package Agent.diagram.edit.parts;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;

/**
 * @generated
 */
public class AgentEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (Agent.diagram.part.AgentVisualIDRegistry.getVisualID(view)) {

			case Agent.diagram.edit.parts.AgentViewpointEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.AgentViewpointEditPart(view);

			case Agent.diagram.edit.parts.RoleEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.RoleEditPart(view);

			case Agent.diagram.edit.parts.RoleNameEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.RoleNameEditPart(view);

			case Agent.diagram.edit.parts.BehaviourEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.BehaviourEditPart(view);

			case Agent.diagram.edit.parts.BehaviourNameEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.BehaviourNameEditPart(view);

			case Agent.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.SemanticWebAgentEditPart(
						view);

			case Agent.diagram.edit.parts.SemanticWebAgentNameEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.SemanticWebAgentNameEditPart(
						view);

			case Agent.diagram.edit.parts.CapabilitiesEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.CapabilitiesEditPart(view);

			case Agent.diagram.edit.parts.CapabilitiesNameEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.CapabilitiesNameEditPart(
						view);

			case Agent.diagram.edit.parts.AgentStateEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.AgentStateEditPart(view);

			case Agent.diagram.edit.parts.AgentStateNameEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.AgentStateNameEditPart(view);

			case Agent.diagram.edit.parts.AgentTypeEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.AgentTypeEditPart(view);

			case Agent.diagram.edit.parts.AgentTypeNameEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.AgentTypeNameEditPart(view);

			case Agent.diagram.edit.parts.BeliefEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.BeliefEditPart(view);

			case Agent.diagram.edit.parts.BeliefNameEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.BeliefNameEditPart(view);

			case Agent.diagram.edit.parts.GoalEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.GoalEditPart(view);

			case Agent.diagram.edit.parts.GoalNameEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.GoalNameEditPart(view);

			case Agent.diagram.edit.parts.PlanEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.PlanEditPart(view);

			case Agent.diagram.edit.parts.PlanNameEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.PlanNameEditPart(view);

			case Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart(
						view);

			case Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart(
						view);

			case Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart(
						view);

			case Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart(
						view);

			case Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart(
						view);

			case Agent.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.SemanticWebAgentPlaysEditPart(
						view);

			case Agent.diagram.edit.parts.WrappingLabelEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.WrappingLabelEditPart(view);

			case Agent.diagram.edit.parts.PlanDispatchesEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.PlanDispatchesEditPart(view);

			case Agent.diagram.edit.parts.WrappingLabel2EditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.WrappingLabel2EditPart(view);

			case Agent.diagram.edit.parts.BehaviourExecutesEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.BehaviourExecutesEditPart(
						view);

			case Agent.diagram.edit.parts.SemanticWebAgentIncludesEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.SemanticWebAgentIncludesEditPart(
						view);

			case Agent.diagram.edit.parts.WrappingLabel3EditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.WrappingLabel3EditPart(view);

			case Agent.diagram.edit.parts.RoleHasEditPart.VISUAL_ID:
				return new Agent.diagram.edit.parts.RoleHasEditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		if (source.getFigure() instanceof WrappingLabel)
			return new TextCellEditorLocator((WrappingLabel) source.getFigure());
		else {
			return new LabelCellEditorLocator((Label) source.getFigure());
		}
	}

	/**
	 * @generated
	 */
	static private class TextCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private WrappingLabel wrapLabel;

		/**
		 * @generated
		 */
		public TextCellEditorLocator(WrappingLabel wrapLabel) {
			this.wrapLabel = wrapLabel;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getWrapLabel() {
			return wrapLabel;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getWrapLabel().getTextBounds().getCopy();
			getWrapLabel().translateToAbsolute(rect);
			if (!text.getFont().isDisposed()) {
				if (getWrapLabel().isTextWrapOn()
						&& getWrapLabel().getText().length() > 0) {
					rect.setSize(new Dimension(text.computeSize(rect.width,
							SWT.DEFAULT)));
				} else {
					int avr = FigureUtilities.getFontMetrics(text.getFont())
							.getAverageCharWidth();
					rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
							SWT.DEFAULT)).expand(avr * 2, 0));
				}
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}

	/**
	 * @generated
	 */
	private static class LabelCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private Label label;

		/**
		 * @generated
		 */
		public LabelCellEditorLocator(Label label) {
			this.label = label;
		}

		/**
		 * @generated
		 */
		public Label getLabel() {
			return label;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getLabel().getTextBounds().getCopy();
			getLabel().translateToAbsolute(rect);
			if (!text.getFont().isDisposed()) {
				int avr = FigureUtilities.getFontMetrics(text.getFont())
						.getAverageCharWidth();
				rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
						SWT.DEFAULT)).expand(avr * 2, 0));
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}
}
