package Agent.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LabeledContainer;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.core.edithelpers.CreateElementRequestAdapter;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CreationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.FlowLayoutEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewAndElementRequest;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class CapabilitiesEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2004;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public CapabilitiesEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		installEditPolicy(EditPolicyRoles.CREATION_ROLE,
				new CreationEditPolicy());
		super.createDefaultEditPolicies();
		installEditPolicy(
				EditPolicyRoles.SEMANTIC_ROLE,
				new Agent.diagram.edit.policies.CapabilitiesItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {

		FlowLayoutEditPolicy lep = new FlowLayoutEditPolicy() {

			protected Command createAddCommand(EditPart child, EditPart after) {
				return null;
			}

			protected Command createMoveChildCommand(EditPart child,
					EditPart after) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new CapabilitiesFigure();
	}

	/**
	 * @generated
	 */
	public CapabilitiesFigure getPrimaryShape() {
		return (CapabilitiesFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof Agent.diagram.edit.parts.CapabilitiesNameEditPart) {
			((Agent.diagram.edit.parts.CapabilitiesNameEditPart) childEditPart)
					.setLabel(getPrimaryShape()
							.getFigureCapabilitiesNameFigure());
			return true;
		}
		if (childEditPart instanceof Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureCapPlanCompartmentFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureCapBeliefCompartmentFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureCapGoalCompartmentFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof Agent.diagram.edit.parts.CapabilitiesNameEditPart) {
			return true;
		}
		if (childEditPart instanceof Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureCapPlanCompartmentFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.remove(((Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureCapBeliefCompartmentFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.remove(((Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureCapGoalCompartmentFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.remove(((Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		if (editPart instanceof Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart) {
			return getPrimaryShape().getFigureCapPlanCompartmentFigure();
		}
		if (editPart instanceof Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart) {
			return getPrimaryShape().getFigureCapBeliefCompartmentFigure();
		}
		if (editPart instanceof Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart) {
			return getPrimaryShape().getFigureCapGoalCompartmentFigure();
		}
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(4, 5);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(Agent.diagram.part.AgentVisualIDRegistry
				.getType(Agent.diagram.edit.parts.CapabilitiesNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(Agent.diagram.providers.AgentElementTypes.SemanticWebAgentIncludes_4005);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == Agent.diagram.providers.AgentElementTypes.SemanticWebAgentIncludes_4005) {
			types.add(Agent.diagram.providers.AgentElementTypes.SemanticWebAgent_2003);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public EditPart getTargetEditPart(Request request) {
		if (request instanceof CreateViewAndElementRequest) {
			CreateElementRequestAdapter adapter = ((CreateViewAndElementRequest) request)
					.getViewAndElementDescriptor()
					.getCreateElementRequestAdapter();
			IElementType type = (IElementType) adapter
					.getAdapter(IElementType.class);
			if (type == Agent.diagram.providers.AgentElementTypes.Plan_3004) {
				return getChildBySemanticHint(Agent.diagram.part.AgentVisualIDRegistry
						.getType(Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart.VISUAL_ID));
			}
			if (type == Agent.diagram.providers.AgentElementTypes.Belief_3002) {
				return getChildBySemanticHint(Agent.diagram.part.AgentVisualIDRegistry
						.getType(Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart.VISUAL_ID));
			}
			if (type == Agent.diagram.providers.AgentElementTypes.Goal_3003) {
				return getChildBySemanticHint(Agent.diagram.part.AgentVisualIDRegistry
						.getType(Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart.VISUAL_ID));
			}
		}
		return super.getTargetEditPart(request);
	}

	/**
	 * @generated
	 */
	public class CapabilitiesFigure extends RectangleFigure {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureCapabilitiesNameFigure;
		/**
		 * @generated
		 */
		private LabeledContainer fFigureCapBeliefCompartmentFigure;
		/**
		 * @generated
		 */
		private LabeledContainer fFigureCapGoalCompartmentFigure;
		/**
		 * @generated
		 */
		private LabeledContainer fFigureCapPlanCompartmentFigure;

		/**
		 * @generated
		 */
		public CapabilitiesFigure() {

			FlowLayout layoutThis = new FlowLayout();
			layoutThis.setStretchMinorAxis(false);
			layoutThis.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutThis.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutThis.setMajorSpacing(5);
			layoutThis.setMinorSpacing(5);
			layoutThis.setHorizontal(true);

			this.setLayoutManager(layoutThis);

			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			fFigureCapabilitiesNameFigure = new WrappingLabel();
			fFigureCapabilitiesNameFigure.setText("<...>");

			this.add(fFigureCapabilitiesNameFigure);

			fFigureCapGoalCompartmentFigure = new LabeledContainer();

			fFigureCapGoalCompartmentFigure
					.setBackgroundColor(FFIGURECAPGOALCOMPARTMENTFIGURE_BACK);
			fFigureCapGoalCompartmentFigure.setBorder(new MarginBorder(
					getMapMode().DPtoLP(5), getMapMode().DPtoLP(4),
					getMapMode().DPtoLP(5), getMapMode().DPtoLP(4)));

			this.add(fFigureCapGoalCompartmentFigure);

			FlowLayout layoutFFigureCapGoalCompartmentFigure = new FlowLayout();
			layoutFFigureCapGoalCompartmentFigure.setStretchMinorAxis(false);
			layoutFFigureCapGoalCompartmentFigure
					.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutFFigureCapGoalCompartmentFigure
					.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutFFigureCapGoalCompartmentFigure.setMajorSpacing(5);
			layoutFFigureCapGoalCompartmentFigure.setMinorSpacing(5);
			layoutFFigureCapGoalCompartmentFigure.setHorizontal(true);

			fFigureCapGoalCompartmentFigure
					.setLayoutManager(layoutFFigureCapGoalCompartmentFigure);

			WrappingLabel capGoalCompartmentName1 = new WrappingLabel();
			capGoalCompartmentName1.setText("<Goals>");
			capGoalCompartmentName1
					.setForegroundColor(CAPGOALCOMPARTMENTNAME1_FORE);

			fFigureCapGoalCompartmentFigure.add(capGoalCompartmentName1);

			fFigureCapBeliefCompartmentFigure = new LabeledContainer();

			fFigureCapBeliefCompartmentFigure
					.setBackgroundColor(FFIGURECAPBELIEFCOMPARTMENTFIGURE_BACK);
			fFigureCapBeliefCompartmentFigure.setBorder(new MarginBorder(
					getMapMode().DPtoLP(5), getMapMode().DPtoLP(4),
					getMapMode().DPtoLP(5), getMapMode().DPtoLP(4)));

			this.add(fFigureCapBeliefCompartmentFigure);

			FlowLayout layoutFFigureCapBeliefCompartmentFigure = new FlowLayout();
			layoutFFigureCapBeliefCompartmentFigure.setStretchMinorAxis(false);
			layoutFFigureCapBeliefCompartmentFigure
					.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutFFigureCapBeliefCompartmentFigure
					.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutFFigureCapBeliefCompartmentFigure.setMajorSpacing(5);
			layoutFFigureCapBeliefCompartmentFigure.setMinorSpacing(5);
			layoutFFigureCapBeliefCompartmentFigure.setHorizontal(true);

			fFigureCapBeliefCompartmentFigure
					.setLayoutManager(layoutFFigureCapBeliefCompartmentFigure);

			WrappingLabel capBeliefCompartmentName1 = new WrappingLabel();
			capBeliefCompartmentName1.setText("<Beliefs>");
			capBeliefCompartmentName1
					.setForegroundColor(CAPBELIEFCOMPARTMENTNAME1_FORE);

			fFigureCapBeliefCompartmentFigure.add(capBeliefCompartmentName1);

			fFigureCapPlanCompartmentFigure = new LabeledContainer();

			fFigureCapPlanCompartmentFigure
					.setBackgroundColor(FFIGURECAPPLANCOMPARTMENTFIGURE_BACK);
			fFigureCapPlanCompartmentFigure.setBorder(new MarginBorder(
					getMapMode().DPtoLP(5), getMapMode().DPtoLP(4),
					getMapMode().DPtoLP(5), getMapMode().DPtoLP(4)));

			this.add(fFigureCapPlanCompartmentFigure);

			FlowLayout layoutFFigureCapPlanCompartmentFigure = new FlowLayout();
			layoutFFigureCapPlanCompartmentFigure.setStretchMinorAxis(false);
			layoutFFigureCapPlanCompartmentFigure
					.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutFFigureCapPlanCompartmentFigure
					.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutFFigureCapPlanCompartmentFigure.setMajorSpacing(5);
			layoutFFigureCapPlanCompartmentFigure.setMinorSpacing(5);
			layoutFFigureCapPlanCompartmentFigure.setHorizontal(true);

			fFigureCapPlanCompartmentFigure
					.setLayoutManager(layoutFFigureCapPlanCompartmentFigure);

			WrappingLabel capPlanCompartmentName1 = new WrappingLabel();
			capPlanCompartmentName1.setText("<Plans>");
			capPlanCompartmentName1
					.setForegroundColor(CAPPLANCOMPARTMENTNAME1_FORE);

			fFigureCapPlanCompartmentFigure.add(capPlanCompartmentName1);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureCapabilitiesNameFigure() {
			return fFigureCapabilitiesNameFigure;
		}

		/**
		 * @generated
		 */
		public LabeledContainer getFigureCapBeliefCompartmentFigure() {
			return fFigureCapBeliefCompartmentFigure;
		}

		/**
		 * @generated
		 */
		public LabeledContainer getFigureCapGoalCompartmentFigure() {
			return fFigureCapGoalCompartmentFigure;
		}

		/**
		 * @generated
		 */
		public LabeledContainer getFigureCapPlanCompartmentFigure() {
			return fFigureCapPlanCompartmentFigure;
		}

	}

	/**
	 * @generated
	 */
	static final Color FFIGURECAPGOALCOMPARTMENTFIGURE_BACK = new Color(null,
			180, 180, 180);

	/**
	 * @generated
	 */
	static final Color CAPGOALCOMPARTMENTNAME1_FORE = new Color(null, 0, 0, 0);

	/**
	 * @generated
	 */
	static final Color FFIGURECAPBELIEFCOMPARTMENTFIGURE_BACK = new Color(null,
			180, 180, 180);

	/**
	 * @generated
	 */
	static final Color CAPBELIEFCOMPARTMENTNAME1_FORE = new Color(null, 0, 0, 0);

	/**
	 * @generated
	 */
	static final Color FFIGURECAPPLANCOMPARTMENTFIGURE_BACK = new Color(null,
			180, 180, 180);

	/**
	 * @generated
	 */
	static final Color CAPPLANCOMPARTMENTNAME1_FORE = new Color(null, 0, 0, 0);

}
