package Agent.diagram.navigator;

import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

/**
 * @generated
 */
public class AgentNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		Agent.diagram.part.AgentDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		Agent.diagram.part.AgentDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof Agent.diagram.navigator.AgentNavigatorItem
				&& !isOwnView(((Agent.diagram.navigator.AgentNavigatorItem) element)
						.getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof Agent.diagram.navigator.AgentNavigatorGroup) {
			Agent.diagram.navigator.AgentNavigatorGroup group = (Agent.diagram.navigator.AgentNavigatorGroup) element;
			return Agent.diagram.part.AgentDiagramEditorPlugin.getInstance()
					.getBundledImage(group.getIcon());
		}

		if (element instanceof Agent.diagram.navigator.AgentNavigatorItem) {
			Agent.diagram.navigator.AgentNavigatorItem navigatorItem = (Agent.diagram.navigator.AgentNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (Agent.diagram.part.AgentVisualIDRegistry.getVisualID(view)) {
		case Agent.diagram.edit.parts.AgentTypeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/MyTest/model/Agent.ecore?AgentType", Agent.diagram.providers.AgentElementTypes.AgentType_3009); //$NON-NLS-1$
		case Agent.diagram.edit.parts.AgentStateEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/MyTest/model/Agent.ecore?AgentState", Agent.diagram.providers.AgentElementTypes.AgentState_3008); //$NON-NLS-1$
		case Agent.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/MyTest/model/Agent.ecore?SemanticWebAgent?plays", Agent.diagram.providers.AgentElementTypes.SemanticWebAgentPlays_4001); //$NON-NLS-1$
		case Agent.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Agent.ecore?SemanticWebAgent", Agent.diagram.providers.AgentElementTypes.SemanticWebAgent_2003); //$NON-NLS-1$
		case Agent.diagram.edit.parts.BeliefEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/MyTest/model/Agent.ecore?Belief", Agent.diagram.providers.AgentElementTypes.Belief_3002); //$NON-NLS-1$
		case Agent.diagram.edit.parts.BehaviourExecutesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/MyTest/model/Agent.ecore?Behaviour?executes", Agent.diagram.providers.AgentElementTypes.BehaviourExecutes_4007); //$NON-NLS-1$
		case Agent.diagram.edit.parts.GoalEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/MyTest/model/Agent.ecore?Goal", Agent.diagram.providers.AgentElementTypes.Goal_3003); //$NON-NLS-1$
		case Agent.diagram.edit.parts.SemanticWebAgentIncludesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/MyTest/model/Agent.ecore?SemanticWebAgent?includes", Agent.diagram.providers.AgentElementTypes.SemanticWebAgentIncludes_4005); //$NON-NLS-1$
		case Agent.diagram.edit.parts.BehaviourEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Agent.ecore?Behaviour", Agent.diagram.providers.AgentElementTypes.Behaviour_2002); //$NON-NLS-1$
		case Agent.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Agent.ecore?Role", Agent.diagram.providers.AgentElementTypes.Role_2001); //$NON-NLS-1$
		case Agent.diagram.edit.parts.PlanDispatchesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/MyTest/model/Agent.ecore?Plan?dispatches", Agent.diagram.providers.AgentElementTypes.PlanDispatches_4002); //$NON-NLS-1$
		case Agent.diagram.edit.parts.PlanEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/MyTest/model/Agent.ecore?Plan", Agent.diagram.providers.AgentElementTypes.Plan_3004); //$NON-NLS-1$
		case Agent.diagram.edit.parts.CapabilitiesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Agent.ecore?Capabilities", Agent.diagram.providers.AgentElementTypes.Capabilities_2004); //$NON-NLS-1$
		case Agent.diagram.edit.parts.RoleHasEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/MyTest/model/Agent.ecore?Role?has", Agent.diagram.providers.AgentElementTypes.RoleHas_4006); //$NON-NLS-1$
		case Agent.diagram.edit.parts.AgentViewpointEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?/MyTest/model/Agent.ecore?AgentViewpoint", Agent.diagram.providers.AgentElementTypes.AgentViewpoint_1000); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = Agent.diagram.part.AgentDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null
				&& elementType != null
				&& Agent.diagram.providers.AgentElementTypes
						.isKnownElementType(elementType)) {
			image = Agent.diagram.providers.AgentElementTypes
					.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof Agent.diagram.navigator.AgentNavigatorGroup) {
			Agent.diagram.navigator.AgentNavigatorGroup group = (Agent.diagram.navigator.AgentNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof Agent.diagram.navigator.AgentNavigatorItem) {
			Agent.diagram.navigator.AgentNavigatorItem navigatorItem = (Agent.diagram.navigator.AgentNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (Agent.diagram.part.AgentVisualIDRegistry.getVisualID(view)) {
		case Agent.diagram.edit.parts.AgentTypeEditPart.VISUAL_ID:
			return getAgentType_3009Text(view);
		case Agent.diagram.edit.parts.AgentStateEditPart.VISUAL_ID:
			return getAgentState_3008Text(view);
		case Agent.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID:
			return getSemanticWebAgentPlays_4001Text(view);
		case Agent.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID:
			return getSemanticWebAgent_2003Text(view);
		case Agent.diagram.edit.parts.BeliefEditPart.VISUAL_ID:
			return getBelief_3002Text(view);
		case Agent.diagram.edit.parts.BehaviourExecutesEditPart.VISUAL_ID:
			return getBehaviourExecutes_4007Text(view);
		case Agent.diagram.edit.parts.GoalEditPart.VISUAL_ID:
			return getGoal_3003Text(view);
		case Agent.diagram.edit.parts.SemanticWebAgentIncludesEditPart.VISUAL_ID:
			return getSemanticWebAgentIncludes_4005Text(view);
		case Agent.diagram.edit.parts.BehaviourEditPart.VISUAL_ID:
			return getBehaviour_2002Text(view);
		case Agent.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			return getRole_2001Text(view);
		case Agent.diagram.edit.parts.PlanDispatchesEditPart.VISUAL_ID:
			return getPlanDispatches_4002Text(view);
		case Agent.diagram.edit.parts.PlanEditPart.VISUAL_ID:
			return getPlan_3004Text(view);
		case Agent.diagram.edit.parts.CapabilitiesEditPart.VISUAL_ID:
			return getCapabilities_2004Text(view);
		case Agent.diagram.edit.parts.RoleHasEditPart.VISUAL_ID:
			return getRoleHas_4006Text(view);
		case Agent.diagram.edit.parts.AgentViewpointEditPart.VISUAL_ID:
			return getAgentViewpoint_1000Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getAgentType_3009Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.AgentType_3009,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.AgentTypeNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5017); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getAgentState_3008Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.AgentState_3008,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.AgentStateNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5016); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSemanticWebAgentPlays_4001Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.SemanticWebAgentPlays_4001,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.WrappingLabelEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSemanticWebAgent_2003Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.SemanticWebAgent_2003,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.SemanticWebAgentNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5009); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getBelief_3002Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.Belief_3002,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.BeliefNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getBehaviourExecutes_4007Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getGoal_3003Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.Goal_3003,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.GoalNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSemanticWebAgentIncludes_4005Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.SemanticWebAgentIncludes_4005,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.WrappingLabel3EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getBehaviour_2002Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.Behaviour_2002,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.BehaviourNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRole_2001Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.Role_2001,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.RoleNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getPlanDispatches_4002Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.PlanDispatches_4002,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.WrappingLabel2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getPlan_3004Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.Plan_3004,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.PlanNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getCapabilities_2004Text(View view) {
		IParser parser = Agent.diagram.providers.AgentParserProvider
				.getParser(
						Agent.diagram.providers.AgentElementTypes.Capabilities_2004,
						view.getElement() != null ? view.getElement() : view,
						Agent.diagram.part.AgentVisualIDRegistry
								.getType(Agent.diagram.edit.parts.CapabilitiesNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Agent.diagram.part.AgentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5015); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRoleHas_4006Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getAgentViewpoint_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return Agent.diagram.edit.parts.AgentViewpointEditPart.MODEL_ID
				.equals(Agent.diagram.part.AgentVisualIDRegistry
						.getModelID(view));
	}

}
