package Agent.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class AgentVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "AgentViewpoint.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (Agent.diagram.edit.parts.AgentViewpointEditPart.MODEL_ID
					.equals(view.getType())) {
				return Agent.diagram.edit.parts.AgentViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return Agent.diagram.part.AgentVisualIDRegistry.getVisualID(view
				.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				Agent.diagram.part.AgentDiagramEditorPlugin.getInstance()
						.logError(
								"Unable to parse view type as a visualID number: "
										+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (Agent.AgentPackage.eINSTANCE.getAgentViewpoint().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((Agent.AgentViewpoint) domainElement)) {
			return Agent.diagram.edit.parts.AgentViewpointEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = Agent.diagram.part.AgentVisualIDRegistry
				.getModelID(containerView);
		if (!Agent.diagram.edit.parts.AgentViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (Agent.diagram.edit.parts.AgentViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = Agent.diagram.part.AgentVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = Agent.diagram.edit.parts.AgentViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case Agent.diagram.edit.parts.AgentViewpointEditPart.VISUAL_ID:
			if (Agent.AgentPackage.eINSTANCE.getRole().isSuperTypeOf(
					domainElement.eClass())) {
				return Agent.diagram.edit.parts.RoleEditPart.VISUAL_ID;
			}
			if (Agent.AgentPackage.eINSTANCE.getBehaviour().isSuperTypeOf(
					domainElement.eClass())) {
				return Agent.diagram.edit.parts.BehaviourEditPart.VISUAL_ID;
			}
			if (Agent.AgentPackage.eINSTANCE.getSemanticWebAgent()
					.isSuperTypeOf(domainElement.eClass())) {
				return Agent.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID;
			}
			if (Agent.AgentPackage.eINSTANCE.getCapabilities().isSuperTypeOf(
					domainElement.eClass())) {
				return Agent.diagram.edit.parts.CapabilitiesEditPart.VISUAL_ID;
			}
			break;
		case Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart.VISUAL_ID:
			if (Agent.AgentPackage.eINSTANCE.getAgentType().isSuperTypeOf(
					domainElement.eClass())) {
				return Agent.diagram.edit.parts.AgentTypeEditPart.VISUAL_ID;
			}
			break;
		case Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart.VISUAL_ID:
			if (Agent.AgentPackage.eINSTANCE.getAgentState().isSuperTypeOf(
					domainElement.eClass())) {
				return Agent.diagram.edit.parts.AgentStateEditPart.VISUAL_ID;
			}
			break;
		case Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart.VISUAL_ID:
			if (Agent.AgentPackage.eINSTANCE.getPlan().isSuperTypeOf(
					domainElement.eClass())) {
				return Agent.diagram.edit.parts.PlanEditPart.VISUAL_ID;
			}
			break;
		case Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart.VISUAL_ID:
			if (Agent.AgentPackage.eINSTANCE.getBelief().isSuperTypeOf(
					domainElement.eClass())) {
				return Agent.diagram.edit.parts.BeliefEditPart.VISUAL_ID;
			}
			break;
		case Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart.VISUAL_ID:
			if (Agent.AgentPackage.eINSTANCE.getGoal().isSuperTypeOf(
					domainElement.eClass())) {
				return Agent.diagram.edit.parts.GoalEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = Agent.diagram.part.AgentVisualIDRegistry
				.getModelID(containerView);
		if (!Agent.diagram.edit.parts.AgentViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (Agent.diagram.edit.parts.AgentViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = Agent.diagram.part.AgentVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = Agent.diagram.edit.parts.AgentViewpointEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case Agent.diagram.edit.parts.AgentViewpointEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.RoleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Agent.diagram.edit.parts.BehaviourEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Agent.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Agent.diagram.edit.parts.CapabilitiesEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.RoleNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.BehaviourEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.BehaviourNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.SemanticWebAgentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.CapabilitiesEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.CapabilitiesNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.AgentStateEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.AgentStateNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.AgentTypeEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.AgentTypeNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.BeliefEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.BeliefNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.GoalEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.GoalNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.PlanEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.PlanNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.AgentTypeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.AgentStateEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.PlanEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.BeliefEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.GoalEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.WrappingLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.PlanDispatchesEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.WrappingLabel2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Agent.diagram.edit.parts.SemanticWebAgentIncludesEditPart.VISUAL_ID:
			if (Agent.diagram.edit.parts.WrappingLabel3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(Agent.AgentViewpoint element) {
		return true;
	}

}
