/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package Agent.provider;


import Agent.AgentFactory;
import Agent.AgentPackage;
import Agent.AgentViewpoint;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link Agent.AgentViewpoint} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class AgentViewpointItemProvider
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AgentViewpointItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addContainsBeliefPropertyDescriptor(object);
			addContainsGoalPropertyDescriptor(object);
			addContainsPlanPropertyDescriptor(object);
			addContainsMatchmakerAgentPropertyDescriptor(object);
			addContainsAgentStatePropertyDescriptor(object);
			addContainsAgentTypePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Contains Belief feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addContainsBeliefPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_AgentViewpoint_containsBelief_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_AgentViewpoint_containsBelief_feature", "_UI_AgentViewpoint_type"),
				 AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_BELIEF,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Contains Goal feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addContainsGoalPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_AgentViewpoint_containsGoal_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_AgentViewpoint_containsGoal_feature", "_UI_AgentViewpoint_type"),
				 AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_GOAL,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Contains Plan feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addContainsPlanPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_AgentViewpoint_containsPlan_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_AgentViewpoint_containsPlan_feature", "_UI_AgentViewpoint_type"),
				 AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_PLAN,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Contains Matchmaker Agent feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addContainsMatchmakerAgentPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_AgentViewpoint_containsMatchmakerAgent_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_AgentViewpoint_containsMatchmakerAgent_feature", "_UI_AgentViewpoint_type"),
				 AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_MATCHMAKER_AGENT,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Contains Agent State feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addContainsAgentStatePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_AgentViewpoint_containsAgentState_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_AgentViewpoint_containsAgentState_feature", "_UI_AgentViewpoint_type"),
				 AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_AGENT_STATE,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Contains Agent Type feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addContainsAgentTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_AgentViewpoint_containsAgentType_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_AgentViewpoint_containsAgentType_feature", "_UI_AgentViewpoint_type"),
				 AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_AGENT_TYPE,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_ROLE);
			childrenFeatures.add(AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_SWA);
			childrenFeatures.add(AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_BEHAVIOUR);
			childrenFeatures.add(AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_CAPABILITIES);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns AgentViewpoint.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/AgentViewpoint"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		return getString("_UI_AgentViewpoint_type");
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(AgentViewpoint.class)) {
			case AgentPackage.AGENT_VIEWPOINT__CONTAINS_ROLE:
			case AgentPackage.AGENT_VIEWPOINT__CONTAINS_SWA:
			case AgentPackage.AGENT_VIEWPOINT__CONTAINS_BEHAVIOUR:
			case AgentPackage.AGENT_VIEWPOINT__CONTAINS_CAPABILITIES:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_ROLE,
				 AgentFactory.eINSTANCE.createRole()));

		newChildDescriptors.add
			(createChildParameter
				(AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_SWA,
				 AgentFactory.eINSTANCE.createSemanticWebAgent()));

		newChildDescriptors.add
			(createChildParameter
				(AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_SWA,
				 AgentFactory.eINSTANCE.createSWSMatchmakerAgent()));

		newChildDescriptors.add
			(createChildParameter
				(AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_BEHAVIOUR,
				 AgentFactory.eINSTANCE.createBehaviour()));

		newChildDescriptors.add
			(createChildParameter
				(AgentPackage.Literals.AGENT_VIEWPOINT__CONTAINS_CAPABILITIES,
				 AgentFactory.eINSTANCE.createCapabilities()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return AgentEditPlugin.INSTANCE;
	}

}
