/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package Agent;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see Agent.AgentFactory
 * @model kind="package"
 * @generated
 */
public interface AgentPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "Agent";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "/MyTest/model/Agent.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "jfb.examples.gmf.Agent";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	AgentPackage eINSTANCE = Agent.impl.AgentPackageImpl.init();

	/**
	 * The meta object id for the '{@link Agent.impl.BeliefImpl <em>Belief</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see Agent.impl.BeliefImpl
	 * @see Agent.impl.AgentPackageImpl#getBelief()
	 * @generated
	 */
	int BELIEF = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BELIEF__DESCRIPTION = 0;

	/**
	 * The feature id for the '<em><b>Dynamic</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BELIEF__DYNAMIC = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BELIEF__NAME = 2;

	/**
	 * The number of structural features of the '<em>Belief</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BELIEF_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link Agent.impl.GoalImpl <em>Goal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see Agent.impl.GoalImpl
	 * @see Agent.impl.AgentPackageImpl#getGoal()
	 * @generated
	 */
	int GOAL = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOAL__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOAL__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Recur</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOAL__RECUR = 2;

	/**
	 * The number of structural features of the '<em>Goal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GOAL_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link Agent.impl.CapabilitiesImpl <em>Capabilities</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see Agent.impl.CapabilitiesImpl
	 * @see Agent.impl.AgentPackageImpl#getCapabilities()
	 * @generated
	 */
	int CAPABILITIES = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAPABILITIES__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAPABILITIES__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Uses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAPABILITIES__USES = 2;

	/**
	 * The feature id for the '<em><b>Applies</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAPABILITIES__APPLIES = 3;

	/**
	 * The feature id for the '<em><b>Includes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAPABILITIES__INCLUDES = 4;

	/**
	 * The number of structural features of the '<em>Capabilities</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAPABILITIES_FEATURE_COUNT = 5;

	/**
	 * The meta object id for the '{@link Agent.impl.PlanImpl <em>Plan</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see Agent.impl.PlanImpl
	 * @see Agent.impl.AgentPackageImpl#getPlan()
	 * @generated
	 */
	int PLAN = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PLAN__NAME = 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PLAN__TYPE = 1;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PLAN__DESCRIPTION = 2;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PLAN__PRIORITY = 3;

	/**
	 * The feature id for the '<em><b>Dispatches</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PLAN__DISPATCHES = 4;

	/**
	 * The number of structural features of the '<em>Plan</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PLAN_FEATURE_COUNT = 5;

	/**
	 * The meta object id for the '{@link Agent.impl.BehaviourImpl <em>Behaviour</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see Agent.impl.BehaviourImpl
	 * @see Agent.impl.AgentPackageImpl#getBehaviour()
	 * @generated
	 */
	int BEHAVIOUR = 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIOUR__NAME = 0;

	/**
	 * The feature id for the '<em><b>Resident</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIOUR__RESIDENT = 1;

	/**
	 * The feature id for the '<em><b>Composed of</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIOUR__COMPOSED_OF = 2;

	/**
	 * The feature id for the '<em><b>Executes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIOUR__EXECUTES = 3;

	/**
	 * The number of structural features of the '<em>Behaviour</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIOUR_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link Agent.impl.SemanticWebAgentImpl <em>Semantic Web Agent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see Agent.impl.SemanticWebAgentImpl
	 * @see Agent.impl.AgentPackageImpl#getSemanticWebAgent()
	 * @generated
	 */
	int SEMANTIC_WEB_AGENT = 5;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMANTIC_WEB_AGENT__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMANTIC_WEB_AGENT__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMANTIC_WEB_AGENT__PROPERTIES = 2;

	/**
	 * The feature id for the '<em><b>Includes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMANTIC_WEB_AGENT__INCLUDES = 3;

	/**
	 * The feature id for the '<em><b>Plays</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMANTIC_WEB_AGENT__PLAYS = 4;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMANTIC_WEB_AGENT__CONTAINS = 5;

	/**
	 * The feature id for the '<em><b>Has</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMANTIC_WEB_AGENT__HAS = 6;

	/**
	 * The number of structural features of the '<em>Semantic Web Agent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMANTIC_WEB_AGENT_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link Agent.impl.SWSMatchmakerAgentImpl <em>SWS Matchmaker Agent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see Agent.impl.SWSMatchmakerAgentImpl
	 * @see Agent.impl.AgentPackageImpl#getSWSMatchmakerAgent()
	 * @generated
	 */
	int SWS_MATCHMAKER_AGENT = 6;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWS_MATCHMAKER_AGENT__NAME = SEMANTIC_WEB_AGENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWS_MATCHMAKER_AGENT__DESCRIPTION = SEMANTIC_WEB_AGENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWS_MATCHMAKER_AGENT__PROPERTIES = SEMANTIC_WEB_AGENT__PROPERTIES;

	/**
	 * The feature id for the '<em><b>Includes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWS_MATCHMAKER_AGENT__INCLUDES = SEMANTIC_WEB_AGENT__INCLUDES;

	/**
	 * The feature id for the '<em><b>Plays</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWS_MATCHMAKER_AGENT__PLAYS = SEMANTIC_WEB_AGENT__PLAYS;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWS_MATCHMAKER_AGENT__CONTAINS = SEMANTIC_WEB_AGENT__CONTAINS;

	/**
	 * The feature id for the '<em><b>Has</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWS_MATCHMAKER_AGENT__HAS = SEMANTIC_WEB_AGENT__HAS;

	/**
	 * The number of structural features of the '<em>SWS Matchmaker Agent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWS_MATCHMAKER_AGENT_FEATURE_COUNT = SEMANTIC_WEB_AGENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link Agent.impl.AgentStateImpl <em>State</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see Agent.impl.AgentStateImpl
	 * @see Agent.impl.AgentPackageImpl#getAgentState()
	 * @generated
	 */
	int AGENT_STATE = 7;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_STATE__NAME = 0;

	/**
	 * The number of structural features of the '<em>State</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_STATE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link Agent.impl.RoleImpl <em>Role</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see Agent.impl.RoleImpl
	 * @see Agent.impl.AgentPackageImpl#getRole()
	 * @generated
	 */
	int ROLE = 8;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE__NAME = 0;

	/**
	 * The feature id for the '<em><b>Has</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE__HAS = 1;

	/**
	 * The number of structural features of the '<em>Role</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link Agent.impl.AgentTypeImpl <em>Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see Agent.impl.AgentTypeImpl
	 * @see Agent.impl.AgentPackageImpl#getAgentType()
	 * @generated
	 */
	int AGENT_TYPE = 9;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_TYPE__NAME = 0;

	/**
	 * The number of structural features of the '<em>Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link Agent.impl.AgentViewpointImpl <em>Viewpoint</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see Agent.impl.AgentViewpointImpl
	 * @see Agent.impl.AgentPackageImpl#getAgentViewpoint()
	 * @generated
	 */
	int AGENT_VIEWPOINT = 10;

	/**
	 * The feature id for the '<em><b>Contains Role</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_VIEWPOINT__CONTAINS_ROLE = 0;

	/**
	 * The feature id for the '<em><b>Contains SWA</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_VIEWPOINT__CONTAINS_SWA = 1;

	/**
	 * The feature id for the '<em><b>Contains Behaviour</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_VIEWPOINT__CONTAINS_BEHAVIOUR = 2;

	/**
	 * The feature id for the '<em><b>Contains Capabilities</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_VIEWPOINT__CONTAINS_CAPABILITIES = 3;

	/**
	 * The feature id for the '<em><b>Contains Belief</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_VIEWPOINT__CONTAINS_BELIEF = 4;

	/**
	 * The feature id for the '<em><b>Contains Goal</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_VIEWPOINT__CONTAINS_GOAL = 5;

	/**
	 * The feature id for the '<em><b>Contains Plan</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_VIEWPOINT__CONTAINS_PLAN = 6;

	/**
	 * The feature id for the '<em><b>Contains Matchmaker Agent</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_VIEWPOINT__CONTAINS_MATCHMAKER_AGENT = 7;

	/**
	 * The feature id for the '<em><b>Contains Agent State</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_VIEWPOINT__CONTAINS_AGENT_STATE = 8;

	/**
	 * The feature id for the '<em><b>Contains Agent Type</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_VIEWPOINT__CONTAINS_AGENT_TYPE = 9;

	/**
	 * The number of structural features of the '<em>Viewpoint</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGENT_VIEWPOINT_FEATURE_COUNT = 10;


	/**
	 * Returns the meta object for class '{@link Agent.Belief <em>Belief</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Belief</em>'.
	 * @see Agent.Belief
	 * @generated
	 */
	EClass getBelief();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Belief#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see Agent.Belief#getDescription()
	 * @see #getBelief()
	 * @generated
	 */
	EAttribute getBelief_Description();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Belief#isDynamic <em>Dynamic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dynamic</em>'.
	 * @see Agent.Belief#isDynamic()
	 * @see #getBelief()
	 * @generated
	 */
	EAttribute getBelief_Dynamic();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Belief#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see Agent.Belief#getName()
	 * @see #getBelief()
	 * @generated
	 */
	EAttribute getBelief_Name();

	/**
	 * Returns the meta object for class '{@link Agent.Goal <em>Goal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Goal</em>'.
	 * @see Agent.Goal
	 * @generated
	 */
	EClass getGoal();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Goal#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see Agent.Goal#getName()
	 * @see #getGoal()
	 * @generated
	 */
	EAttribute getGoal_Name();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Goal#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see Agent.Goal#getDescription()
	 * @see #getGoal()
	 * @generated
	 */
	EAttribute getGoal_Description();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Goal#isRecur <em>Recur</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Recur</em>'.
	 * @see Agent.Goal#isRecur()
	 * @see #getGoal()
	 * @generated
	 */
	EAttribute getGoal_Recur();

	/**
	 * Returns the meta object for class '{@link Agent.Capabilities <em>Capabilities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Capabilities</em>'.
	 * @see Agent.Capabilities
	 * @generated
	 */
	EClass getCapabilities();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Capabilities#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see Agent.Capabilities#getName()
	 * @see #getCapabilities()
	 * @generated
	 */
	EAttribute getCapabilities_Name();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Capabilities#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see Agent.Capabilities#getDescription()
	 * @see #getCapabilities()
	 * @generated
	 */
	EAttribute getCapabilities_Description();

	/**
	 * Returns the meta object for the containment reference list '{@link Agent.Capabilities#getUses <em>Uses</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Uses</em>'.
	 * @see Agent.Capabilities#getUses()
	 * @see #getCapabilities()
	 * @generated
	 */
	EReference getCapabilities_Uses();

	/**
	 * Returns the meta object for the containment reference list '{@link Agent.Capabilities#getApplies <em>Applies</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Applies</em>'.
	 * @see Agent.Capabilities#getApplies()
	 * @see #getCapabilities()
	 * @generated
	 */
	EReference getCapabilities_Applies();

	/**
	 * Returns the meta object for the containment reference list '{@link Agent.Capabilities#getIncludes <em>Includes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Includes</em>'.
	 * @see Agent.Capabilities#getIncludes()
	 * @see #getCapabilities()
	 * @generated
	 */
	EReference getCapabilities_Includes();

	/**
	 * Returns the meta object for class '{@link Agent.Plan <em>Plan</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Plan</em>'.
	 * @see Agent.Plan
	 * @generated
	 */
	EClass getPlan();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Plan#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see Agent.Plan#getName()
	 * @see #getPlan()
	 * @generated
	 */
	EAttribute getPlan_Name();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Plan#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see Agent.Plan#getType()
	 * @see #getPlan()
	 * @generated
	 */
	EAttribute getPlan_Type();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Plan#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see Agent.Plan#getDescription()
	 * @see #getPlan()
	 * @generated
	 */
	EAttribute getPlan_Description();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Plan#getPriority <em>Priority</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Priority</em>'.
	 * @see Agent.Plan#getPriority()
	 * @see #getPlan()
	 * @generated
	 */
	EAttribute getPlan_Priority();

	/**
	 * Returns the meta object for the reference list '{@link Agent.Plan#getDispatches <em>Dispatches</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Dispatches</em>'.
	 * @see Agent.Plan#getDispatches()
	 * @see #getPlan()
	 * @generated
	 */
	EReference getPlan_Dispatches();

	/**
	 * Returns the meta object for class '{@link Agent.Behaviour <em>Behaviour</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Behaviour</em>'.
	 * @see Agent.Behaviour
	 * @generated
	 */
	EClass getBehaviour();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Behaviour#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see Agent.Behaviour#getName()
	 * @see #getBehaviour()
	 * @generated
	 */
	EAttribute getBehaviour_Name();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Behaviour#getResident <em>Resident</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Resident</em>'.
	 * @see Agent.Behaviour#getResident()
	 * @see #getBehaviour()
	 * @generated
	 */
	EAttribute getBehaviour_Resident();

	/**
	 * Returns the meta object for the containment reference list '{@link Agent.Behaviour#getComposed_of <em>Composed of</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Composed of</em>'.
	 * @see Agent.Behaviour#getComposed_of()
	 * @see #getBehaviour()
	 * @generated
	 */
	EReference getBehaviour_Composed_of();

	/**
	 * Returns the meta object for the reference list '{@link Agent.Behaviour#getExecutes <em>Executes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Executes</em>'.
	 * @see Agent.Behaviour#getExecutes()
	 * @see #getBehaviour()
	 * @generated
	 */
	EReference getBehaviour_Executes();

	/**
	 * Returns the meta object for class '{@link Agent.SemanticWebAgent <em>Semantic Web Agent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Semantic Web Agent</em>'.
	 * @see Agent.SemanticWebAgent
	 * @generated
	 */
	EClass getSemanticWebAgent();

	/**
	 * Returns the meta object for the attribute '{@link Agent.SemanticWebAgent#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see Agent.SemanticWebAgent#getName()
	 * @see #getSemanticWebAgent()
	 * @generated
	 */
	EAttribute getSemanticWebAgent_Name();

	/**
	 * Returns the meta object for the attribute '{@link Agent.SemanticWebAgent#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see Agent.SemanticWebAgent#getDescription()
	 * @see #getSemanticWebAgent()
	 * @generated
	 */
	EAttribute getSemanticWebAgent_Description();

	/**
	 * Returns the meta object for the attribute '{@link Agent.SemanticWebAgent#getProperties <em>Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Properties</em>'.
	 * @see Agent.SemanticWebAgent#getProperties()
	 * @see #getSemanticWebAgent()
	 * @generated
	 */
	EAttribute getSemanticWebAgent_Properties();

	/**
	 * Returns the meta object for the reference list '{@link Agent.SemanticWebAgent#getIncludes <em>Includes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Includes</em>'.
	 * @see Agent.SemanticWebAgent#getIncludes()
	 * @see #getSemanticWebAgent()
	 * @generated
	 */
	EReference getSemanticWebAgent_Includes();

	/**
	 * Returns the meta object for the reference list '{@link Agent.SemanticWebAgent#getPlays <em>Plays</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Plays</em>'.
	 * @see Agent.SemanticWebAgent#getPlays()
	 * @see #getSemanticWebAgent()
	 * @generated
	 */
	EReference getSemanticWebAgent_Plays();

	/**
	 * Returns the meta object for the containment reference list '{@link Agent.SemanticWebAgent#getContains <em>Contains</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contains</em>'.
	 * @see Agent.SemanticWebAgent#getContains()
	 * @see #getSemanticWebAgent()
	 * @generated
	 */
	EReference getSemanticWebAgent_Contains();

	/**
	 * Returns the meta object for the containment reference '{@link Agent.SemanticWebAgent#getHas <em>Has</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Has</em>'.
	 * @see Agent.SemanticWebAgent#getHas()
	 * @see #getSemanticWebAgent()
	 * @generated
	 */
	EReference getSemanticWebAgent_Has();

	/**
	 * Returns the meta object for class '{@link Agent.SWSMatchmakerAgent <em>SWS Matchmaker Agent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SWS Matchmaker Agent</em>'.
	 * @see Agent.SWSMatchmakerAgent
	 * @generated
	 */
	EClass getSWSMatchmakerAgent();

	/**
	 * Returns the meta object for class '{@link Agent.AgentState <em>State</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>State</em>'.
	 * @see Agent.AgentState
	 * @generated
	 */
	EClass getAgentState();

	/**
	 * Returns the meta object for the attribute '{@link Agent.AgentState#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see Agent.AgentState#getName()
	 * @see #getAgentState()
	 * @generated
	 */
	EAttribute getAgentState_Name();

	/**
	 * Returns the meta object for class '{@link Agent.Role <em>Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Role</em>'.
	 * @see Agent.Role
	 * @generated
	 */
	EClass getRole();

	/**
	 * Returns the meta object for the attribute '{@link Agent.Role#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see Agent.Role#getName()
	 * @see #getRole()
	 * @generated
	 */
	EAttribute getRole_Name();

	/**
	 * Returns the meta object for the reference list '{@link Agent.Role#getHas <em>Has</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Has</em>'.
	 * @see Agent.Role#getHas()
	 * @see #getRole()
	 * @generated
	 */
	EReference getRole_Has();

	/**
	 * Returns the meta object for class '{@link Agent.AgentType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type</em>'.
	 * @see Agent.AgentType
	 * @generated
	 */
	EClass getAgentType();

	/**
	 * Returns the meta object for the attribute '{@link Agent.AgentType#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see Agent.AgentType#getName()
	 * @see #getAgentType()
	 * @generated
	 */
	EAttribute getAgentType_Name();

	/**
	 * Returns the meta object for class '{@link Agent.AgentViewpoint <em>Viewpoint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Viewpoint</em>'.
	 * @see Agent.AgentViewpoint
	 * @generated
	 */
	EClass getAgentViewpoint();

	/**
	 * Returns the meta object for the containment reference list '{@link Agent.AgentViewpoint#getContainsRole <em>Contains Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contains Role</em>'.
	 * @see Agent.AgentViewpoint#getContainsRole()
	 * @see #getAgentViewpoint()
	 * @generated
	 */
	EReference getAgentViewpoint_ContainsRole();

	/**
	 * Returns the meta object for the containment reference list '{@link Agent.AgentViewpoint#getContainsSWA <em>Contains SWA</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contains SWA</em>'.
	 * @see Agent.AgentViewpoint#getContainsSWA()
	 * @see #getAgentViewpoint()
	 * @generated
	 */
	EReference getAgentViewpoint_ContainsSWA();

	/**
	 * Returns the meta object for the containment reference list '{@link Agent.AgentViewpoint#getContainsBehaviour <em>Contains Behaviour</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contains Behaviour</em>'.
	 * @see Agent.AgentViewpoint#getContainsBehaviour()
	 * @see #getAgentViewpoint()
	 * @generated
	 */
	EReference getAgentViewpoint_ContainsBehaviour();

	/**
	 * Returns the meta object for the containment reference list '{@link Agent.AgentViewpoint#getContainsCapabilities <em>Contains Capabilities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contains Capabilities</em>'.
	 * @see Agent.AgentViewpoint#getContainsCapabilities()
	 * @see #getAgentViewpoint()
	 * @generated
	 */
	EReference getAgentViewpoint_ContainsCapabilities();

	/**
	 * Returns the meta object for the reference list '{@link Agent.AgentViewpoint#getContainsBelief <em>Contains Belief</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Contains Belief</em>'.
	 * @see Agent.AgentViewpoint#getContainsBelief()
	 * @see #getAgentViewpoint()
	 * @generated
	 */
	EReference getAgentViewpoint_ContainsBelief();

	/**
	 * Returns the meta object for the reference list '{@link Agent.AgentViewpoint#getContainsGoal <em>Contains Goal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Contains Goal</em>'.
	 * @see Agent.AgentViewpoint#getContainsGoal()
	 * @see #getAgentViewpoint()
	 * @generated
	 */
	EReference getAgentViewpoint_ContainsGoal();

	/**
	 * Returns the meta object for the reference list '{@link Agent.AgentViewpoint#getContainsPlan <em>Contains Plan</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Contains Plan</em>'.
	 * @see Agent.AgentViewpoint#getContainsPlan()
	 * @see #getAgentViewpoint()
	 * @generated
	 */
	EReference getAgentViewpoint_ContainsPlan();

	/**
	 * Returns the meta object for the reference list '{@link Agent.AgentViewpoint#getContainsMatchmakerAgent <em>Contains Matchmaker Agent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Contains Matchmaker Agent</em>'.
	 * @see Agent.AgentViewpoint#getContainsMatchmakerAgent()
	 * @see #getAgentViewpoint()
	 * @generated
	 */
	EReference getAgentViewpoint_ContainsMatchmakerAgent();

	/**
	 * Returns the meta object for the reference list '{@link Agent.AgentViewpoint#getContainsAgentState <em>Contains Agent State</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Contains Agent State</em>'.
	 * @see Agent.AgentViewpoint#getContainsAgentState()
	 * @see #getAgentViewpoint()
	 * @generated
	 */
	EReference getAgentViewpoint_ContainsAgentState();

	/**
	 * Returns the meta object for the reference list '{@link Agent.AgentViewpoint#getContainsAgentType <em>Contains Agent Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Contains Agent Type</em>'.
	 * @see Agent.AgentViewpoint#getContainsAgentType()
	 * @see #getAgentViewpoint()
	 * @generated
	 */
	EReference getAgentViewpoint_ContainsAgentType();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	AgentFactory getAgentFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link Agent.impl.BeliefImpl <em>Belief</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see Agent.impl.BeliefImpl
		 * @see Agent.impl.AgentPackageImpl#getBelief()
		 * @generated
		 */
		EClass BELIEF = eINSTANCE.getBelief();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BELIEF__DESCRIPTION = eINSTANCE.getBelief_Description();

		/**
		 * The meta object literal for the '<em><b>Dynamic</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BELIEF__DYNAMIC = eINSTANCE.getBelief_Dynamic();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BELIEF__NAME = eINSTANCE.getBelief_Name();

		/**
		 * The meta object literal for the '{@link Agent.impl.GoalImpl <em>Goal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see Agent.impl.GoalImpl
		 * @see Agent.impl.AgentPackageImpl#getGoal()
		 * @generated
		 */
		EClass GOAL = eINSTANCE.getGoal();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GOAL__NAME = eINSTANCE.getGoal_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GOAL__DESCRIPTION = eINSTANCE.getGoal_Description();

		/**
		 * The meta object literal for the '<em><b>Recur</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GOAL__RECUR = eINSTANCE.getGoal_Recur();

		/**
		 * The meta object literal for the '{@link Agent.impl.CapabilitiesImpl <em>Capabilities</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see Agent.impl.CapabilitiesImpl
		 * @see Agent.impl.AgentPackageImpl#getCapabilities()
		 * @generated
		 */
		EClass CAPABILITIES = eINSTANCE.getCapabilities();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CAPABILITIES__NAME = eINSTANCE.getCapabilities_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CAPABILITIES__DESCRIPTION = eINSTANCE.getCapabilities_Description();

		/**
		 * The meta object literal for the '<em><b>Uses</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CAPABILITIES__USES = eINSTANCE.getCapabilities_Uses();

		/**
		 * The meta object literal for the '<em><b>Applies</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CAPABILITIES__APPLIES = eINSTANCE.getCapabilities_Applies();

		/**
		 * The meta object literal for the '<em><b>Includes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CAPABILITIES__INCLUDES = eINSTANCE.getCapabilities_Includes();

		/**
		 * The meta object literal for the '{@link Agent.impl.PlanImpl <em>Plan</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see Agent.impl.PlanImpl
		 * @see Agent.impl.AgentPackageImpl#getPlan()
		 * @generated
		 */
		EClass PLAN = eINSTANCE.getPlan();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PLAN__NAME = eINSTANCE.getPlan_Name();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PLAN__TYPE = eINSTANCE.getPlan_Type();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PLAN__DESCRIPTION = eINSTANCE.getPlan_Description();

		/**
		 * The meta object literal for the '<em><b>Priority</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PLAN__PRIORITY = eINSTANCE.getPlan_Priority();

		/**
		 * The meta object literal for the '<em><b>Dispatches</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PLAN__DISPATCHES = eINSTANCE.getPlan_Dispatches();

		/**
		 * The meta object literal for the '{@link Agent.impl.BehaviourImpl <em>Behaviour</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see Agent.impl.BehaviourImpl
		 * @see Agent.impl.AgentPackageImpl#getBehaviour()
		 * @generated
		 */
		EClass BEHAVIOUR = eINSTANCE.getBehaviour();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BEHAVIOUR__NAME = eINSTANCE.getBehaviour_Name();

		/**
		 * The meta object literal for the '<em><b>Resident</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BEHAVIOUR__RESIDENT = eINSTANCE.getBehaviour_Resident();

		/**
		 * The meta object literal for the '<em><b>Composed of</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BEHAVIOUR__COMPOSED_OF = eINSTANCE.getBehaviour_Composed_of();

		/**
		 * The meta object literal for the '<em><b>Executes</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BEHAVIOUR__EXECUTES = eINSTANCE.getBehaviour_Executes();

		/**
		 * The meta object literal for the '{@link Agent.impl.SemanticWebAgentImpl <em>Semantic Web Agent</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see Agent.impl.SemanticWebAgentImpl
		 * @see Agent.impl.AgentPackageImpl#getSemanticWebAgent()
		 * @generated
		 */
		EClass SEMANTIC_WEB_AGENT = eINSTANCE.getSemanticWebAgent();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SEMANTIC_WEB_AGENT__NAME = eINSTANCE.getSemanticWebAgent_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SEMANTIC_WEB_AGENT__DESCRIPTION = eINSTANCE.getSemanticWebAgent_Description();

		/**
		 * The meta object literal for the '<em><b>Properties</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SEMANTIC_WEB_AGENT__PROPERTIES = eINSTANCE.getSemanticWebAgent_Properties();

		/**
		 * The meta object literal for the '<em><b>Includes</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEMANTIC_WEB_AGENT__INCLUDES = eINSTANCE.getSemanticWebAgent_Includes();

		/**
		 * The meta object literal for the '<em><b>Plays</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEMANTIC_WEB_AGENT__PLAYS = eINSTANCE.getSemanticWebAgent_Plays();

		/**
		 * The meta object literal for the '<em><b>Contains</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEMANTIC_WEB_AGENT__CONTAINS = eINSTANCE.getSemanticWebAgent_Contains();

		/**
		 * The meta object literal for the '<em><b>Has</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEMANTIC_WEB_AGENT__HAS = eINSTANCE.getSemanticWebAgent_Has();

		/**
		 * The meta object literal for the '{@link Agent.impl.SWSMatchmakerAgentImpl <em>SWS Matchmaker Agent</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see Agent.impl.SWSMatchmakerAgentImpl
		 * @see Agent.impl.AgentPackageImpl#getSWSMatchmakerAgent()
		 * @generated
		 */
		EClass SWS_MATCHMAKER_AGENT = eINSTANCE.getSWSMatchmakerAgent();

		/**
		 * The meta object literal for the '{@link Agent.impl.AgentStateImpl <em>State</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see Agent.impl.AgentStateImpl
		 * @see Agent.impl.AgentPackageImpl#getAgentState()
		 * @generated
		 */
		EClass AGENT_STATE = eINSTANCE.getAgentState();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AGENT_STATE__NAME = eINSTANCE.getAgentState_Name();

		/**
		 * The meta object literal for the '{@link Agent.impl.RoleImpl <em>Role</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see Agent.impl.RoleImpl
		 * @see Agent.impl.AgentPackageImpl#getRole()
		 * @generated
		 */
		EClass ROLE = eINSTANCE.getRole();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ROLE__NAME = eINSTANCE.getRole_Name();

		/**
		 * The meta object literal for the '<em><b>Has</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROLE__HAS = eINSTANCE.getRole_Has();

		/**
		 * The meta object literal for the '{@link Agent.impl.AgentTypeImpl <em>Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see Agent.impl.AgentTypeImpl
		 * @see Agent.impl.AgentPackageImpl#getAgentType()
		 * @generated
		 */
		EClass AGENT_TYPE = eINSTANCE.getAgentType();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AGENT_TYPE__NAME = eINSTANCE.getAgentType_Name();

		/**
		 * The meta object literal for the '{@link Agent.impl.AgentViewpointImpl <em>Viewpoint</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see Agent.impl.AgentViewpointImpl
		 * @see Agent.impl.AgentPackageImpl#getAgentViewpoint()
		 * @generated
		 */
		EClass AGENT_VIEWPOINT = eINSTANCE.getAgentViewpoint();

		/**
		 * The meta object literal for the '<em><b>Contains Role</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AGENT_VIEWPOINT__CONTAINS_ROLE = eINSTANCE.getAgentViewpoint_ContainsRole();

		/**
		 * The meta object literal for the '<em><b>Contains SWA</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AGENT_VIEWPOINT__CONTAINS_SWA = eINSTANCE.getAgentViewpoint_ContainsSWA();

		/**
		 * The meta object literal for the '<em><b>Contains Behaviour</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AGENT_VIEWPOINT__CONTAINS_BEHAVIOUR = eINSTANCE.getAgentViewpoint_ContainsBehaviour();

		/**
		 * The meta object literal for the '<em><b>Contains Capabilities</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AGENT_VIEWPOINT__CONTAINS_CAPABILITIES = eINSTANCE.getAgentViewpoint_ContainsCapabilities();

		/**
		 * The meta object literal for the '<em><b>Contains Belief</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AGENT_VIEWPOINT__CONTAINS_BELIEF = eINSTANCE.getAgentViewpoint_ContainsBelief();

		/**
		 * The meta object literal for the '<em><b>Contains Goal</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AGENT_VIEWPOINT__CONTAINS_GOAL = eINSTANCE.getAgentViewpoint_ContainsGoal();

		/**
		 * The meta object literal for the '<em><b>Contains Plan</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AGENT_VIEWPOINT__CONTAINS_PLAN = eINSTANCE.getAgentViewpoint_ContainsPlan();

		/**
		 * The meta object literal for the '<em><b>Contains Matchmaker Agent</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AGENT_VIEWPOINT__CONTAINS_MATCHMAKER_AGENT = eINSTANCE.getAgentViewpoint_ContainsMatchmakerAgent();

		/**
		 * The meta object literal for the '<em><b>Contains Agent State</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AGENT_VIEWPOINT__CONTAINS_AGENT_STATE = eINSTANCE.getAgentViewpoint_ContainsAgentState();

		/**
		 * The meta object literal for the '<em><b>Contains Agent Type</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AGENT_VIEWPOINT__CONTAINS_AGENT_TYPE = eINSTANCE.getAgentViewpoint_ContainsAgentType();

	}

} //AgentPackage
