/*
 * 
 */
package environment.diagram.edit.parts;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.directedit.locator.CellEditorLocatorAccess;

import environment.diagram.part.EnvironmentVisualIDRegistry;

/**
 * @generated
 */
public class EnvironmentEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (EnvironmentVisualIDRegistry.getVisualID(view)) {

			case EnvironmentViewpointEditPart.VISUAL_ID:
				return new EnvironmentViewpointEditPart(view);

			case ServiceEditPart.VISUAL_ID:
				return new ServiceEditPart(view);

			case ServiceNameEditPart.VISUAL_ID:
				return new ServiceNameEditPart(view);

			case EnvironmentEditPart.VISUAL_ID:
				return new EnvironmentEditPart(view);

			case EnvironmentNameEditPart.VISUAL_ID:
				return new EnvironmentNameEditPart(view);

			case FactEditPart.VISUAL_ID:
				return new FactEditPart(view);

			case FactNameEditPart.VISUAL_ID:
				return new FactNameEditPart(view);

			case SemanticWebAgentEditPart.VISUAL_ID:
				return new SemanticWebAgentEditPart(view);

			case SemanticWebAgentNameEditPart.VISUAL_ID:
				return new SemanticWebAgentNameEditPart(view);

			case ResourceEditPart.VISUAL_ID:
				return new ResourceEditPart(view);

			case ResourceNameEditPart.VISUAL_ID:
				return new ResourceNameEditPart(view);

			case Resource2EditPart.VISUAL_ID:
				return new Resource2EditPart(view);

			case ResourceName2EditPart.VISUAL_ID:
				return new ResourceName2EditPart(view);

			case Service2EditPart.VISUAL_ID:
				return new Service2EditPart(view);

			case ServiceName2EditPart.VISUAL_ID:
				return new ServiceName2EditPart(view);

			case Fact2EditPart.VISUAL_ID:
				return new Fact2EditPart(view);

			case FactName2EditPart.VISUAL_ID:
				return new FactName2EditPart(view);

			case EnvironmentEnvironmentHasResourceCompartmentEditPart.VISUAL_ID:
				return new EnvironmentEnvironmentHasResourceCompartmentEditPart(
						view);

			case EnvironmentEnvironmentHasServiceCompartmentEditPart.VISUAL_ID:
				return new EnvironmentEnvironmentHasServiceCompartmentEditPart(
						view);

			case EnvironmentEnvironmentHasFactCompartmentEditPart.VISUAL_ID:
				return new EnvironmentEnvironmentHasFactCompartmentEditPart(
						view);

			case SemanticWebAgentAccessEditPart.VISUAL_ID:
				return new SemanticWebAgentAccessEditPart(view);

			case SemanticWebAgentAccessExternalLabelEditPart.VISUAL_ID:
				return new SemanticWebAgentAccessExternalLabelEditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		return CellEditorLocatorAccess.INSTANCE
				.getTextCellEditorLocator(source);
	}

}
