/*
 * 
 */
package environment.diagram.navigator;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.common.ui.services.parser.CommonParserHint;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import environment.diagram.edit.parts.EnvironmentEditPart;
import environment.diagram.edit.parts.EnvironmentNameEditPart;
import environment.diagram.edit.parts.EnvironmentViewpointEditPart;
import environment.diagram.edit.parts.Fact2EditPart;
import environment.diagram.edit.parts.FactEditPart;
import environment.diagram.edit.parts.FactName2EditPart;
import environment.diagram.edit.parts.FactNameEditPart;
import environment.diagram.edit.parts.Resource2EditPart;
import environment.diagram.edit.parts.ResourceEditPart;
import environment.diagram.edit.parts.ResourceName2EditPart;
import environment.diagram.edit.parts.ResourceNameEditPart;
import environment.diagram.edit.parts.SemanticWebAgentAccessEditPart;
import environment.diagram.edit.parts.SemanticWebAgentEditPart;
import environment.diagram.edit.parts.SemanticWebAgentNameEditPart;
import environment.diagram.edit.parts.Service2EditPart;
import environment.diagram.edit.parts.ServiceEditPart;
import environment.diagram.edit.parts.ServiceName2EditPart;
import environment.diagram.edit.parts.ServiceNameEditPart;
import environment.diagram.part.EnvironmentDiagramEditorPlugin;
import environment.diagram.part.EnvironmentVisualIDRegistry;
import environment.diagram.providers.EnvironmentElementTypes;
import environment.diagram.providers.EnvironmentParserProvider;

/**
 * @generated
 */
public class EnvironmentNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		EnvironmentDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		EnvironmentDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof EnvironmentNavigatorItem
				&& !isOwnView(((EnvironmentNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof EnvironmentNavigatorGroup) {
			EnvironmentNavigatorGroup group = (EnvironmentNavigatorGroup) element;
			return EnvironmentDiagramEditorPlugin.getInstance()
					.getBundledImage(group.getIcon());
		}

		if (element instanceof EnvironmentNavigatorItem) {
			EnvironmentNavigatorItem navigatorItem = (EnvironmentNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getImage(view);
			}
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (EnvironmentVisualIDRegistry.getVisualID(view)) {
		case ServiceEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?environment?Service", EnvironmentElementTypes.Service_2001); //$NON-NLS-1$
		case Fact2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?environment?Fact", EnvironmentElementTypes.Fact_3003); //$NON-NLS-1$
		case FactEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?environment?Fact", EnvironmentElementTypes.Fact_2003); //$NON-NLS-1$
		case EnvironmentEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?environment?Environment", EnvironmentElementTypes.Environment_2002); //$NON-NLS-1$
		case ResourceEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?environment?Resource", EnvironmentElementTypes.Resource_2005); //$NON-NLS-1$
		case Resource2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?environment?Resource", EnvironmentElementTypes.Resource_3001); //$NON-NLS-1$
		case Service2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?environment?Service", EnvironmentElementTypes.Service_3002); //$NON-NLS-1$
		case SemanticWebAgentAccessEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?environment?SemanticWebAgent?access", EnvironmentElementTypes.SemanticWebAgentAccess_4001); //$NON-NLS-1$
		case EnvironmentViewpointEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?environment?EnvironmentViewpoint", EnvironmentElementTypes.EnvironmentViewpoint_1000); //$NON-NLS-1$
		case SemanticWebAgentEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?environment?SemanticWebAgent", EnvironmentElementTypes.SemanticWebAgent_2004); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = EnvironmentDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& EnvironmentElementTypes.isKnownElementType(elementType)) {
			image = EnvironmentElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof EnvironmentNavigatorGroup) {
			EnvironmentNavigatorGroup group = (EnvironmentNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof EnvironmentNavigatorItem) {
			EnvironmentNavigatorItem navigatorItem = (EnvironmentNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getText(view);
			}
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (EnvironmentVisualIDRegistry.getVisualID(view)) {
		case ServiceEditPart.VISUAL_ID:
			return getService_2001Text(view);
		case Fact2EditPart.VISUAL_ID:
			return getFact_3003Text(view);
		case FactEditPart.VISUAL_ID:
			return getFact_2003Text(view);
		case EnvironmentEditPart.VISUAL_ID:
			return getEnvironment_2002Text(view);
		case ResourceEditPart.VISUAL_ID:
			return getResource_2005Text(view);
		case Resource2EditPart.VISUAL_ID:
			return getResource_3001Text(view);
		case Service2EditPart.VISUAL_ID:
			return getService_3002Text(view);
		case SemanticWebAgentAccessEditPart.VISUAL_ID:
			return getSemanticWebAgentAccess_4001Text(view);
		case EnvironmentViewpointEditPart.VISUAL_ID:
			return getEnvironmentViewpoint_1000Text(view);
		case SemanticWebAgentEditPart.VISUAL_ID:
			return getSemanticWebAgent_2004Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getFact_3003Text(View view) {
		IParser parser = EnvironmentParserProvider.getParser(
				EnvironmentElementTypes.Fact_3003,
				view.getElement() != null ? view.getElement() : view,
				EnvironmentVisualIDRegistry
						.getType(FactName2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			EnvironmentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getService_3002Text(View view) {
		IParser parser = EnvironmentParserProvider.getParser(
				EnvironmentElementTypes.Service_3002,
				view.getElement() != null ? view.getElement() : view,
				EnvironmentVisualIDRegistry
						.getType(ServiceName2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			EnvironmentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getEnvironment_2002Text(View view) {
		IParser parser = EnvironmentParserProvider.getParser(
				EnvironmentElementTypes.Environment_2002,
				view.getElement() != null ? view.getElement() : view,
				EnvironmentVisualIDRegistry
						.getType(EnvironmentNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			EnvironmentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSemanticWebAgent_2004Text(View view) {
		IParser parser = EnvironmentParserProvider.getParser(
				EnvironmentElementTypes.SemanticWebAgent_2004, view
						.getElement() != null ? view.getElement() : view,
				EnvironmentVisualIDRegistry
						.getType(SemanticWebAgentNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			EnvironmentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getService_2001Text(View view) {
		IParser parser = EnvironmentParserProvider.getParser(
				EnvironmentElementTypes.Service_2001,
				view.getElement() != null ? view.getElement() : view,
				EnvironmentVisualIDRegistry
						.getType(ServiceNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			EnvironmentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getFact_2003Text(View view) {
		IParser parser = EnvironmentParserProvider
				.getParser(EnvironmentElementTypes.Fact_2003,
						view.getElement() != null ? view.getElement() : view,
						EnvironmentVisualIDRegistry
								.getType(FactNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			EnvironmentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getEnvironmentViewpoint_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getResource_3001Text(View view) {
		IParser parser = EnvironmentParserProvider.getParser(
				EnvironmentElementTypes.Resource_3001,
				view.getElement() != null ? view.getElement() : view,
				EnvironmentVisualIDRegistry
						.getType(ResourceName2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			EnvironmentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getResource_2005Text(View view) {
		IParser parser = EnvironmentParserProvider.getParser(
				EnvironmentElementTypes.Resource_2005,
				view.getElement() != null ? view.getElement() : view,
				EnvironmentVisualIDRegistry
						.getType(ResourceNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			EnvironmentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5008); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSemanticWebAgentAccess_4001Text(View view) {
		IParser parser = EnvironmentParserProvider.getParser(
				EnvironmentElementTypes.SemanticWebAgentAccess_4001,
				view.getElement() != null ? view.getElement() : view,
				CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			EnvironmentDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return EnvironmentViewpointEditPart.MODEL_ID
				.equals(EnvironmentVisualIDRegistry.getModelID(view));
	}

}
