/*
 * 
 */
package environment.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.update.DiagramUpdater;

import environment.Environment;
import environment.EnvironmentPackage;
import environment.EnvironmentViewpoint;
import environment.Fact;
import environment.Resource;
import environment.SemanticWebAgent;
import environment.Service;
import environment.diagram.edit.parts.EnvironmentEditPart;
import environment.diagram.edit.parts.EnvironmentEnvironmentHasFactCompartmentEditPart;
import environment.diagram.edit.parts.EnvironmentEnvironmentHasResourceCompartmentEditPart;
import environment.diagram.edit.parts.EnvironmentEnvironmentHasServiceCompartmentEditPart;
import environment.diagram.edit.parts.EnvironmentViewpointEditPart;
import environment.diagram.edit.parts.Fact2EditPart;
import environment.diagram.edit.parts.FactEditPart;
import environment.diagram.edit.parts.Resource2EditPart;
import environment.diagram.edit.parts.ResourceEditPart;
import environment.diagram.edit.parts.SemanticWebAgentAccessEditPart;
import environment.diagram.edit.parts.SemanticWebAgentEditPart;
import environment.diagram.edit.parts.Service2EditPart;
import environment.diagram.edit.parts.ServiceEditPart;
import environment.diagram.providers.EnvironmentElementTypes;

/**
 * @generated
 */
public class EnvironmentDiagramUpdater {

	/**
	 * @generated
	 */
	public static boolean isShortcutOrphaned(View view) {
		return !view.isSetElement() || view.getElement() == null
				|| view.getElement().eIsProxy();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentNodeDescriptor> getSemanticChildren(View view) {
		switch (EnvironmentVisualIDRegistry.getVisualID(view)) {
		case EnvironmentViewpointEditPart.VISUAL_ID:
			return getEnvironmentViewpoint_1000SemanticChildren(view);
		case EnvironmentEnvironmentHasResourceCompartmentEditPart.VISUAL_ID:
			return getEnvironmentEnvironmentHasResourceCompartment_7001SemanticChildren(view);
		case EnvironmentEnvironmentHasServiceCompartmentEditPart.VISUAL_ID:
			return getEnvironmentEnvironmentHasServiceCompartment_7002SemanticChildren(view);
		case EnvironmentEnvironmentHasFactCompartmentEditPart.VISUAL_ID:
			return getEnvironmentEnvironmentHasFactCompartment_7003SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentNodeDescriptor> getEnvironmentViewpoint_1000SemanticChildren(
			View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		EnvironmentViewpoint modelElement = (EnvironmentViewpoint) view
				.getElement();
		LinkedList<EnvironmentNodeDescriptor> result = new LinkedList<EnvironmentNodeDescriptor>();
		for (Iterator<?> it = modelElement.getHasService().iterator(); it
				.hasNext();) {
			Service childElement = (Service) it.next();
			int visualID = EnvironmentVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ServiceEditPart.VISUAL_ID) {
				result.add(new EnvironmentNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getHasEnvironment().iterator(); it
				.hasNext();) {
			Environment childElement = (Environment) it.next();
			int visualID = EnvironmentVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == EnvironmentEditPart.VISUAL_ID) {
				result.add(new EnvironmentNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getHasFact().iterator(); it
				.hasNext();) {
			Fact childElement = (Fact) it.next();
			int visualID = EnvironmentVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FactEditPart.VISUAL_ID) {
				result.add(new EnvironmentNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getHasSWA().iterator(); it.hasNext();) {
			SemanticWebAgent childElement = (SemanticWebAgent) it.next();
			int visualID = EnvironmentVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == SemanticWebAgentEditPart.VISUAL_ID) {
				result.add(new EnvironmentNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getHasResource().iterator(); it
				.hasNext();) {
			Resource childElement = (Resource) it.next();
			int visualID = EnvironmentVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ResourceEditPart.VISUAL_ID) {
				result.add(new EnvironmentNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentNodeDescriptor> getEnvironmentEnvironmentHasResourceCompartment_7001SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		Environment modelElement = (Environment) containerView.getElement();
		LinkedList<EnvironmentNodeDescriptor> result = new LinkedList<EnvironmentNodeDescriptor>();
		for (Iterator<?> it = modelElement.getHasResource().iterator(); it
				.hasNext();) {
			Resource childElement = (Resource) it.next();
			int visualID = EnvironmentVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Resource2EditPart.VISUAL_ID) {
				result.add(new EnvironmentNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentNodeDescriptor> getEnvironmentEnvironmentHasServiceCompartment_7002SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		Environment modelElement = (Environment) containerView.getElement();
		LinkedList<EnvironmentNodeDescriptor> result = new LinkedList<EnvironmentNodeDescriptor>();
		for (Iterator<?> it = modelElement.getHasService().iterator(); it
				.hasNext();) {
			Service childElement = (Service) it.next();
			int visualID = EnvironmentVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Service2EditPart.VISUAL_ID) {
				result.add(new EnvironmentNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentNodeDescriptor> getEnvironmentEnvironmentHasFactCompartment_7003SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		Environment modelElement = (Environment) containerView.getElement();
		LinkedList<EnvironmentNodeDescriptor> result = new LinkedList<EnvironmentNodeDescriptor>();
		for (Iterator<?> it = modelElement.getHasFact().iterator(); it
				.hasNext();) {
			Fact childElement = (Fact) it.next();
			int visualID = EnvironmentVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Fact2EditPart.VISUAL_ID) {
				result.add(new EnvironmentNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getContainedLinks(View view) {
		switch (EnvironmentVisualIDRegistry.getVisualID(view)) {
		case EnvironmentViewpointEditPart.VISUAL_ID:
			return getEnvironmentViewpoint_1000ContainedLinks(view);
		case ServiceEditPart.VISUAL_ID:
			return getService_2001ContainedLinks(view);
		case EnvironmentEditPart.VISUAL_ID:
			return getEnvironment_2002ContainedLinks(view);
		case FactEditPart.VISUAL_ID:
			return getFact_2003ContainedLinks(view);
		case SemanticWebAgentEditPart.VISUAL_ID:
			return getSemanticWebAgent_2004ContainedLinks(view);
		case ResourceEditPart.VISUAL_ID:
			return getResource_2005ContainedLinks(view);
		case Resource2EditPart.VISUAL_ID:
			return getResource_3001ContainedLinks(view);
		case Service2EditPart.VISUAL_ID:
			return getService_3002ContainedLinks(view);
		case Fact2EditPart.VISUAL_ID:
			return getFact_3003ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getIncomingLinks(View view) {
		switch (EnvironmentVisualIDRegistry.getVisualID(view)) {
		case ServiceEditPart.VISUAL_ID:
			return getService_2001IncomingLinks(view);
		case EnvironmentEditPart.VISUAL_ID:
			return getEnvironment_2002IncomingLinks(view);
		case FactEditPart.VISUAL_ID:
			return getFact_2003IncomingLinks(view);
		case SemanticWebAgentEditPart.VISUAL_ID:
			return getSemanticWebAgent_2004IncomingLinks(view);
		case ResourceEditPart.VISUAL_ID:
			return getResource_2005IncomingLinks(view);
		case Resource2EditPart.VISUAL_ID:
			return getResource_3001IncomingLinks(view);
		case Service2EditPart.VISUAL_ID:
			return getService_3002IncomingLinks(view);
		case Fact2EditPart.VISUAL_ID:
			return getFact_3003IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getOutgoingLinks(View view) {
		switch (EnvironmentVisualIDRegistry.getVisualID(view)) {
		case ServiceEditPart.VISUAL_ID:
			return getService_2001OutgoingLinks(view);
		case EnvironmentEditPart.VISUAL_ID:
			return getEnvironment_2002OutgoingLinks(view);
		case FactEditPart.VISUAL_ID:
			return getFact_2003OutgoingLinks(view);
		case SemanticWebAgentEditPart.VISUAL_ID:
			return getSemanticWebAgent_2004OutgoingLinks(view);
		case ResourceEditPart.VISUAL_ID:
			return getResource_2005OutgoingLinks(view);
		case Resource2EditPart.VISUAL_ID:
			return getResource_3001OutgoingLinks(view);
		case Service2EditPart.VISUAL_ID:
			return getService_3002OutgoingLinks(view);
		case Fact2EditPart.VISUAL_ID:
			return getFact_3003OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getEnvironmentViewpoint_1000ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getService_2001ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getEnvironment_2002ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getFact_2003ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getSemanticWebAgent_2004ContainedLinks(
			View view) {
		SemanticWebAgent modelElement = (SemanticWebAgent) view.getElement();
		LinkedList<EnvironmentLinkDescriptor> result = new LinkedList<EnvironmentLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_SemanticWebAgent_Access_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getResource_2005ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getResource_3001ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getService_3002ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getFact_3003ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getService_2001IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getEnvironment_2002IncomingLinks(
			View view) {
		Environment modelElement = (Environment) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<EnvironmentLinkDescriptor> result = new LinkedList<EnvironmentLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_SemanticWebAgent_Access_4001(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getFact_2003IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getSemanticWebAgent_2004IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getResource_2005IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getResource_3001IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getService_3002IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getFact_3003IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getService_2001OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getEnvironment_2002OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getFact_2003OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getSemanticWebAgent_2004OutgoingLinks(
			View view) {
		SemanticWebAgent modelElement = (SemanticWebAgent) view.getElement();
		LinkedList<EnvironmentLinkDescriptor> result = new LinkedList<EnvironmentLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_SemanticWebAgent_Access_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getResource_2005OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getResource_3001OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getService_3002OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<EnvironmentLinkDescriptor> getFact_3003OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	private static Collection<EnvironmentLinkDescriptor> getIncomingFeatureModelFacetLinks_SemanticWebAgent_Access_4001(
			Environment target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<EnvironmentLinkDescriptor> result = new LinkedList<EnvironmentLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == EnvironmentPackage.eINSTANCE
					.getSemanticWebAgent_Access()) {
				result.add(new EnvironmentLinkDescriptor(setting.getEObject(),
						target,
						EnvironmentElementTypes.SemanticWebAgentAccess_4001,
						SemanticWebAgentAccessEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<EnvironmentLinkDescriptor> getOutgoingFeatureModelFacetLinks_SemanticWebAgent_Access_4001(
			SemanticWebAgent source) {
		LinkedList<EnvironmentLinkDescriptor> result = new LinkedList<EnvironmentLinkDescriptor>();
		for (Iterator<?> destinations = source.getAccess().iterator(); destinations
				.hasNext();) {
			Environment destination = (Environment) destinations.next();
			result.add(new EnvironmentLinkDescriptor(source, destination,
					EnvironmentElementTypes.SemanticWebAgentAccess_4001,
					SemanticWebAgentAccessEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static final DiagramUpdater TYPED_INSTANCE = new DiagramUpdater() {
		/**
		 * @generated
		 */
		@Override
		public List<EnvironmentNodeDescriptor> getSemanticChildren(View view) {
			return EnvironmentDiagramUpdater.getSemanticChildren(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<EnvironmentLinkDescriptor> getContainedLinks(View view) {
			return EnvironmentDiagramUpdater.getContainedLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<EnvironmentLinkDescriptor> getIncomingLinks(View view) {
			return EnvironmentDiagramUpdater.getIncomingLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<EnvironmentLinkDescriptor> getOutgoingLinks(View view) {
			return EnvironmentDiagramUpdater.getOutgoingLinks(view);
		}
	};

}
