/*
 * 
 */
package environment.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

import environment.EnvironmentPackage;
import environment.diagram.edit.parts.EnvironmentEditPart;
import environment.diagram.edit.parts.EnvironmentViewpointEditPart;
import environment.diagram.edit.parts.Fact2EditPart;
import environment.diagram.edit.parts.FactEditPart;
import environment.diagram.edit.parts.Resource2EditPart;
import environment.diagram.edit.parts.ResourceEditPart;
import environment.diagram.edit.parts.SemanticWebAgentAccessEditPart;
import environment.diagram.edit.parts.SemanticWebAgentEditPart;
import environment.diagram.edit.parts.Service2EditPart;
import environment.diagram.edit.parts.ServiceEditPart;
import environment.diagram.part.EnvironmentDiagramEditorPlugin;

/**
 * @generated
 */
public class EnvironmentElementTypes {

	/**
	 * @generated
	 */
	private EnvironmentElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType EnvironmentViewpoint_1000 = getElementType("Environment.diagram.EnvironmentViewpoint_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Service_2001 = getElementType("Environment.diagram.Service_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Environment_2002 = getElementType("Environment.diagram.Environment_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Fact_2003 = getElementType("Environment.diagram.Fact_2003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SemanticWebAgent_2004 = getElementType("Environment.diagram.SemanticWebAgent_2004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Resource_2005 = getElementType("Environment.diagram.Resource_2005"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Resource_3001 = getElementType("Environment.diagram.Resource_3001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Service_3002 = getElementType("Environment.diagram.Service_3002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Fact_3003 = getElementType("Environment.diagram.Fact_3003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SemanticWebAgentAccess_4001 = getElementType("Environment.diagram.SemanticWebAgentAccess_4001"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return EnvironmentDiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(EnvironmentViewpoint_1000,
					EnvironmentPackage.eINSTANCE.getEnvironmentViewpoint());

			elements.put(Service_2001,
					EnvironmentPackage.eINSTANCE.getService());

			elements.put(Environment_2002,
					EnvironmentPackage.eINSTANCE.getEnvironment());

			elements.put(Fact_2003, EnvironmentPackage.eINSTANCE.getFact());

			elements.put(SemanticWebAgent_2004,
					EnvironmentPackage.eINSTANCE.getSemanticWebAgent());

			elements.put(Resource_2005,
					EnvironmentPackage.eINSTANCE.getResource());

			elements.put(Resource_3001,
					EnvironmentPackage.eINSTANCE.getResource());

			elements.put(Service_3002,
					EnvironmentPackage.eINSTANCE.getService());

			elements.put(Fact_3003, EnvironmentPackage.eINSTANCE.getFact());

			elements.put(SemanticWebAgentAccess_4001,
					EnvironmentPackage.eINSTANCE.getSemanticWebAgent_Access());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(EnvironmentViewpoint_1000);
			KNOWN_ELEMENT_TYPES.add(Service_2001);
			KNOWN_ELEMENT_TYPES.add(Environment_2002);
			KNOWN_ELEMENT_TYPES.add(Fact_2003);
			KNOWN_ELEMENT_TYPES.add(SemanticWebAgent_2004);
			KNOWN_ELEMENT_TYPES.add(Resource_2005);
			KNOWN_ELEMENT_TYPES.add(Resource_3001);
			KNOWN_ELEMENT_TYPES.add(Service_3002);
			KNOWN_ELEMENT_TYPES.add(Fact_3003);
			KNOWN_ELEMENT_TYPES.add(SemanticWebAgentAccess_4001);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case EnvironmentViewpointEditPart.VISUAL_ID:
			return EnvironmentViewpoint_1000;
		case ServiceEditPart.VISUAL_ID:
			return Service_2001;
		case EnvironmentEditPart.VISUAL_ID:
			return Environment_2002;
		case FactEditPart.VISUAL_ID:
			return Fact_2003;
		case SemanticWebAgentEditPart.VISUAL_ID:
			return SemanticWebAgent_2004;
		case ResourceEditPart.VISUAL_ID:
			return Resource_2005;
		case Resource2EditPart.VISUAL_ID:
			return Resource_3001;
		case Service2EditPart.VISUAL_ID:
			return Service_3002;
		case Fact2EditPart.VISUAL_ID:
			return Fact_3003;
		case SemanticWebAgentAccessEditPart.VISUAL_ID:
			return SemanticWebAgentAccess_4001;
		}
		return null;
	}

}
