/*
 * 
 */
package environment.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

import environment.EnvironmentPackage;
import environment.diagram.edit.parts.EnvironmentNameEditPart;
import environment.diagram.edit.parts.FactName2EditPart;
import environment.diagram.edit.parts.FactNameEditPart;
import environment.diagram.edit.parts.ResourceName2EditPart;
import environment.diagram.edit.parts.ResourceNameEditPart;
import environment.diagram.edit.parts.SemanticWebAgentNameEditPart;
import environment.diagram.edit.parts.ServiceName2EditPart;
import environment.diagram.edit.parts.ServiceNameEditPart;
import environment.diagram.parsers.MessageFormatParser;
import environment.diagram.part.EnvironmentVisualIDRegistry;

/**
 * @generated
 */
public class EnvironmentParserProvider extends AbstractProvider implements
		IParserProvider {

	/**
	 * @generated
	 */
	private IParser serviceName_5001Parser;

	/**
	 * @generated
	 */
	private IParser getServiceName_5001Parser() {
		if (serviceName_5001Parser == null) {
			EAttribute[] features = new EAttribute[] { EnvironmentPackage.eINSTANCE
					.getService_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			serviceName_5001Parser = parser;
		}
		return serviceName_5001Parser;
	}

	/**
	 * @generated
	 */
	private IParser environmentName_5005Parser;

	/**
	 * @generated
	 */
	private IParser getEnvironmentName_5005Parser() {
		if (environmentName_5005Parser == null) {
			EAttribute[] features = new EAttribute[] { EnvironmentPackage.eINSTANCE
					.getEnvironment_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			environmentName_5005Parser = parser;
		}
		return environmentName_5005Parser;
	}

	/**
	 * @generated
	 */
	private IParser factName_5006Parser;

	/**
	 * @generated
	 */
	private IParser getFactName_5006Parser() {
		if (factName_5006Parser == null) {
			EAttribute[] features = new EAttribute[] { EnvironmentPackage.eINSTANCE
					.getFact_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			factName_5006Parser = parser;
		}
		return factName_5006Parser;
	}

	/**
	 * @generated
	 */
	private IParser semanticWebAgentName_5007Parser;

	/**
	 * @generated
	 */
	private IParser getSemanticWebAgentName_5007Parser() {
		if (semanticWebAgentName_5007Parser == null) {
			EAttribute[] features = new EAttribute[] { EnvironmentPackage.eINSTANCE
					.getSemanticWebAgent_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			semanticWebAgentName_5007Parser = parser;
		}
		return semanticWebAgentName_5007Parser;
	}

	/**
	 * @generated
	 */
	private IParser resourceName_5008Parser;

	/**
	 * @generated
	 */
	private IParser getResourceName_5008Parser() {
		if (resourceName_5008Parser == null) {
			EAttribute[] features = new EAttribute[] { EnvironmentPackage.eINSTANCE
					.getResource_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			resourceName_5008Parser = parser;
		}
		return resourceName_5008Parser;
	}

	/**
	 * @generated
	 */
	private IParser resourceName_5002Parser;

	/**
	 * @generated
	 */
	private IParser getResourceName_5002Parser() {
		if (resourceName_5002Parser == null) {
			EAttribute[] features = new EAttribute[] { EnvironmentPackage.eINSTANCE
					.getResource_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			resourceName_5002Parser = parser;
		}
		return resourceName_5002Parser;
	}

	/**
	 * @generated
	 */
	private IParser serviceName_5003Parser;

	/**
	 * @generated
	 */
	private IParser getServiceName_5003Parser() {
		if (serviceName_5003Parser == null) {
			EAttribute[] features = new EAttribute[] { EnvironmentPackage.eINSTANCE
					.getService_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			serviceName_5003Parser = parser;
		}
		return serviceName_5003Parser;
	}

	/**
	 * @generated
	 */
	private IParser factName_5004Parser;

	/**
	 * @generated
	 */
	private IParser getFactName_5004Parser() {
		if (factName_5004Parser == null) {
			EAttribute[] features = new EAttribute[] { EnvironmentPackage.eINSTANCE
					.getFact_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			factName_5004Parser = parser;
		}
		return factName_5004Parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case ServiceNameEditPart.VISUAL_ID:
			return getServiceName_5001Parser();
		case EnvironmentNameEditPart.VISUAL_ID:
			return getEnvironmentName_5005Parser();
		case FactNameEditPart.VISUAL_ID:
			return getFactName_5006Parser();
		case SemanticWebAgentNameEditPart.VISUAL_ID:
			return getSemanticWebAgentName_5007Parser();
		case ResourceNameEditPart.VISUAL_ID:
			return getResourceName_5008Parser();
		case ResourceName2EditPart.VISUAL_ID:
			return getResourceName_5002Parser();
		case ServiceName2EditPart.VISUAL_ID:
			return getServiceName_5003Parser();
		case FactName2EditPart.VISUAL_ID:
			return getFactName_5004Parser();
		}
		return null;
	}

	/**
	 * Utility method that consults ParserService
	 * @generated
	 */
	public static IParser getParser(IElementType type, EObject object,
			String parserHint) {
		return ParserService.getInstance().getParser(
				new HintAdapter(type, object, parserHint));
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(EnvironmentVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(EnvironmentVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (EnvironmentElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	private static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
