/**
 */
package environment;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see environment.EnvironmentFactory
 * @model kind="package"
 * @generated
 */
public interface EnvironmentPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "environment";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "environment";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "environment";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  EnvironmentPackage eINSTANCE = environment.impl.EnvironmentPackageImpl.init();

  /**
   * The meta object id for the '{@link environment.impl.EnvironmentViewpointImpl <em>Viewpoint</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see environment.impl.EnvironmentViewpointImpl
   * @see environment.impl.EnvironmentPackageImpl#getEnvironmentViewpoint()
   * @generated
   */
  int ENVIRONMENT_VIEWPOINT = 0;

  /**
   * The feature id for the '<em><b>Has Service</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENVIRONMENT_VIEWPOINT__HAS_SERVICE = 0;

  /**
   * The feature id for the '<em><b>Has Environment</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENVIRONMENT_VIEWPOINT__HAS_ENVIRONMENT = 1;

  /**
   * The feature id for the '<em><b>Has Fact</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENVIRONMENT_VIEWPOINT__HAS_FACT = 2;

  /**
   * The feature id for the '<em><b>Has SWA</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENVIRONMENT_VIEWPOINT__HAS_SWA = 3;

  /**
   * The feature id for the '<em><b>Has Resource</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENVIRONMENT_VIEWPOINT__HAS_RESOURCE = 4;

  /**
   * The number of structural features of the '<em>Viewpoint</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENVIRONMENT_VIEWPOINT_FEATURE_COUNT = 5;

  /**
   * The meta object id for the '{@link environment.impl.ServiceImpl <em>Service</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see environment.impl.ServiceImpl
   * @see environment.impl.EnvironmentPackageImpl#getService()
   * @generated
   */
  int SERVICE = 1;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SERVICE__NAME = 0;

  /**
   * The number of structural features of the '<em>Service</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SERVICE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link environment.impl.EnvironmentImpl <em>Environment</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see environment.impl.EnvironmentImpl
   * @see environment.impl.EnvironmentPackageImpl#getEnvironment()
   * @generated
   */
  int ENVIRONMENT = 2;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENVIRONMENT__NAME = 0;

  /**
   * The feature id for the '<em><b>Has Resource</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENVIRONMENT__HAS_RESOURCE = 1;

  /**
   * The feature id for the '<em><b>Has Service</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENVIRONMENT__HAS_SERVICE = 2;

  /**
   * The feature id for the '<em><b>Has Fact</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENVIRONMENT__HAS_FACT = 3;

  /**
   * The number of structural features of the '<em>Environment</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENVIRONMENT_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link environment.impl.FactImpl <em>Fact</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see environment.impl.FactImpl
   * @see environment.impl.EnvironmentPackageImpl#getFact()
   * @generated
   */
  int FACT = 3;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FACT__NAME = 0;

  /**
   * The number of structural features of the '<em>Fact</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FACT_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link environment.impl.SemanticWebAgentImpl <em>Semantic Web Agent</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see environment.impl.SemanticWebAgentImpl
   * @see environment.impl.EnvironmentPackageImpl#getSemanticWebAgent()
   * @generated
   */
  int SEMANTIC_WEB_AGENT = 4;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEMANTIC_WEB_AGENT__NAME = 0;

  /**
   * The feature id for the '<em><b>Access</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEMANTIC_WEB_AGENT__ACCESS = 1;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEMANTIC_WEB_AGENT__DESCRIPTION = 2;

  /**
   * The feature id for the '<em><b>Properties</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEMANTIC_WEB_AGENT__PROPERTIES = 3;

  /**
   * The number of structural features of the '<em>Semantic Web Agent</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEMANTIC_WEB_AGENT_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link environment.impl.ResourceImpl <em>Resource</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see environment.impl.ResourceImpl
   * @see environment.impl.EnvironmentPackageImpl#getResource()
   * @generated
   */
  int RESOURCE = 5;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__NAME = 0;

  /**
   * The number of structural features of the '<em>Resource</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE_FEATURE_COUNT = 1;


  /**
   * Returns the meta object for class '{@link environment.EnvironmentViewpoint <em>Viewpoint</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Viewpoint</em>'.
   * @see environment.EnvironmentViewpoint
   * @generated
   */
  EClass getEnvironmentViewpoint();

  /**
   * Returns the meta object for the containment reference list '{@link environment.EnvironmentViewpoint#getHasService <em>Has Service</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Service</em>'.
   * @see environment.EnvironmentViewpoint#getHasService()
   * @see #getEnvironmentViewpoint()
   * @generated
   */
  EReference getEnvironmentViewpoint_HasService();

  /**
   * Returns the meta object for the containment reference list '{@link environment.EnvironmentViewpoint#getHasEnvironment <em>Has Environment</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Environment</em>'.
   * @see environment.EnvironmentViewpoint#getHasEnvironment()
   * @see #getEnvironmentViewpoint()
   * @generated
   */
  EReference getEnvironmentViewpoint_HasEnvironment();

  /**
   * Returns the meta object for the containment reference list '{@link environment.EnvironmentViewpoint#getHasFact <em>Has Fact</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Fact</em>'.
   * @see environment.EnvironmentViewpoint#getHasFact()
   * @see #getEnvironmentViewpoint()
   * @generated
   */
  EReference getEnvironmentViewpoint_HasFact();

  /**
   * Returns the meta object for the containment reference list '{@link environment.EnvironmentViewpoint#getHasSWA <em>Has SWA</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has SWA</em>'.
   * @see environment.EnvironmentViewpoint#getHasSWA()
   * @see #getEnvironmentViewpoint()
   * @generated
   */
  EReference getEnvironmentViewpoint_HasSWA();

  /**
   * Returns the meta object for the containment reference list '{@link environment.EnvironmentViewpoint#getHasResource <em>Has Resource</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Resource</em>'.
   * @see environment.EnvironmentViewpoint#getHasResource()
   * @see #getEnvironmentViewpoint()
   * @generated
   */
  EReference getEnvironmentViewpoint_HasResource();

  /**
   * Returns the meta object for class '{@link environment.Service <em>Service</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Service</em>'.
   * @see environment.Service
   * @generated
   */
  EClass getService();

  /**
   * Returns the meta object for the attribute '{@link environment.Service#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see environment.Service#getName()
   * @see #getService()
   * @generated
   */
  EAttribute getService_Name();

  /**
   * Returns the meta object for class '{@link environment.Environment <em>Environment</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Environment</em>'.
   * @see environment.Environment
   * @generated
   */
  EClass getEnvironment();

  /**
   * Returns the meta object for the attribute '{@link environment.Environment#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see environment.Environment#getName()
   * @see #getEnvironment()
   * @generated
   */
  EAttribute getEnvironment_Name();

  /**
   * Returns the meta object for the containment reference list '{@link environment.Environment#getHasResource <em>Has Resource</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Resource</em>'.
   * @see environment.Environment#getHasResource()
   * @see #getEnvironment()
   * @generated
   */
  EReference getEnvironment_HasResource();

  /**
   * Returns the meta object for the containment reference list '{@link environment.Environment#getHasService <em>Has Service</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Service</em>'.
   * @see environment.Environment#getHasService()
   * @see #getEnvironment()
   * @generated
   */
  EReference getEnvironment_HasService();

  /**
   * Returns the meta object for the containment reference list '{@link environment.Environment#getHasFact <em>Has Fact</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Fact</em>'.
   * @see environment.Environment#getHasFact()
   * @see #getEnvironment()
   * @generated
   */
  EReference getEnvironment_HasFact();

  /**
   * Returns the meta object for class '{@link environment.Fact <em>Fact</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Fact</em>'.
   * @see environment.Fact
   * @generated
   */
  EClass getFact();

  /**
   * Returns the meta object for the attribute '{@link environment.Fact#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see environment.Fact#getName()
   * @see #getFact()
   * @generated
   */
  EAttribute getFact_Name();

  /**
   * Returns the meta object for class '{@link environment.SemanticWebAgent <em>Semantic Web Agent</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Semantic Web Agent</em>'.
   * @see environment.SemanticWebAgent
   * @generated
   */
  EClass getSemanticWebAgent();

  /**
   * Returns the meta object for the attribute '{@link environment.SemanticWebAgent#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see environment.SemanticWebAgent#getName()
   * @see #getSemanticWebAgent()
   * @generated
   */
  EAttribute getSemanticWebAgent_Name();

  /**
   * Returns the meta object for the reference list '{@link environment.SemanticWebAgent#getAccess <em>Access</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Access</em>'.
   * @see environment.SemanticWebAgent#getAccess()
   * @see #getSemanticWebAgent()
   * @generated
   */
  EReference getSemanticWebAgent_Access();

  /**
   * Returns the meta object for the attribute '{@link environment.SemanticWebAgent#getDescription <em>Description</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Description</em>'.
   * @see environment.SemanticWebAgent#getDescription()
   * @see #getSemanticWebAgent()
   * @generated
   */
  EAttribute getSemanticWebAgent_Description();

  /**
   * Returns the meta object for the attribute '{@link environment.SemanticWebAgent#getProperties <em>Properties</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Properties</em>'.
   * @see environment.SemanticWebAgent#getProperties()
   * @see #getSemanticWebAgent()
   * @generated
   */
  EAttribute getSemanticWebAgent_Properties();

  /**
   * Returns the meta object for class '{@link environment.Resource <em>Resource</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Resource</em>'.
   * @see environment.Resource
   * @generated
   */
  EClass getResource();

  /**
   * Returns the meta object for the attribute '{@link environment.Resource#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see environment.Resource#getName()
   * @see #getResource()
   * @generated
   */
  EAttribute getResource_Name();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  EnvironmentFactory getEnvironmentFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link environment.impl.EnvironmentViewpointImpl <em>Viewpoint</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see environment.impl.EnvironmentViewpointImpl
     * @see environment.impl.EnvironmentPackageImpl#getEnvironmentViewpoint()
     * @generated
     */
    EClass ENVIRONMENT_VIEWPOINT = eINSTANCE.getEnvironmentViewpoint();

    /**
     * The meta object literal for the '<em><b>Has Service</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ENVIRONMENT_VIEWPOINT__HAS_SERVICE = eINSTANCE.getEnvironmentViewpoint_HasService();

    /**
     * The meta object literal for the '<em><b>Has Environment</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ENVIRONMENT_VIEWPOINT__HAS_ENVIRONMENT = eINSTANCE.getEnvironmentViewpoint_HasEnvironment();

    /**
     * The meta object literal for the '<em><b>Has Fact</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ENVIRONMENT_VIEWPOINT__HAS_FACT = eINSTANCE.getEnvironmentViewpoint_HasFact();

    /**
     * The meta object literal for the '<em><b>Has SWA</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ENVIRONMENT_VIEWPOINT__HAS_SWA = eINSTANCE.getEnvironmentViewpoint_HasSWA();

    /**
     * The meta object literal for the '<em><b>Has Resource</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ENVIRONMENT_VIEWPOINT__HAS_RESOURCE = eINSTANCE.getEnvironmentViewpoint_HasResource();

    /**
     * The meta object literal for the '{@link environment.impl.ServiceImpl <em>Service</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see environment.impl.ServiceImpl
     * @see environment.impl.EnvironmentPackageImpl#getService()
     * @generated
     */
    EClass SERVICE = eINSTANCE.getService();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SERVICE__NAME = eINSTANCE.getService_Name();

    /**
     * The meta object literal for the '{@link environment.impl.EnvironmentImpl <em>Environment</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see environment.impl.EnvironmentImpl
     * @see environment.impl.EnvironmentPackageImpl#getEnvironment()
     * @generated
     */
    EClass ENVIRONMENT = eINSTANCE.getEnvironment();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ENVIRONMENT__NAME = eINSTANCE.getEnvironment_Name();

    /**
     * The meta object literal for the '<em><b>Has Resource</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ENVIRONMENT__HAS_RESOURCE = eINSTANCE.getEnvironment_HasResource();

    /**
     * The meta object literal for the '<em><b>Has Service</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ENVIRONMENT__HAS_SERVICE = eINSTANCE.getEnvironment_HasService();

    /**
     * The meta object literal for the '<em><b>Has Fact</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ENVIRONMENT__HAS_FACT = eINSTANCE.getEnvironment_HasFact();

    /**
     * The meta object literal for the '{@link environment.impl.FactImpl <em>Fact</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see environment.impl.FactImpl
     * @see environment.impl.EnvironmentPackageImpl#getFact()
     * @generated
     */
    EClass FACT = eINSTANCE.getFact();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FACT__NAME = eINSTANCE.getFact_Name();

    /**
     * The meta object literal for the '{@link environment.impl.SemanticWebAgentImpl <em>Semantic Web Agent</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see environment.impl.SemanticWebAgentImpl
     * @see environment.impl.EnvironmentPackageImpl#getSemanticWebAgent()
     * @generated
     */
    EClass SEMANTIC_WEB_AGENT = eINSTANCE.getSemanticWebAgent();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SEMANTIC_WEB_AGENT__NAME = eINSTANCE.getSemanticWebAgent_Name();

    /**
     * The meta object literal for the '<em><b>Access</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SEMANTIC_WEB_AGENT__ACCESS = eINSTANCE.getSemanticWebAgent_Access();

    /**
     * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SEMANTIC_WEB_AGENT__DESCRIPTION = eINSTANCE.getSemanticWebAgent_Description();

    /**
     * The meta object literal for the '<em><b>Properties</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SEMANTIC_WEB_AGENT__PROPERTIES = eINSTANCE.getSemanticWebAgent_Properties();

    /**
     * The meta object literal for the '{@link environment.impl.ResourceImpl <em>Resource</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see environment.impl.ResourceImpl
     * @see environment.impl.EnvironmentPackageImpl#getResource()
     * @generated
     */
    EClass RESOURCE = eINSTANCE.getResource();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute RESOURCE__NAME = eINSTANCE.getResource_Name();

  }

} //EnvironmentPackage
