/*
 * 
 */
package interaction.diagram.edit.parts;

import interaction.diagram.part.InteractionVisualIDRegistry;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.directedit.locator.CellEditorLocatorAccess;

/**
 * @generated
 */
public class InteractionEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (InteractionVisualIDRegistry.getVisualID(view)) {

			case InteractionViewpointEditPart.VISUAL_ID:
				return new InteractionViewpointEditPart(view);

			case InteractionEditPart.VISUAL_ID:
				return new InteractionEditPart(view);

			case InteractionNameEditPart.VISUAL_ID:
				return new InteractionNameEditPart(view);

			case MessageEditPart.VISUAL_ID:
				return new MessageEditPart(view);

			case MessagePerformativeEditPart.VISUAL_ID:
				return new MessagePerformativeEditPart(view);

			case MessageSequenceEditPart.VISUAL_ID:
				return new MessageSequenceEditPart(view);

			case MessageSequenceNameEditPart.VISUAL_ID:
				return new MessageSequenceNameEditPart(view);

			case InteractionIncludesEditPart.VISUAL_ID:
				return new InteractionIncludesEditPart(view);

			case InteractionIncludesExternalLabelEditPart.VISUAL_ID:
				return new InteractionIncludesExternalLabelEditPart(view);

			case InteractionHasEditPart.VISUAL_ID:
				return new InteractionHasEditPart(view);

			case InteractionHasExternalLabelEditPart.VISUAL_ID:
				return new InteractionHasExternalLabelEditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		return CellEditorLocatorAccess.INSTANCE
				.getTextCellEditorLocator(source);
	}

}
