/*
 * 
 */
package interaction.diagram.edit.policies;

import interaction.diagram.edit.commands.InteractionCreateCommand;
import interaction.diagram.edit.commands.MessageCreateCommand;
import interaction.diagram.edit.commands.MessageSequenceCreateCommand;
import interaction.diagram.providers.InteractionElementTypes;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

/**
 * @generated
 */
public class InteractionViewpointItemSemanticEditPolicy extends
		InteractionBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public InteractionViewpointItemSemanticEditPolicy() {
		super(InteractionElementTypes.InteractionViewpoint_1000);
	}

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (InteractionElementTypes.Interaction_2001 == req.getElementType()) {
			return getGEFWrapper(new InteractionCreateCommand(req));
		}
		if (InteractionElementTypes.Message_2002 == req.getElementType()) {
			return getGEFWrapper(new MessageCreateCommand(req));
		}
		if (InteractionElementTypes.MessageSequence_2003 == req
				.getElementType()) {
			return getGEFWrapper(new MessageSequenceCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
