/*
 * 
 */
package interaction.diagram.navigator;

import interaction.diagram.edit.parts.InteractionEditPart;
import interaction.diagram.edit.parts.InteractionHasEditPart;
import interaction.diagram.edit.parts.InteractionIncludesEditPart;
import interaction.diagram.edit.parts.InteractionNameEditPart;
import interaction.diagram.edit.parts.InteractionViewpointEditPart;
import interaction.diagram.edit.parts.MessageEditPart;
import interaction.diagram.edit.parts.MessagePerformativeEditPart;
import interaction.diagram.edit.parts.MessageSequenceEditPart;
import interaction.diagram.edit.parts.MessageSequenceIdEditPart;
import interaction.diagram.edit.parts.MessageSequenceNameEditPart;
import interaction.diagram.part.InteractionDiagramEditorPlugin;
import interaction.diagram.part.InteractionVisualIDRegistry;
import interaction.diagram.providers.InteractionElementTypes;
import interaction.diagram.providers.InteractionParserProvider;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.common.ui.services.parser.CommonParserHint;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

/**
 * @generated
 */
public class InteractionNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		InteractionDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		InteractionDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof InteractionNavigatorItem
				&& !isOwnView(((InteractionNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof InteractionNavigatorGroup) {
			InteractionNavigatorGroup group = (InteractionNavigatorGroup) element;
			return InteractionDiagramEditorPlugin.getInstance()
					.getBundledImage(group.getIcon());
		}

		if (element instanceof InteractionNavigatorItem) {
			InteractionNavigatorItem navigatorItem = (InteractionNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getImage(view);
			}
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (InteractionVisualIDRegistry.getVisualID(view)) {
		case InteractionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?interaction?Interaction", InteractionElementTypes.Interaction_2001); //$NON-NLS-1$
		case MessageSequenceEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?interaction?MessageSequence", InteractionElementTypes.MessageSequence_2003); //$NON-NLS-1$
		case InteractionHasEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?interaction?Interaction?has", InteractionElementTypes.InteractionHas_4002); //$NON-NLS-1$
		case InteractionIncludesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?interaction?Interaction?includes", InteractionElementTypes.InteractionIncludes_4001); //$NON-NLS-1$
		case MessageEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?interaction?Message", InteractionElementTypes.Message_2002); //$NON-NLS-1$
		case InteractionViewpointEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?interaction?InteractionViewpoint", InteractionElementTypes.InteractionViewpoint_1000); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = InteractionDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& InteractionElementTypes.isKnownElementType(elementType)) {
			image = InteractionElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof InteractionNavigatorGroup) {
			InteractionNavigatorGroup group = (InteractionNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof InteractionNavigatorItem) {
			InteractionNavigatorItem navigatorItem = (InteractionNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getText(view);
			}
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (InteractionVisualIDRegistry.getVisualID(view)) {
		case InteractionEditPart.VISUAL_ID:
			return getInteraction_2001Text(view);
		case MessageSequenceEditPart.VISUAL_ID:
			return getMessageSequence_2003Text(view);
		case InteractionHasEditPart.VISUAL_ID:
			return getInteractionHas_4002Text(view);
		case InteractionIncludesEditPart.VISUAL_ID:
			return getInteractionIncludes_4001Text(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_2002Text(view);
		case InteractionViewpointEditPart.VISUAL_ID:
			return getInteractionViewpoint_1000Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getInteractionHas_4002Text(View view) {
		IParser parser = InteractionParserProvider.getParser(
				InteractionElementTypes.InteractionHas_4002,
				view.getElement() != null ? view.getElement() : view,
				CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			InteractionDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getInteractionIncludes_4001Text(View view) {
		IParser parser = InteractionParserProvider.getParser(
				InteractionElementTypes.InteractionIncludes_4001,
				view.getElement() != null ? view.getElement() : view,
				CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			InteractionDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getInteraction_2001Text(View view) {
		IParser parser = InteractionParserProvider.getParser(
				InteractionElementTypes.Interaction_2001,
				view.getElement() != null ? view.getElement() : view,
				InteractionVisualIDRegistry
						.getType(InteractionNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			InteractionDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getInteractionViewpoint_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getMessage_2002Text(View view) {
		IParser parser = InteractionParserProvider.getParser(
				InteractionElementTypes.Message_2002,
				view.getElement() != null ? view.getElement() : view,
				InteractionVisualIDRegistry
						.getType(MessagePerformativeEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			InteractionDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMessageSequence_2003Text(View view) {
		IParser parser = InteractionParserProvider.getParser(
				InteractionElementTypes.MessageSequence_2003,
				view.getElement() != null ? view.getElement() : view,
				InteractionVisualIDRegistry
						.getType(MessageSequenceNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			InteractionDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return InteractionViewpointEditPart.MODEL_ID
				.equals(InteractionVisualIDRegistry.getModelID(view));
	}

}
