/*
 * 
 */
package interaction.diagram.part;

import interaction.Interaction;
import interaction.InteractionPackage;
import interaction.InteractionViewpoint;
import interaction.Message;
import interaction.MessageSequence;
import interaction.diagram.edit.parts.InteractionEditPart;
import interaction.diagram.edit.parts.InteractionHasEditPart;
import interaction.diagram.edit.parts.InteractionIncludesEditPart;
import interaction.diagram.edit.parts.InteractionViewpointEditPart;
import interaction.diagram.edit.parts.MessageEditPart;
import interaction.diagram.edit.parts.MessageSequenceEditPart;
import interaction.diagram.providers.InteractionElementTypes;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.update.DiagramUpdater;

/**
 * @generated
 */
public class InteractionDiagramUpdater {

	/**
	 * @generated
	 */
	public static boolean isShortcutOrphaned(View view) {
		return !view.isSetElement() || view.getElement() == null
				|| view.getElement().eIsProxy();
	}

	/**
	 * @generated
	 */
	public static List<InteractionNodeDescriptor> getSemanticChildren(View view) {
		switch (InteractionVisualIDRegistry.getVisualID(view)) {
		case InteractionViewpointEditPart.VISUAL_ID:
			return getInteractionViewpoint_1000SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<InteractionNodeDescriptor> getInteractionViewpoint_1000SemanticChildren(
			View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		InteractionViewpoint modelElement = (InteractionViewpoint) view
				.getElement();
		LinkedList<InteractionNodeDescriptor> result = new LinkedList<InteractionNodeDescriptor>();
		for (Iterator<?> it = modelElement.getInteraction().iterator(); it
				.hasNext();) {
			Interaction childElement = (Interaction) it.next();
			int visualID = InteractionVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == InteractionEditPart.VISUAL_ID) {
				result.add(new InteractionNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getHasMessage().iterator(); it
				.hasNext();) {
			Message childElement = (Message) it.next();
			int visualID = InteractionVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == MessageEditPart.VISUAL_ID) {
				result.add(new InteractionNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getHasMessageSequence().iterator(); it
				.hasNext();) {
			MessageSequence childElement = (MessageSequence) it.next();
			int visualID = InteractionVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == MessageSequenceEditPart.VISUAL_ID) {
				result.add(new InteractionNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getContainedLinks(View view) {
		switch (InteractionVisualIDRegistry.getVisualID(view)) {
		case InteractionViewpointEditPart.VISUAL_ID:
			return getInteractionViewpoint_1000ContainedLinks(view);
		case InteractionEditPart.VISUAL_ID:
			return getInteraction_2001ContainedLinks(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_2002ContainedLinks(view);
		case MessageSequenceEditPart.VISUAL_ID:
			return getMessageSequence_2003ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getIncomingLinks(View view) {
		switch (InteractionVisualIDRegistry.getVisualID(view)) {
		case InteractionEditPart.VISUAL_ID:
			return getInteraction_2001IncomingLinks(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_2002IncomingLinks(view);
		case MessageSequenceEditPart.VISUAL_ID:
			return getMessageSequence_2003IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getOutgoingLinks(View view) {
		switch (InteractionVisualIDRegistry.getVisualID(view)) {
		case InteractionEditPart.VISUAL_ID:
			return getInteraction_2001OutgoingLinks(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_2002OutgoingLinks(view);
		case MessageSequenceEditPart.VISUAL_ID:
			return getMessageSequence_2003OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getInteractionViewpoint_1000ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getInteraction_2001ContainedLinks(
			View view) {
		Interaction modelElement = (Interaction) view.getElement();
		LinkedList<InteractionLinkDescriptor> result = new LinkedList<InteractionLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Interaction_Includes_4001(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Interaction_Has_4002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getMessage_2002ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getMessageSequence_2003ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getInteraction_2001IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getMessage_2002IncomingLinks(
			View view) {
		Message modelElement = (Message) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<InteractionLinkDescriptor> result = new LinkedList<InteractionLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_Interaction_Includes_4001(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getMessageSequence_2003IncomingLinks(
			View view) {
		MessageSequence modelElement = (MessageSequence) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<InteractionLinkDescriptor> result = new LinkedList<InteractionLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_Interaction_Has_4002(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getInteraction_2001OutgoingLinks(
			View view) {
		Interaction modelElement = (Interaction) view.getElement();
		LinkedList<InteractionLinkDescriptor> result = new LinkedList<InteractionLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Interaction_Includes_4001(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Interaction_Has_4002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getMessage_2002OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<InteractionLinkDescriptor> getMessageSequence_2003OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	private static Collection<InteractionLinkDescriptor> getIncomingFeatureModelFacetLinks_Interaction_Includes_4001(
			Message target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<InteractionLinkDescriptor> result = new LinkedList<InteractionLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == InteractionPackage.eINSTANCE
					.getInteraction_Includes()) {
				result.add(new InteractionLinkDescriptor(setting.getEObject(),
						target,
						InteractionElementTypes.InteractionIncludes_4001,
						InteractionIncludesEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<InteractionLinkDescriptor> getIncomingFeatureModelFacetLinks_Interaction_Has_4002(
			MessageSequence target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<InteractionLinkDescriptor> result = new LinkedList<InteractionLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == InteractionPackage.eINSTANCE
					.getInteraction_Has()) {
				result.add(new InteractionLinkDescriptor(setting.getEObject(),
						target, InteractionElementTypes.InteractionHas_4002,
						InteractionHasEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<InteractionLinkDescriptor> getOutgoingFeatureModelFacetLinks_Interaction_Includes_4001(
			Interaction source) {
		LinkedList<InteractionLinkDescriptor> result = new LinkedList<InteractionLinkDescriptor>();
		for (Iterator<?> destinations = source.getIncludes().iterator(); destinations
				.hasNext();) {
			Message destination = (Message) destinations.next();
			result.add(new InteractionLinkDescriptor(source, destination,
					InteractionElementTypes.InteractionIncludes_4001,
					InteractionIncludesEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<InteractionLinkDescriptor> getOutgoingFeatureModelFacetLinks_Interaction_Has_4002(
			Interaction source) {
		LinkedList<InteractionLinkDescriptor> result = new LinkedList<InteractionLinkDescriptor>();
		MessageSequence destination = source.getHas();
		if (destination == null) {
			return result;
		}
		result.add(new InteractionLinkDescriptor(source, destination,
				InteractionElementTypes.InteractionHas_4002,
				InteractionHasEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	public static final DiagramUpdater TYPED_INSTANCE = new DiagramUpdater() {
		/**
		 * @generated
		 */
		@Override
		public List<InteractionNodeDescriptor> getSemanticChildren(View view) {
			return InteractionDiagramUpdater.getSemanticChildren(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<InteractionLinkDescriptor> getContainedLinks(View view) {
			return InteractionDiagramUpdater.getContainedLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<InteractionLinkDescriptor> getIncomingLinks(View view) {
			return InteractionDiagramUpdater.getIncomingLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<InteractionLinkDescriptor> getOutgoingLinks(View view) {
			return InteractionDiagramUpdater.getOutgoingLinks(view);
		}
	};

}
