/*
 * 
 */
package interaction.diagram.part;

import interaction.diagram.providers.InteractionElementTypes;

import java.util.Collections;
import java.util.List;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;

/**
 * @generated
 */
public class InteractionPaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createObjects1Group());
		paletteRoot.add(createConnections2Group());
	}

	/**
	 * Creates "Objects" palette tool group
	 * @generated
	 */
	private PaletteContainer createObjects1Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Objects1Group_title);
		paletteContainer.setId("createObjects1Group"); //$NON-NLS-1$
		paletteContainer.add(createInteraction1CreationTool());
		paletteContainer.add(createMessage2CreationTool());
		paletteContainer.add(createMessageSequence3CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Connections" palette tool group
	 * @generated
	 */
	private PaletteContainer createConnections2Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Connections2Group_title);
		paletteContainer.setId("createConnections2Group"); //$NON-NLS-1$
		paletteContainer.add(createHas1CreationTool());
		paletteContainer.add(createIncludes2CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createInteraction1CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Interaction1CreationTool_title,
				Messages.Interaction1CreationTool_desc,
				Collections
						.singletonList(InteractionElementTypes.Interaction_2001));
		entry.setId("createInteraction1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(InteractionElementTypes
				.getImageDescriptor(InteractionElementTypes.Interaction_2001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMessage2CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Message2CreationTool_title,
				Messages.Message2CreationTool_desc,
				Collections.singletonList(InteractionElementTypes.Message_2002));
		entry.setId("createMessage2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(InteractionElementTypes
				.getImageDescriptor(InteractionElementTypes.Message_2002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMessageSequence3CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.MessageSequence3CreationTool_title,
				Messages.MessageSequence3CreationTool_desc,
				Collections
						.singletonList(InteractionElementTypes.MessageSequence_2003));
		entry.setId("createMessageSequence3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(InteractionElementTypes
				.getImageDescriptor(InteractionElementTypes.MessageSequence_2003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createHas1CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Has1CreationTool_title,
				Messages.Has1CreationTool_desc,
				Collections
						.singletonList(InteractionElementTypes.InteractionHas_4002));
		entry.setId("createHas1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(InteractionElementTypes
				.getImageDescriptor(InteractionElementTypes.InteractionHas_4002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createIncludes2CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Includes2CreationTool_title,
				Messages.Includes2CreationTool_desc,
				Collections
						.singletonList(InteractionElementTypes.InteractionIncludes_4001));
		entry.setId("createIncludes2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(InteractionElementTypes
				.getImageDescriptor(InteractionElementTypes.InteractionIncludes_4001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				List<IElementType> elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				List<IElementType> relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
