/*
 * 
 */
package interaction.diagram.part;

import interaction.InteractionPackage;
import interaction.InteractionViewpoint;
import interaction.diagram.edit.parts.InteractionEditPart;
import interaction.diagram.edit.parts.InteractionHasEditPart;
import interaction.diagram.edit.parts.InteractionHasExternalLabelEditPart;
import interaction.diagram.edit.parts.InteractionIncludesEditPart;
import interaction.diagram.edit.parts.InteractionIncludesExternalLabelEditPart;
import interaction.diagram.edit.parts.InteractionNameEditPart;
import interaction.diagram.edit.parts.InteractionViewpointEditPart;
import interaction.diagram.edit.parts.MessageEditPart;
import interaction.diagram.edit.parts.MessagePerformativeEditPart;

import interaction.diagram.edit.parts.MessageSequenceEditPart;
import interaction.diagram.edit.parts.MessageSequenceIdEditPart;
import interaction.diagram.edit.parts.MessageSequenceNameEditPart;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class InteractionVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "Interaction.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (InteractionViewpointEditPart.MODEL_ID.equals(view.getType())) {
				return InteractionViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return interaction.diagram.part.InteractionVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				InteractionDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (InteractionPackage.eINSTANCE.getInteractionViewpoint()
				.isSuperTypeOf(domainElement.eClass())
				&& isDiagram((InteractionViewpoint) domainElement)) {
			return InteractionViewpointEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = interaction.diagram.part.InteractionVisualIDRegistry
				.getModelID(containerView);
		if (!InteractionViewpointEditPart.MODEL_ID.equals(containerModelID)
				&& !"interaction".equals(containerModelID)) { //$NON-NLS-1$
			return -1;
		}
		int containerVisualID;
		if (InteractionViewpointEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = interaction.diagram.part.InteractionVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = InteractionViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case InteractionViewpointEditPart.VISUAL_ID:
			if (InteractionPackage.eINSTANCE.getInteraction().isSuperTypeOf(
					domainElement.eClass())) {
				return InteractionEditPart.VISUAL_ID;
			}
			if (InteractionPackage.eINSTANCE.getMessage().isSuperTypeOf(
					domainElement.eClass())) {
				return MessageEditPart.VISUAL_ID;
			}
			if (InteractionPackage.eINSTANCE.getMessageSequence()
					.isSuperTypeOf(domainElement.eClass())) {
				return MessageSequenceEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = interaction.diagram.part.InteractionVisualIDRegistry
				.getModelID(containerView);
		if (!InteractionViewpointEditPart.MODEL_ID.equals(containerModelID)
				&& !"interaction".equals(containerModelID)) { //$NON-NLS-1$
			return false;
		}
		int containerVisualID;
		if (InteractionViewpointEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = interaction.diagram.part.InteractionVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = InteractionViewpointEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case InteractionViewpointEditPart.VISUAL_ID:
			if (InteractionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MessageEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MessageSequenceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InteractionEditPart.VISUAL_ID:
			if (InteractionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MessageEditPart.VISUAL_ID:
			if (MessagePerformativeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MessageSequenceEditPart.VISUAL_ID:
			if (MessageSequenceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InteractionIncludesEditPart.VISUAL_ID:
			if (InteractionIncludesExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InteractionHasEditPart.VISUAL_ID:
			if (InteractionHasExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(InteractionViewpoint element) {
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView,
			EObject domainElement, int candidate) {
		if (candidate == -1) {
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID) {
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID) {
		switch (visualID) {
		case InteractionViewpointEditPart.VISUAL_ID:
			return false;
		case InteractionEditPart.VISUAL_ID:
		case MessageEditPart.VISUAL_ID:
		case MessageSequenceEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure TYPED_INSTANCE = new DiagramStructure() {
		/**
		 * @generated
		 */
		@Override
		public int getVisualID(View view) {
			return interaction.diagram.part.InteractionVisualIDRegistry
					.getVisualID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public String getModelID(View view) {
			return interaction.diagram.part.InteractionVisualIDRegistry
					.getModelID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public int getNodeVisualID(View containerView, EObject domainElement) {
			return interaction.diagram.part.InteractionVisualIDRegistry
					.getNodeVisualID(containerView, domainElement);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean checkNodeVisualID(View containerView,
				EObject domainElement, int candidate) {
			return interaction.diagram.part.InteractionVisualIDRegistry
					.checkNodeVisualID(containerView, domainElement, candidate);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isCompartmentVisualID(int visualID) {
			return interaction.diagram.part.InteractionVisualIDRegistry
					.isCompartmentVisualID(visualID);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isSemanticLeafVisualID(int visualID) {
			return interaction.diagram.part.InteractionVisualIDRegistry
					.isSemanticLeafVisualID(visualID);
		}
	};

}
