/*
 * 
 */
package interaction.diagram.providers;

import interaction.InteractionPackage;
import interaction.diagram.edit.parts.InteractionEditPart;
import interaction.diagram.edit.parts.InteractionHasEditPart;
import interaction.diagram.edit.parts.InteractionIncludesEditPart;
import interaction.diagram.edit.parts.InteractionViewpointEditPart;
import interaction.diagram.edit.parts.MessageEditPart;
import interaction.diagram.edit.parts.MessageSequenceEditPart;
import interaction.diagram.part.InteractionDiagramEditorPlugin;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

/**
 * @generated
 */
public class InteractionElementTypes {

	/**
	 * @generated
	 */
	private InteractionElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType InteractionViewpoint_1000 = getElementType("Interaction.diagram.InteractionViewpoint_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Interaction_2001 = getElementType("Interaction.diagram.Interaction_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Message_2002 = getElementType("Interaction.diagram.Message_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType MessageSequence_2003 = getElementType("Interaction.diagram.MessageSequence_2003"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final IElementType InteractionIncludes_4001 = getElementType("Interaction.diagram.InteractionIncludes_4001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType InteractionHas_4002 = getElementType("Interaction.diagram.InteractionHas_4002"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return InteractionDiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(InteractionViewpoint_1000,
					InteractionPackage.eINSTANCE.getInteractionViewpoint());

			elements.put(Interaction_2001,
					InteractionPackage.eINSTANCE.getInteraction());

			elements.put(Message_2002,
					InteractionPackage.eINSTANCE.getMessage());

			elements.put(MessageSequence_2003,
					InteractionPackage.eINSTANCE.getMessageSequence());

			elements.put(InteractionIncludes_4001,
					InteractionPackage.eINSTANCE.getInteraction_Includes());

			elements.put(InteractionHas_4002,
					InteractionPackage.eINSTANCE.getInteraction_Has());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(InteractionViewpoint_1000);
			KNOWN_ELEMENT_TYPES.add(Interaction_2001);
			KNOWN_ELEMENT_TYPES.add(Message_2002);
			KNOWN_ELEMENT_TYPES.add(MessageSequence_2003);
			KNOWN_ELEMENT_TYPES.add(InteractionIncludes_4001);
			KNOWN_ELEMENT_TYPES.add(InteractionHas_4002);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case InteractionViewpointEditPart.VISUAL_ID:
			return InteractionViewpoint_1000;
		case InteractionEditPart.VISUAL_ID:
			return Interaction_2001;
		case MessageEditPart.VISUAL_ID:
			return Message_2002;
		case MessageSequenceEditPart.VISUAL_ID:
			return MessageSequence_2003;
		case InteractionIncludesEditPart.VISUAL_ID:
			return InteractionIncludes_4001;
		case InteractionHasEditPart.VISUAL_ID:
			return InteractionHas_4002;
		}
		return null;
	}

}
