/**
 */
package interaction;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see interaction.InteractionFactory
 * @model kind="package"
 * @generated
 */
public interface InteractionPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "interaction";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "interaction";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "interaction";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  InteractionPackage eINSTANCE = interaction.impl.InteractionPackageImpl.init();

  /**
   * The meta object id for the '{@link interaction.impl.InteractionViewpointImpl <em>Viewpoint</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see interaction.impl.InteractionViewpointImpl
   * @see interaction.impl.InteractionPackageImpl#getInteractionViewpoint()
   * @generated
   */
  int INTERACTION_VIEWPOINT = 0;

  /**
   * The feature id for the '<em><b>Has Message</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERACTION_VIEWPOINT__HAS_MESSAGE = 0;

  /**
   * The feature id for the '<em><b>Interaction</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERACTION_VIEWPOINT__INTERACTION = 1;

  /**
   * The feature id for the '<em><b>Has Message Sequence</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERACTION_VIEWPOINT__HAS_MESSAGE_SEQUENCE = 2;

  /**
   * The number of structural features of the '<em>Viewpoint</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERACTION_VIEWPOINT_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link interaction.impl.FIPAContractNetImpl <em>FIPA Contract Net</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see interaction.impl.FIPAContractNetImpl
   * @see interaction.impl.InteractionPackageImpl#getFIPAContractNet()
   * @generated
   */
  int FIPA_CONTRACT_NET = 1;

  /**
   * The feature id for the '<em><b>Spec no</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FIPA_CONTRACT_NET__SPEC_NO = 0;

  /**
   * The number of structural features of the '<em>FIPA Contract Net</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FIPA_CONTRACT_NET_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link interaction.impl.MessageImpl <em>Message</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see interaction.impl.MessageImpl
   * @see interaction.impl.InteractionPackageImpl#getMessage()
   * @generated
   */
  int MESSAGE = 2;

  /**
   * The feature id for the '<em><b>Content language</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__CONTENT_LANGUAGE = 0;

  /**
   * The feature id for the '<em><b>Sender</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__SENDER = 1;

  /**
   * The feature id for the '<em><b>Receiver</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__RECEIVER = 2;

  /**
   * The feature id for the '<em><b>Performative</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__PERFORMATIVE = 3;

  /**
   * The feature id for the '<em><b>Msg Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__MSG_TYPE = 4;

  /**
   * The feature id for the '<em><b>Content</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__CONTENT = 5;

  /**
   * The number of structural features of the '<em>Message</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE_FEATURE_COUNT = 6;

  /**
   * The meta object id for the '{@link interaction.impl.InteractionImpl <em>Interaction</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see interaction.impl.InteractionImpl
   * @see interaction.impl.InteractionPackageImpl#getInteraction()
   * @generated
   */
  int INTERACTION = 3;

  /**
   * The feature id for the '<em><b>Spec no</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERACTION__SPEC_NO = FIPA_CONTRACT_NET__SPEC_NO;

  /**
   * The feature id for the '<em><b>Includes</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERACTION__INCLUDES = FIPA_CONTRACT_NET_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Has</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERACTION__HAS = FIPA_CONTRACT_NET_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERACTION__NAME = FIPA_CONTRACT_NET_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Interaction</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERACTION_FEATURE_COUNT = FIPA_CONTRACT_NET_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link interaction.impl.MessageSequenceImpl <em>Message Sequence</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see interaction.impl.MessageSequenceImpl
   * @see interaction.impl.InteractionPackageImpl#getMessageSequence()
   * @generated
   */
  int MESSAGE_SEQUENCE = 4;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE_SEQUENCE__NAME = 0;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE_SEQUENCE__ID = 1;

  /**
   * The number of structural features of the '<em>Message Sequence</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE_SEQUENCE_FEATURE_COUNT = 2;


  /**
   * Returns the meta object for class '{@link interaction.InteractionViewpoint <em>Viewpoint</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Viewpoint</em>'.
   * @see interaction.InteractionViewpoint
   * @generated
   */
  EClass getInteractionViewpoint();

  /**
   * Returns the meta object for the containment reference list '{@link interaction.InteractionViewpoint#getHasMessage <em>Has Message</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Message</em>'.
   * @see interaction.InteractionViewpoint#getHasMessage()
   * @see #getInteractionViewpoint()
   * @generated
   */
  EReference getInteractionViewpoint_HasMessage();

  /**
   * Returns the meta object for the containment reference list '{@link interaction.InteractionViewpoint#getInteraction <em>Interaction</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Interaction</em>'.
   * @see interaction.InteractionViewpoint#getInteraction()
   * @see #getInteractionViewpoint()
   * @generated
   */
  EReference getInteractionViewpoint_Interaction();

  /**
   * Returns the meta object for the containment reference list '{@link interaction.InteractionViewpoint#getHasMessageSequence <em>Has Message Sequence</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Message Sequence</em>'.
   * @see interaction.InteractionViewpoint#getHasMessageSequence()
   * @see #getInteractionViewpoint()
   * @generated
   */
  EReference getInteractionViewpoint_HasMessageSequence();

  /**
   * Returns the meta object for class '{@link interaction.FIPAContractNet <em>FIPA Contract Net</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>FIPA Contract Net</em>'.
   * @see interaction.FIPAContractNet
   * @generated
   */
  EClass getFIPAContractNet();

  /**
   * Returns the meta object for the attribute '{@link interaction.FIPAContractNet#getSpec_no <em>Spec no</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Spec no</em>'.
   * @see interaction.FIPAContractNet#getSpec_no()
   * @see #getFIPAContractNet()
   * @generated
   */
  EAttribute getFIPAContractNet_Spec_no();

  /**
   * Returns the meta object for class '{@link interaction.Message <em>Message</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Message</em>'.
   * @see interaction.Message
   * @generated
   */
  EClass getMessage();

  /**
   * Returns the meta object for the attribute '{@link interaction.Message#getContent_language <em>Content language</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Content language</em>'.
   * @see interaction.Message#getContent_language()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_Content_language();

  /**
   * Returns the meta object for the attribute '{@link interaction.Message#getSender <em>Sender</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Sender</em>'.
   * @see interaction.Message#getSender()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_Sender();

  /**
   * Returns the meta object for the attribute '{@link interaction.Message#getReceiver <em>Receiver</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Receiver</em>'.
   * @see interaction.Message#getReceiver()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_Receiver();

  /**
   * Returns the meta object for the attribute '{@link interaction.Message#getPerformative <em>Performative</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Performative</em>'.
   * @see interaction.Message#getPerformative()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_Performative();

  /**
   * Returns the meta object for the attribute '{@link interaction.Message#getMsgType <em>Msg Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Msg Type</em>'.
   * @see interaction.Message#getMsgType()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_MsgType();

  /**
   * Returns the meta object for the attribute '{@link interaction.Message#getContent <em>Content</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Content</em>'.
   * @see interaction.Message#getContent()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_Content();

  /**
   * Returns the meta object for class '{@link interaction.Interaction <em>Interaction</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Interaction</em>'.
   * @see interaction.Interaction
   * @generated
   */
  EClass getInteraction();

  /**
   * Returns the meta object for the reference list '{@link interaction.Interaction#getIncludes <em>Includes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Includes</em>'.
   * @see interaction.Interaction#getIncludes()
   * @see #getInteraction()
   * @generated
   */
  EReference getInteraction_Includes();

  /**
   * Returns the meta object for the reference '{@link interaction.Interaction#getHas <em>Has</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Has</em>'.
   * @see interaction.Interaction#getHas()
   * @see #getInteraction()
   * @generated
   */
  EReference getInteraction_Has();

  /**
   * Returns the meta object for the attribute '{@link interaction.Interaction#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see interaction.Interaction#getName()
   * @see #getInteraction()
   * @generated
   */
  EAttribute getInteraction_Name();

  /**
   * Returns the meta object for class '{@link interaction.MessageSequence <em>Message Sequence</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Message Sequence</em>'.
   * @see interaction.MessageSequence
   * @generated
   */
  EClass getMessageSequence();

  /**
   * Returns the meta object for the attribute '{@link interaction.MessageSequence#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see interaction.MessageSequence#getName()
   * @see #getMessageSequence()
   * @generated
   */
  EAttribute getMessageSequence_Name();

  /**
   * Returns the meta object for the attribute '{@link interaction.MessageSequence#getId <em>Id</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Id</em>'.
   * @see interaction.MessageSequence#getId()
   * @see #getMessageSequence()
   * @generated
   */
  EAttribute getMessageSequence_Id();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  InteractionFactory getInteractionFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link interaction.impl.InteractionViewpointImpl <em>Viewpoint</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see interaction.impl.InteractionViewpointImpl
     * @see interaction.impl.InteractionPackageImpl#getInteractionViewpoint()
     * @generated
     */
    EClass INTERACTION_VIEWPOINT = eINSTANCE.getInteractionViewpoint();

    /**
     * The meta object literal for the '<em><b>Has Message</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTERACTION_VIEWPOINT__HAS_MESSAGE = eINSTANCE.getInteractionViewpoint_HasMessage();

    /**
     * The meta object literal for the '<em><b>Interaction</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTERACTION_VIEWPOINT__INTERACTION = eINSTANCE.getInteractionViewpoint_Interaction();

    /**
     * The meta object literal for the '<em><b>Has Message Sequence</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTERACTION_VIEWPOINT__HAS_MESSAGE_SEQUENCE = eINSTANCE.getInteractionViewpoint_HasMessageSequence();

    /**
     * The meta object literal for the '{@link interaction.impl.FIPAContractNetImpl <em>FIPA Contract Net</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see interaction.impl.FIPAContractNetImpl
     * @see interaction.impl.InteractionPackageImpl#getFIPAContractNet()
     * @generated
     */
    EClass FIPA_CONTRACT_NET = eINSTANCE.getFIPAContractNet();

    /**
     * The meta object literal for the '<em><b>Spec no</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FIPA_CONTRACT_NET__SPEC_NO = eINSTANCE.getFIPAContractNet_Spec_no();

    /**
     * The meta object literal for the '{@link interaction.impl.MessageImpl <em>Message</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see interaction.impl.MessageImpl
     * @see interaction.impl.InteractionPackageImpl#getMessage()
     * @generated
     */
    EClass MESSAGE = eINSTANCE.getMessage();

    /**
     * The meta object literal for the '<em><b>Content language</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__CONTENT_LANGUAGE = eINSTANCE.getMessage_Content_language();

    /**
     * The meta object literal for the '<em><b>Sender</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__SENDER = eINSTANCE.getMessage_Sender();

    /**
     * The meta object literal for the '<em><b>Receiver</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__RECEIVER = eINSTANCE.getMessage_Receiver();

    /**
     * The meta object literal for the '<em><b>Performative</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__PERFORMATIVE = eINSTANCE.getMessage_Performative();

    /**
     * The meta object literal for the '<em><b>Msg Type</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__MSG_TYPE = eINSTANCE.getMessage_MsgType();

    /**
     * The meta object literal for the '<em><b>Content</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__CONTENT = eINSTANCE.getMessage_Content();

    /**
     * The meta object literal for the '{@link interaction.impl.InteractionImpl <em>Interaction</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see interaction.impl.InteractionImpl
     * @see interaction.impl.InteractionPackageImpl#getInteraction()
     * @generated
     */
    EClass INTERACTION = eINSTANCE.getInteraction();

    /**
     * The meta object literal for the '<em><b>Includes</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTERACTION__INCLUDES = eINSTANCE.getInteraction_Includes();

    /**
     * The meta object literal for the '<em><b>Has</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTERACTION__HAS = eINSTANCE.getInteraction_Has();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INTERACTION__NAME = eINSTANCE.getInteraction_Name();

    /**
     * The meta object literal for the '{@link interaction.impl.MessageSequenceImpl <em>Message Sequence</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see interaction.impl.MessageSequenceImpl
     * @see interaction.impl.InteractionPackageImpl#getMessageSequence()
     * @generated
     */
    EClass MESSAGE_SEQUENCE = eINSTANCE.getMessageSequence();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE_SEQUENCE__NAME = eINSTANCE.getMessageSequence_Name();

    /**
     * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE_SEQUENCE__ID = eINSTANCE.getMessageSequence_Id();

  }

} //InteractionPackage
