/*
 * 
 */
package MASandOrg.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class SemanticWebOrganizationHasReorientCommand extends
		EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public SemanticWebOrganizationHasReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == referenceOwner instanceof MASandOrg.SemanticWebOrganization) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof MASandOrg.Role && newEnd instanceof MASandOrg.SemanticWebOrganization)) {
			return false;
		}
		return MASandOrg.diagram.edit.policies.MASandOrgBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistSemanticWebOrganizationHas_4001(
						getNewSource(), getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof MASandOrg.Role && newEnd instanceof MASandOrg.Role)) {
			return false;
		}
		return MASandOrg.diagram.edit.policies.MASandOrgBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistSemanticWebOrganizationHas_4001(
						getOldSource(), getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().getHas().remove(getOldTarget());
		getNewSource().getHas().add(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().getHas().remove(getOldTarget());
		getOldSource().getHas().add(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected MASandOrg.SemanticWebOrganization getOldSource() {
		return (MASandOrg.SemanticWebOrganization) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected MASandOrg.SemanticWebOrganization getNewSource() {
		return (MASandOrg.SemanticWebOrganization) newEnd;
	}

	/**
	 * @generated
	 */
	protected MASandOrg.Role getOldTarget() {
		return (MASandOrg.Role) oldEnd;
	}

	/**
	 * @generated
	 */
	protected MASandOrg.Role getNewTarget() {
		return (MASandOrg.Role) newEnd;
	}
}
