/*
 * 
 */
package MASandOrg.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.common.core.command.ICompositeCommand;
import org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand;
import org.eclipse.gmf.runtime.emf.commands.core.command.CompositeTransactionalCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyReferenceCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyReferenceRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class SemanticWebOrganization2ItemSemanticEditPolicy extends
		MASandOrg.diagram.edit.policies.MASandOrgBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public SemanticWebOrganization2ItemSemanticEditPolicy() {
		super(
				MASandOrg.diagram.providers.MASandOrgElementTypes.SemanticWebOrganization_3001);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		View view = (View) getHost().getModel();
		CompositeTransactionalCommand cmd = new CompositeTransactionalCommand(
				getEditingDomain(), null);
		cmd.setTransactionNestingEnabled(false);
		for (Iterator<?> it = view.getTargetEdges().iterator(); it.hasNext();) {
			Edge incomingLink = (Edge) it.next();
			if (MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.getVisualID(incomingLink) == MASandOrg.diagram.edit.parts.SemanticWebAgentWorks_inEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(
						incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
		}
		for (Iterator<?> it = view.getSourceEdges().iterator(); it.hasNext();) {
			Edge outgoingLink = (Edge) it.next();
			if (MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.getVisualID(outgoingLink) == MASandOrg.diagram.edit.parts.SemanticWebOrganizationHasEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(
						outgoingLink.getSource().getElement(), null,
						outgoingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.getVisualID(outgoingLink) == MASandOrg.diagram.edit.parts.SemanticWebOrganizationInteracts_withEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(
						outgoingLink.getSource().getElement(), null,
						outgoingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
		}
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation == null) {
			// there are indirectly referenced children, need extra commands: false
			addDestroyChildNodesCommand(cmd);
			addDestroyShortcutsCommand(cmd, view);
			// delete host element
			cmd.add(new DestroyElementCommand(req));
		} else {
			cmd.add(new DeleteCommand(getEditingDomain(), view));
		}
		return getGEFWrapper(cmd.reduce());
	}

	/**
	 * @generated
	 */
	private void addDestroyChildNodesCommand(ICompositeCommand cmd) {
		View view = (View) getHost().getModel();
		for (Iterator<?> nit = view.getChildren().iterator(); nit.hasNext();) {
			Node node = (Node) nit.next();
			switch (MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.getVisualID(node)) {
			case MASandOrg.diagram.edit.parts.SemanticWebOrganizationSemanticWebOrganizationContainsCompartment2EditPart.VISUAL_ID:
				for (Iterator<?> cit = node.getChildren().iterator(); cit
						.hasNext();) {
					Node cnode = (Node) cit.next();
					switch (MASandOrg.diagram.part.MASandOrgVisualIDRegistry
							.getVisualID(cnode)) {
					case MASandOrg.diagram.edit.parts.SemanticWebOrganization2EditPart.VISUAL_ID:
						for (Iterator<?> it = cnode.getTargetEdges().iterator(); it
								.hasNext();) {
							Edge incomingLink = (Edge) it.next();
							if (MASandOrg.diagram.part.MASandOrgVisualIDRegistry
									.getVisualID(incomingLink) == MASandOrg.diagram.edit.parts.SemanticWebAgentWorks_inEditPart.VISUAL_ID) {
								DestroyReferenceRequest r = new DestroyReferenceRequest(
										incomingLink.getSource().getElement(),
										null, incomingLink.getTarget()
												.getElement(), false);
								cmd.add(new DestroyReferenceCommand(r));
								cmd.add(new DeleteCommand(getEditingDomain(),
										incomingLink));
								continue;
							}
						}
						for (Iterator<?> it = cnode.getSourceEdges().iterator(); it
								.hasNext();) {
							Edge outgoingLink = (Edge) it.next();
							if (MASandOrg.diagram.part.MASandOrgVisualIDRegistry
									.getVisualID(outgoingLink) == MASandOrg.diagram.edit.parts.SemanticWebOrganizationHasEditPart.VISUAL_ID) {
								DestroyReferenceRequest r = new DestroyReferenceRequest(
										outgoingLink.getSource().getElement(),
										null, outgoingLink.getTarget()
												.getElement(), false);
								cmd.add(new DestroyReferenceCommand(r));
								cmd.add(new DeleteCommand(getEditingDomain(),
										outgoingLink));
								continue;
							}
							if (MASandOrg.diagram.part.MASandOrgVisualIDRegistry
									.getVisualID(outgoingLink) == MASandOrg.diagram.edit.parts.SemanticWebOrganizationInteracts_withEditPart.VISUAL_ID) {
								DestroyReferenceRequest r = new DestroyReferenceRequest(
										outgoingLink.getSource().getElement(),
										null, outgoingLink.getTarget()
												.getElement(), false);
								cmd.add(new DestroyReferenceCommand(r));
								cmd.add(new DeleteCommand(getEditingDomain(),
										outgoingLink));
								continue;
							}
						}
						cmd.add(new DestroyElementCommand(
								new DestroyElementRequest(getEditingDomain(),
										cnode.getElement(), false))); // directlyOwned: true
						// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
						// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
						break;
					}
				}
				break;
			}
		}
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (MASandOrg.diagram.providers.MASandOrgElementTypes.SemanticWebOrganizationHas_4001 == req
				.getElementType()) {
			return getGEFWrapper(new MASandOrg.diagram.edit.commands.SemanticWebOrganizationHasCreateCommand(
					req, req.getSource(), req.getTarget()));
		}
		if (MASandOrg.diagram.providers.MASandOrgElementTypes.SemanticWebOrganizationInteracts_with_4002 == req
				.getElementType()) {
			return getGEFWrapper(new MASandOrg.diagram.edit.commands.SemanticWebOrganizationInteracts_withCreateCommand(
					req, req.getSource(), req.getTarget()));
		}
		if (MASandOrg.diagram.providers.MASandOrgElementTypes.SemanticWebAgentWorks_in_4003 == req
				.getElementType()) {
			return null;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (MASandOrg.diagram.providers.MASandOrgElementTypes.SemanticWebOrganizationHas_4001 == req
				.getElementType()) {
			return null;
		}
		if (MASandOrg.diagram.providers.MASandOrgElementTypes.SemanticWebOrganizationInteracts_with_4002 == req
				.getElementType()) {
			return null;
		}
		if (MASandOrg.diagram.providers.MASandOrgElementTypes.SemanticWebAgentWorks_in_4003 == req
				.getElementType()) {
			return getGEFWrapper(new MASandOrg.diagram.edit.commands.SemanticWebAgentWorks_inCreateCommand(
					req, req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(
			ReorientReferenceRelationshipRequest req) {
		switch (getVisualID(req)) {
		case MASandOrg.diagram.edit.parts.SemanticWebOrganizationHasEditPart.VISUAL_ID:
			return getGEFWrapper(new MASandOrg.diagram.edit.commands.SemanticWebOrganizationHasReorientCommand(
					req));
		case MASandOrg.diagram.edit.parts.SemanticWebOrganizationInteracts_withEditPart.VISUAL_ID:
			return getGEFWrapper(new MASandOrg.diagram.edit.commands.SemanticWebOrganizationInteracts_withReorientCommand(
					req));
		case MASandOrg.diagram.edit.parts.SemanticWebAgentWorks_inEditPart.VISUAL_ID:
			return getGEFWrapper(new MASandOrg.diagram.edit.commands.SemanticWebAgentWorks_inReorientCommand(
					req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
