/*
 * 
 */
package Ontology.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class RoleKnowsRoleOntReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public RoleKnowsRoleOntReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == referenceOwner instanceof Ontology.Role) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof Ontology.RoleOntology && newEnd instanceof Ontology.Role)) {
			return false;
		}
		return Ontology.diagram.edit.policies.OntologyBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistRoleKnowsRoleOnt_4004(
						getNewSource(), getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof Ontology.RoleOntology && newEnd instanceof Ontology.RoleOntology)) {
			return false;
		}
		return Ontology.diagram.edit.policies.OntologyBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistRoleKnowsRoleOnt_4004(
						getOldSource(), getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().getKnowsRoleOnt().remove(getOldTarget());
		getNewSource().getKnowsRoleOnt().add(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().getKnowsRoleOnt().remove(getOldTarget());
		getOldSource().getKnowsRoleOnt().add(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected Ontology.Role getOldSource() {
		return (Ontology.Role) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected Ontology.Role getNewSource() {
		return (Ontology.Role) newEnd;
	}

	/**
	 * @generated
	 */
	protected Ontology.RoleOntology getOldTarget() {
		return (Ontology.RoleOntology) oldEnd;
	}

	/**
	 * @generated
	 */
	protected Ontology.RoleOntology getNewTarget() {
		return (Ontology.RoleOntology) newEnd;
	}
}
