/*
 * 
 */
package Ontology.diagram.navigator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gmf.runtime.emf.core.GMFEditingDomainFactory;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonContentProvider;

/**
 * @generated
 */
public class OntologyNavigatorContentProvider implements ICommonContentProvider {

	/**
	 * @generated
	 */
	private static final Object[] EMPTY_ARRAY = new Object[0];

	/**
	 * @generated
	 */
	private Viewer myViewer;

	/**
	 * @generated
	 */
	private AdapterFactoryEditingDomain myEditingDomain;

	/**
	 * @generated
	 */
	private WorkspaceSynchronizer myWorkspaceSynchronizer;

	/**
	 * @generated
	 */
	private Runnable myViewerRefreshRunnable;

	/**
	 * @generated
	 */
	@SuppressWarnings({ "unchecked", "serial", "rawtypes" })
	public OntologyNavigatorContentProvider() {
		TransactionalEditingDomain editingDomain = GMFEditingDomainFactory.INSTANCE
				.createEditingDomain();
		myEditingDomain = (AdapterFactoryEditingDomain) editingDomain;
		myEditingDomain.setResourceToReadOnlyMap(new HashMap() {
			public Object get(Object key) {
				if (!containsKey(key)) {
					put(key, Boolean.TRUE);
				}
				return super.get(key);
			}
		});
		myViewerRefreshRunnable = new Runnable() {
			public void run() {
				if (myViewer != null) {
					myViewer.refresh();
				}
			}
		};
		myWorkspaceSynchronizer = new WorkspaceSynchronizer(editingDomain,
				new WorkspaceSynchronizer.Delegate() {
					public void dispose() {
					}

					public boolean handleResourceChanged(final Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceDeleted(Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceMoved(Resource resource,
							final URI newURI) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}
				});
	}

	/**
	 * @generated
	 */
	public void dispose() {
		myWorkspaceSynchronizer.dispose();
		myWorkspaceSynchronizer = null;
		myViewerRefreshRunnable = null;
		myViewer = null;
		unloadAllResources();
		((TransactionalEditingDomain) myEditingDomain).dispose();
		myEditingDomain = null;
	}

	/**
	 * @generated
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		myViewer = viewer;
	}

	/**
	 * @generated
	 */
	void unloadAllResources() {
		for (Resource nextResource : myEditingDomain.getResourceSet()
				.getResources()) {
			nextResource.unload();
		}
	}

	/**
	 * @generated
	 */
	void asyncRefresh() {
		if (myViewer != null && !myViewer.getControl().isDisposed()) {
			myViewer.getControl().getDisplay()
					.asyncExec(myViewerRefreshRunnable);
		}
	}

	/**
	 * @generated
	 */
	public Object[] getElements(Object inputElement) {
		return getChildren(inputElement);
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof IFile) {
			IFile file = (IFile) parentElement;
			URI fileURI = URI.createPlatformResourceURI(file.getFullPath()
					.toString(), true);
			Resource resource = myEditingDomain.getResourceSet().getResource(
					fileURI, true);
			ArrayList<Ontology.diagram.navigator.OntologyNavigatorItem> result = new ArrayList<Ontology.diagram.navigator.OntologyNavigatorItem>();
			ArrayList<View> topViews = new ArrayList<View>(resource
					.getContents().size());
			for (EObject o : resource.getContents()) {
				if (o instanceof View) {
					topViews.add((View) o);
				}
			}
			result.addAll(createNavigatorItems(
					selectViewsByType(
							topViews,
							Ontology.diagram.edit.parts.OntologyViewpointEditPart.MODEL_ID),
					file, false));
			return result.toArray();
		}

		if (parentElement instanceof Ontology.diagram.navigator.OntologyNavigatorGroup) {
			Ontology.diagram.navigator.OntologyNavigatorGroup group = (Ontology.diagram.navigator.OntologyNavigatorGroup) parentElement;
			return group.getChildren();
		}

		if (parentElement instanceof Ontology.diagram.navigator.OntologyNavigatorItem) {
			Ontology.diagram.navigator.OntologyNavigatorItem navigatorItem = (Ontology.diagram.navigator.OntologyNavigatorItem) parentElement;
			if (navigatorItem.isLeaf() || !isOwnView(navigatorItem.getView())) {
				return EMPTY_ARRAY;
			}
			return getViewChildren(navigatorItem.getView(), parentElement);
		}

		/*
		 * Due to plugin.xml restrictions this code will be called only for views representing
		 * shortcuts to this diagram elements created on other diagrams. 
		 */
		if (parentElement instanceof IAdaptable) {
			View view = (View) ((IAdaptable) parentElement)
					.getAdapter(View.class);
			if (view != null) {
				return getViewChildren(view, parentElement);
			}
		}

		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Object[] getViewChildren(View view, Object parentElement) {
		switch (Ontology.diagram.part.OntologyVisualIDRegistry
				.getVisualID(view)) {

		case Ontology.diagram.edit.parts.RoleEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup outgoinglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_Role_2007_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleKnowsRoleOntEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleKnowsOrgOntEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.OntologyViewpointEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			result.addAll(getForeignShortcuts((Diagram) view, parentElement));
			Diagram sv = (Diagram) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup links = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_OntologyViewpoint_1000_links,
					"icons/linksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleOntologyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.BeliefEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.FactEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.SWSEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OntologyMediatorRoleEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OWLOntologyIncludesEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.SemanticWebOrganizationKnowsOrgEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.SWSDepends_onEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleKnowsRoleOntEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleKnowsOrgOntEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OntologyMediatorRoleKnowsServiceEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			if (!links.isEmpty()) {
				result.add(links);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.BeliefEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup incominglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_Belief_2004_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OWLOntologyIncludesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.RoleKnowsRoleOntEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup target = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_RoleKnowsRoleOnt_4004_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Ontology.diagram.navigator.OntologyNavigatorGroup source = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_RoleKnowsRoleOnt_4004_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleOntologyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup outgoinglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_ServiceOntology_2003_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Ontology.diagram.navigator.OntologyNavigatorGroup incominglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_ServiceOntology_2003_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OWLOntologyIncludesEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.SWSDepends_onEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OntologyMediatorRoleKnowsServiceEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.OWLOntologyIncludesEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup target = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_OWLOntologyIncludes_4001_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Ontology.diagram.navigator.OntologyNavigatorGroup source = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_OWLOntologyIncludes_4001_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.BeliefEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.FactEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleOntologyEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.SWSDepends_onEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup target = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_SWSDepends_on_4003_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Ontology.diagram.navigator.OntologyNavigatorGroup source = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_SWSDepends_on_4003_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.SWSEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.FactEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup incominglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_Fact_2005_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OWLOntologyIncludesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup outgoinglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_OrganizationOntology_2002_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Ontology.diagram.navigator.OntologyNavigatorGroup incominglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_OrganizationOntology_2002_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OWLOntologyIncludesEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.SemanticWebOrganizationKnowsOrgEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleKnowsOrgOntEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.RoleOntologyEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup outgoinglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_RoleOntology_2001_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Ontology.diagram.navigator.OntologyNavigatorGroup incominglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_RoleOntology_2001_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OWLOntologyIncludesEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleKnowsRoleOntEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.RoleKnowsOrgOntEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup target = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_RoleKnowsOrgOnt_4005_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Ontology.diagram.navigator.OntologyNavigatorGroup source = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_RoleKnowsOrgOnt_4005_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.RoleEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.OntologyMediatorRoleEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup outgoinglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_OntologyMediatorRole_2008_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OntologyMediatorRoleKnowsServiceEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.SemanticWebOrganizationKnowsOrgEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup target = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_SemanticWebOrganizationKnowsOrg_4007_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Ontology.diagram.navigator.OntologyNavigatorGroup source = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_SemanticWebOrganizationKnowsOrg_4007_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.OntologyMediatorRoleKnowsServiceEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup target = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_OntologyMediatorRoleKnowsService_4008_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Ontology.diagram.navigator.OntologyNavigatorGroup source = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_OntologyMediatorRoleKnowsService_4008_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.OntologyMediatorRoleEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup outgoinglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_SemanticWebOrganization_2006_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.SemanticWebOrganizationKnowsOrgEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case Ontology.diagram.edit.parts.SWSEditPart.VISUAL_ID: {
			LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem> result = new LinkedList<Ontology.diagram.navigator.OntologyAbstractNavigatorItem>();
			Node sv = (Node) view;
			Ontology.diagram.navigator.OntologyNavigatorGroup outgoinglinks = new Ontology.diagram.navigator.OntologyNavigatorGroup(
					Ontology.diagram.part.Messages.NavigatorGroupName_SWS_2009_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Ontology.diagram.part.OntologyVisualIDRegistry
							.getType(Ontology.diagram.edit.parts.SWSDepends_onEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}
		}
		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksSourceByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeSource = nextEdge.getSource();
			if (type.equals(nextEdgeSource.getType())
					&& isOwnView(nextEdgeSource)) {
				result.add(nextEdgeSource);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksTargetByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeTarget = nextEdge.getTarget();
			if (type.equals(nextEdgeTarget.getType())
					&& isOwnView(nextEdgeTarget)) {
				result.add(nextEdgeTarget);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getOutgoingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getSourceEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getIncomingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getTargetEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getChildrenByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getChildren(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getDiagramLinksByType(
			Collection<Diagram> diagrams, String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (Diagram nextDiagram : diagrams) {
			result.addAll(selectViewsByType(nextDiagram.getEdges(), type));
		}
		return result;
	}

	// TODO refactor as static method
	/**
	 * @generated
	 */
	private Collection<View> selectViewsByType(Collection<View> views,
			String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (View nextView : views) {
			if (type.equals(nextView.getType()) && isOwnView(nextView)) {
				result.add(nextView);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return Ontology.diagram.edit.parts.OntologyViewpointEditPart.MODEL_ID
				.equals(Ontology.diagram.part.OntologyVisualIDRegistry
						.getModelID(view));
	}

	/**
	 * @generated
	 */
	private Collection<Ontology.diagram.navigator.OntologyNavigatorItem> createNavigatorItems(
			Collection<View> views, Object parent, boolean isLeafs) {
		ArrayList<Ontology.diagram.navigator.OntologyNavigatorItem> result = new ArrayList<Ontology.diagram.navigator.OntologyNavigatorItem>(
				views.size());
		for (View nextView : views) {
			result.add(new Ontology.diagram.navigator.OntologyNavigatorItem(
					nextView, parent, isLeafs));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<Ontology.diagram.navigator.OntologyNavigatorItem> getForeignShortcuts(
			Diagram diagram, Object parent) {
		LinkedList<View> result = new LinkedList<View>();
		for (Iterator<View> it = diagram.getChildren().iterator(); it.hasNext();) {
			View nextView = it.next();
			if (!isOwnView(nextView)
					&& nextView.getEAnnotation("Shortcut") != null) { //$NON-NLS-1$
				result.add(nextView);
			}
		}
		return createNavigatorItems(result, parent, false);
	}

	/**
	 * @generated
	 */
	public Object getParent(Object element) {
		if (element instanceof Ontology.diagram.navigator.OntologyAbstractNavigatorItem) {
			Ontology.diagram.navigator.OntologyAbstractNavigatorItem abstractNavigatorItem = (Ontology.diagram.navigator.OntologyAbstractNavigatorItem) element;
			return abstractNavigatorItem.getParent();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean hasChildren(Object element) {
		return element instanceof IFile || getChildren(element).length > 0;
	}

}
