/*
 * 
 */
package Ontology.diagram.navigator;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.common.ui.services.parser.CommonParserHint;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

/**
 * @generated
 */
public class OntologyNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		Ontology.diagram.part.OntologyDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		Ontology.diagram.part.OntologyDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof Ontology.diagram.navigator.OntologyNavigatorItem
				&& !isOwnView(((Ontology.diagram.navigator.OntologyNavigatorItem) element)
						.getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof Ontology.diagram.navigator.OntologyNavigatorGroup) {
			Ontology.diagram.navigator.OntologyNavigatorGroup group = (Ontology.diagram.navigator.OntologyNavigatorGroup) element;
			return Ontology.diagram.part.OntologyDiagramEditorPlugin
					.getInstance().getBundledImage(group.getIcon());
		}

		if (element instanceof Ontology.diagram.navigator.OntologyNavigatorItem) {
			Ontology.diagram.navigator.OntologyNavigatorItem navigatorItem = (Ontology.diagram.navigator.OntologyNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getImage(view);
			}
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (Ontology.diagram.part.OntologyVisualIDRegistry
				.getVisualID(view)) {
		case Ontology.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Ontology.ecore?Role", Ontology.diagram.providers.OntologyElementTypes.Role_2007); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.OntologyViewpointEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?/MyTest/model/Ontology.ecore?OntologyViewpoint", Ontology.diagram.providers.OntologyElementTypes.OntologyViewpoint_1000); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.BeliefEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Ontology.ecore?Belief", Ontology.diagram.providers.OntologyElementTypes.Belief_2004); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.RoleKnowsRoleOntEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/MyTest/model/Ontology.ecore?Role?knowsRoleOnt", Ontology.diagram.providers.OntologyElementTypes.RoleKnowsRoleOnt_4004); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Ontology.ecore?ServiceOntology", Ontology.diagram.providers.OntologyElementTypes.ServiceOntology_2003); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.OWLOntologyIncludesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/MyTest/model/Ontology.ecore?OWLOntology?includes", Ontology.diagram.providers.OntologyElementTypes.OWLOntologyIncludes_4001); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.SWSDepends_onEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/MyTest/model/Ontology.ecore?SWS?depends_on", Ontology.diagram.providers.OntologyElementTypes.SWSDepends_on_4003); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.FactEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Ontology.ecore?Fact", Ontology.diagram.providers.OntologyElementTypes.Fact_2005); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Ontology.ecore?OrganizationOntology", Ontology.diagram.providers.OntologyElementTypes.OrganizationOntology_2002); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.RoleOntologyEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Ontology.ecore?RoleOntology", Ontology.diagram.providers.OntologyElementTypes.RoleOntology_2001); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.RoleKnowsOrgOntEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/MyTest/model/Ontology.ecore?Role?knowsOrgOnt", Ontology.diagram.providers.OntologyElementTypes.RoleKnowsOrgOnt_4005); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.OntologyMediatorRoleEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Ontology.ecore?OntologyMediatorRole", Ontology.diagram.providers.OntologyElementTypes.OntologyMediatorRole_2008); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.SemanticWebOrganizationKnowsOrgEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/MyTest/model/Ontology.ecore?SemanticWebOrganization?knowsOrg", Ontology.diagram.providers.OntologyElementTypes.SemanticWebOrganizationKnowsOrg_4007); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.OntologyMediatorRoleKnowsServiceEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/MyTest/model/Ontology.ecore?OntologyMediatorRole?knowsService", Ontology.diagram.providers.OntologyElementTypes.OntologyMediatorRoleKnowsService_4008); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Ontology.ecore?SemanticWebOrganization", Ontology.diagram.providers.OntologyElementTypes.SemanticWebOrganization_2006); //$NON-NLS-1$
		case Ontology.diagram.edit.parts.SWSEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/MyTest/model/Ontology.ecore?SWS", Ontology.diagram.providers.OntologyElementTypes.SWS_2009); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = Ontology.diagram.part.OntologyDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null
				&& elementType != null
				&& Ontology.diagram.providers.OntologyElementTypes
						.isKnownElementType(elementType)) {
			image = Ontology.diagram.providers.OntologyElementTypes
					.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof Ontology.diagram.navigator.OntologyNavigatorGroup) {
			Ontology.diagram.navigator.OntologyNavigatorGroup group = (Ontology.diagram.navigator.OntologyNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof Ontology.diagram.navigator.OntologyNavigatorItem) {
			Ontology.diagram.navigator.OntologyNavigatorItem navigatorItem = (Ontology.diagram.navigator.OntologyNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getText(view);
			}
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (Ontology.diagram.part.OntologyVisualIDRegistry
				.getVisualID(view)) {
		case Ontology.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			return getRole_2007Text(view);
		case Ontology.diagram.edit.parts.OntologyViewpointEditPart.VISUAL_ID:
			return getOntologyViewpoint_1000Text(view);
		case Ontology.diagram.edit.parts.BeliefEditPart.VISUAL_ID:
			return getBelief_2004Text(view);
		case Ontology.diagram.edit.parts.RoleKnowsRoleOntEditPart.VISUAL_ID:
			return getRoleKnowsRoleOnt_4004Text(view);
		case Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID:
			return getServiceOntology_2003Text(view);
		case Ontology.diagram.edit.parts.OWLOntologyIncludesEditPart.VISUAL_ID:
			return getOWLOntologyIncludes_4001Text(view);
		case Ontology.diagram.edit.parts.SWSDepends_onEditPart.VISUAL_ID:
			return getSWSDepends_on_4003Text(view);
		case Ontology.diagram.edit.parts.FactEditPart.VISUAL_ID:
			return getFact_2005Text(view);
		case Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID:
			return getOrganizationOntology_2002Text(view);
		case Ontology.diagram.edit.parts.RoleOntologyEditPart.VISUAL_ID:
			return getRoleOntology_2001Text(view);
		case Ontology.diagram.edit.parts.RoleKnowsOrgOntEditPart.VISUAL_ID:
			return getRoleKnowsOrgOnt_4005Text(view);
		case Ontology.diagram.edit.parts.OntologyMediatorRoleEditPart.VISUAL_ID:
			return getOntologyMediatorRole_2008Text(view);
		case Ontology.diagram.edit.parts.SemanticWebOrganizationKnowsOrgEditPart.VISUAL_ID:
			return getSemanticWebOrganizationKnowsOrg_4007Text(view);
		case Ontology.diagram.edit.parts.OntologyMediatorRoleKnowsServiceEditPart.VISUAL_ID:
			return getOntologyMediatorRoleKnowsService_4008Text(view);
		case Ontology.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID:
			return getSemanticWebOrganization_2006Text(view);
		case Ontology.diagram.edit.parts.SWSEditPart.VISUAL_ID:
			return getSWS_2009Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getRole_2007Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.Role_2007,
						view.getElement() != null ? view.getElement() : view,
						Ontology.diagram.part.OntologyVisualIDRegistry
								.getType(Ontology.diagram.edit.parts.RoleNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getOntologyViewpoint_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getBelief_2004Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.Belief_2004,
						view.getElement() != null ? view.getElement() : view,
						Ontology.diagram.part.OntologyVisualIDRegistry
								.getType(Ontology.diagram.edit.parts.BeliefNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRoleKnowsRoleOnt_4004Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.RoleKnowsRoleOnt_4004,
						view.getElement() != null ? view.getElement() : view,
						CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 6004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getServiceOntology_2003Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.ServiceOntology_2003,
						view.getElement() != null ? view.getElement() : view,
						Ontology.diagram.part.OntologyVisualIDRegistry
								.getType(Ontology.diagram.edit.parts.ServiceOntologySnameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getOWLOntologyIncludes_4001Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.OWLOntologyIncludes_4001,
						view.getElement() != null ? view.getElement() : view,
						CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 6001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSWSDepends_on_4003Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.SWSDepends_on_4003,
						view.getElement() != null ? view.getElement() : view,
						CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 6003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getFact_2005Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.Fact_2005,
						view.getElement() != null ? view.getElement() : view,
						Ontology.diagram.part.OntologyVisualIDRegistry
								.getType(Ontology.diagram.edit.parts.FactFnameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getOrganizationOntology_2002Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.OrganizationOntology_2002,
						view.getElement() != null ? view.getElement() : view,
						Ontology.diagram.part.OntologyVisualIDRegistry
								.getType(Ontology.diagram.edit.parts.OrganizationOntologyOrgontnameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRoleOntology_2001Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.RoleOntology_2001,
						view.getElement() != null ? view.getElement() : view,
						Ontology.diagram.part.OntologyVisualIDRegistry
								.getType(Ontology.diagram.edit.parts.RoleOntologyRnameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRoleKnowsOrgOnt_4005Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.RoleKnowsOrgOnt_4005,
						view.getElement() != null ? view.getElement() : view,
						CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 6005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getOntologyMediatorRole_2008Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.OntologyMediatorRole_2008,
						view.getElement() != null ? view.getElement() : view,
						Ontology.diagram.part.OntologyVisualIDRegistry
								.getType(Ontology.diagram.edit.parts.OntologyMediatorRoleNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5008); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSemanticWebOrganizationKnowsOrg_4007Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.SemanticWebOrganizationKnowsOrg_4007,
						view.getElement() != null ? view.getElement() : view,
						CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 6007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getOntologyMediatorRoleKnowsService_4008Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.OntologyMediatorRoleKnowsService_4008,
						view.getElement() != null ? view.getElement() : view,
						CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 6008); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSemanticWebOrganization_2006Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.SemanticWebOrganization_2006,
						view.getElement() != null ? view.getElement() : view,
						Ontology.diagram.part.OntologyVisualIDRegistry
								.getType(Ontology.diagram.edit.parts.SemanticWebOrganizationNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSWS_2009Text(View view) {
		IParser parser = Ontology.diagram.providers.OntologyParserProvider
				.getParser(
						Ontology.diagram.providers.OntologyElementTypes.SWS_2009,
						view.getElement() != null ? view.getElement() : view,
						Ontology.diagram.part.OntologyVisualIDRegistry
								.getType(Ontology.diagram.edit.parts.SWSNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5009); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return Ontology.diagram.edit.parts.OntologyViewpointEditPart.MODEL_ID
				.equals(Ontology.diagram.part.OntologyVisualIDRegistry
						.getModelID(view));
	}

}
