/*
 * 
 */
package Ontology.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class OntologyVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "Ontology.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (Ontology.diagram.edit.parts.OntologyViewpointEditPart.MODEL_ID
					.equals(view.getType())) {
				return Ontology.diagram.edit.parts.OntologyViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return Ontology.diagram.part.OntologyVisualIDRegistry.getVisualID(view
				.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				Ontology.diagram.part.OntologyDiagramEditorPlugin.getInstance()
						.logError(
								"Unable to parse view type as a visualID number: "
										+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (Ontology.OntologyPackage.eINSTANCE.getOntologyViewpoint()
				.isSuperTypeOf(domainElement.eClass())
				&& isDiagram((Ontology.OntologyViewpoint) domainElement)) {
			return Ontology.diagram.edit.parts.OntologyViewpointEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = Ontology.diagram.part.OntologyVisualIDRegistry
				.getModelID(containerView);
		if (!Ontology.diagram.edit.parts.OntologyViewpointEditPart.MODEL_ID
				.equals(containerModelID)
				&& !"Ontology".equals(containerModelID)) { //$NON-NLS-1$
			return -1;
		}
		int containerVisualID;
		if (Ontology.diagram.edit.parts.OntologyViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = Ontology.diagram.part.OntologyVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = Ontology.diagram.edit.parts.OntologyViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case Ontology.diagram.edit.parts.OntologyViewpointEditPart.VISUAL_ID:
			if (Ontology.OntologyPackage.eINSTANCE.getRoleOntology()
					.isSuperTypeOf(domainElement.eClass())) {
				return Ontology.diagram.edit.parts.RoleOntologyEditPart.VISUAL_ID;
			}
			if (Ontology.OntologyPackage.eINSTANCE.getOrganizationOntology()
					.isSuperTypeOf(domainElement.eClass())) {
				return Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID;
			}
			if (Ontology.OntologyPackage.eINSTANCE.getServiceOntology()
					.isSuperTypeOf(domainElement.eClass())) {
				return Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID;
			}
			if (Ontology.OntologyPackage.eINSTANCE.getBelief().isSuperTypeOf(
					domainElement.eClass())) {
				return Ontology.diagram.edit.parts.BeliefEditPart.VISUAL_ID;
			}
			if (Ontology.OntologyPackage.eINSTANCE.getFact().isSuperTypeOf(
					domainElement.eClass())) {
				return Ontology.diagram.edit.parts.FactEditPart.VISUAL_ID;
			}
			if (Ontology.OntologyPackage.eINSTANCE.getSemanticWebOrganization()
					.isSuperTypeOf(domainElement.eClass())) {
				return Ontology.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID;
			}
			if (Ontology.OntologyPackage.eINSTANCE.getRole().isSuperTypeOf(
					domainElement.eClass())) {
				return Ontology.diagram.edit.parts.RoleEditPart.VISUAL_ID;
			}
			if (Ontology.OntologyPackage.eINSTANCE.getSWS().isSuperTypeOf(
					domainElement.eClass())) {
				return Ontology.diagram.edit.parts.SWSEditPart.VISUAL_ID;
			}
			if (Ontology.OntologyPackage.eINSTANCE.getOntologyMediatorRole()
					.isSuperTypeOf(domainElement.eClass())) {
				return Ontology.diagram.edit.parts.OntologyMediatorRoleEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = Ontology.diagram.part.OntologyVisualIDRegistry
				.getModelID(containerView);
		if (!Ontology.diagram.edit.parts.OntologyViewpointEditPart.MODEL_ID
				.equals(containerModelID)
				&& !"Ontology".equals(containerModelID)) { //$NON-NLS-1$
			return false;
		}
		int containerVisualID;
		if (Ontology.diagram.edit.parts.OntologyViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = Ontology.diagram.part.OntologyVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = Ontology.diagram.edit.parts.OntologyViewpointEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case Ontology.diagram.edit.parts.OntologyViewpointEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.RoleOntologyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Ontology.diagram.edit.parts.BeliefEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Ontology.diagram.edit.parts.FactEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Ontology.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Ontology.diagram.edit.parts.RoleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Ontology.diagram.edit.parts.SWSEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Ontology.diagram.edit.parts.OntologyMediatorRoleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.RoleOntologyEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.RoleOntologyRnameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.OrganizationOntologyOrgontnameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.ServiceOntologySnameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.BeliefEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.BeliefNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.FactEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.FactFnameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.SemanticWebOrganizationNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.RoleNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.SWSEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.SWSNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.OntologyMediatorRoleEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.OntologyMediatorRoleNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.OWLOntologyIncludesEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.OWLOntologyIncludesExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.SemanticWebOrganizationKnowsOrgEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.SemanticWebOrganizationKnowsOrgExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.SWSDepends_onEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.SWSDepends_onExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.RoleKnowsRoleOntEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.RoleKnowsRoleOntExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.RoleKnowsOrgOntEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.RoleKnowsOrgOntExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Ontology.diagram.edit.parts.OntologyMediatorRoleKnowsServiceEditPart.VISUAL_ID:
			if (Ontology.diagram.edit.parts.OntologyMediatorRoleKnowsServiceExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(Ontology.OntologyViewpoint element) {
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView,
			EObject domainElement, int candidate) {
		if (candidate == -1) {
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID) {
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID) {
		switch (visualID) {
		case Ontology.diagram.edit.parts.OntologyViewpointEditPart.VISUAL_ID:
			return false;
		case Ontology.diagram.edit.parts.RoleOntologyEditPart.VISUAL_ID:
		case Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID:
		case Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID:
		case Ontology.diagram.edit.parts.BeliefEditPart.VISUAL_ID:
		case Ontology.diagram.edit.parts.FactEditPart.VISUAL_ID:
		case Ontology.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID:
		case Ontology.diagram.edit.parts.RoleEditPart.VISUAL_ID:
		case Ontology.diagram.edit.parts.OntologyMediatorRoleEditPart.VISUAL_ID:
		case Ontology.diagram.edit.parts.SWSEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure TYPED_INSTANCE = new DiagramStructure() {
		/**
		 * @generated
		 */
		@Override
		public int getVisualID(View view) {
			return Ontology.diagram.part.OntologyVisualIDRegistry
					.getVisualID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public String getModelID(View view) {
			return Ontology.diagram.part.OntologyVisualIDRegistry
					.getModelID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public int getNodeVisualID(View containerView, EObject domainElement) {
			return Ontology.diagram.part.OntologyVisualIDRegistry
					.getNodeVisualID(containerView, domainElement);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean checkNodeVisualID(View containerView,
				EObject domainElement, int candidate) {
			return Ontology.diagram.part.OntologyVisualIDRegistry
					.checkNodeVisualID(containerView, domainElement, candidate);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isCompartmentVisualID(int visualID) {
			return Ontology.diagram.part.OntologyVisualIDRegistry
					.isCompartmentVisualID(visualID);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isSemanticLeafVisualID(int visualID) {
			return Ontology.diagram.part.OntologyVisualIDRegistry
					.isSemanticLeafVisualID(visualID);
		}
	};

}
