/**
 */
package Ontology.provider;

import Ontology.util.OntologyAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class OntologyItemProviderAdapterFactory extends OntologyAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable
{
  /**
   * This keeps track of the root adapter factory that delegates to this adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ComposedAdapterFactory parentAdapterFactory;

  /**
   * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IChangeNotifier changeNotifier = new ChangeNotifier();

  /**
   * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Collection<Object> supportedTypes = new ArrayList<Object>();

  /**
   * This constructs an instance.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OntologyItemProviderAdapterFactory()
  {
    supportedTypes.add(IEditingDomainItemProvider.class);
    supportedTypes.add(IStructuredItemContentProvider.class);
    supportedTypes.add(ITreeItemContentProvider.class);
    supportedTypes.add(IItemLabelProvider.class);
    supportedTypes.add(IItemPropertySource.class);
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.OntologyViewpoint} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OntologyViewpointItemProvider ontologyViewpointItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.OntologyViewpoint}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createOntologyViewpointAdapter()
  {
    if (ontologyViewpointItemProvider == null)
    {
      ontologyViewpointItemProvider = new OntologyViewpointItemProvider(this);
    }

    return ontologyViewpointItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.OrganizationOntology} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OrganizationOntologyItemProvider organizationOntologyItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.OrganizationOntology}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createOrganizationOntologyAdapter()
  {
    if (organizationOntologyItemProvider == null)
    {
      organizationOntologyItemProvider = new OrganizationOntologyItemProvider(this);
    }

    return organizationOntologyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.OWLOntology} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OWLOntologyItemProvider owlOntologyItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.OWLOntology}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createOWLOntologyAdapter()
  {
    if (owlOntologyItemProvider == null)
    {
      owlOntologyItemProvider = new OWLOntologyItemProvider(this);
    }

    return owlOntologyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.SemanticWebOrganization} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SemanticWebOrganizationItemProvider semanticWebOrganizationItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.SemanticWebOrganization}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createSemanticWebOrganizationAdapter()
  {
    if (semanticWebOrganizationItemProvider == null)
    {
      semanticWebOrganizationItemProvider = new SemanticWebOrganizationItemProvider(this);
    }

    return semanticWebOrganizationItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.RoleOntology} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RoleOntologyItemProvider roleOntologyItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.RoleOntology}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createRoleOntologyAdapter()
  {
    if (roleOntologyItemProvider == null)
    {
      roleOntologyItemProvider = new RoleOntologyItemProvider(this);
    }

    return roleOntologyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.ServiceOntology} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ServiceOntologyItemProvider serviceOntologyItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.ServiceOntology}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createServiceOntologyAdapter()
  {
    if (serviceOntologyItemProvider == null)
    {
      serviceOntologyItemProvider = new ServiceOntologyItemProvider(this);
    }

    return serviceOntologyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.SWS} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SWSItemProvider swsItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.SWS}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createSWSAdapter()
  {
    if (swsItemProvider == null)
    {
      swsItemProvider = new SWSItemProvider(this);
    }

    return swsItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.Role} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RoleItemProvider roleItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.Role}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createRoleAdapter()
  {
    if (roleItemProvider == null)
    {
      roleItemProvider = new RoleItemProvider(this);
    }

    return roleItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.OntologyMediatorRole} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OntologyMediatorRoleItemProvider ontologyMediatorRoleItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.OntologyMediatorRole}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createOntologyMediatorRoleAdapter()
  {
    if (ontologyMediatorRoleItemProvider == null)
    {
      ontologyMediatorRoleItemProvider = new OntologyMediatorRoleItemProvider(this);
    }

    return ontologyMediatorRoleItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.Belief} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BeliefItemProvider beliefItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.Belief}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createBeliefAdapter()
  {
    if (beliefItemProvider == null)
    {
      beliefItemProvider = new BeliefItemProvider(this);
    }

    return beliefItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.Fact} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FactItemProvider factItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.Fact}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createFactAdapter()
  {
    if (factItemProvider == null)
    {
      factItemProvider = new FactItemProvider(this);
    }

    return factItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link Ontology.ODMOWLStatement} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ODMOWLStatementItemProvider odmowlStatementItemProvider;

  /**
   * This creates an adapter for a {@link Ontology.ODMOWLStatement}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createODMOWLStatementAdapter()
  {
    if (odmowlStatementItemProvider == null)
    {
      odmowlStatementItemProvider = new ODMOWLStatementItemProvider(this);
    }

    return odmowlStatementItemProvider;
  }

  /**
   * This returns the root adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComposeableAdapterFactory getRootAdapterFactory()
  {
    return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
  }

  /**
   * This sets the composed adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
  {
    this.parentAdapterFactory = parentAdapterFactory;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object type)
  {
    return supportedTypes.contains(type) || super.isFactoryForType(type);
  }

  /**
   * This implementation substitutes the factory itself as the key for the adapter.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter adapt(Notifier notifier, Object type)
  {
    return super.adapt(notifier, this);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object adapt(Object object, Object type)
  {
    if (isFactoryForType(type))
    {
      Object adapter = super.adapt(object, type);
      if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter)))
      {
        return adapter;
      }
    }

    return null;
  }

  /**
   * This adds a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void addListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.addListener(notifyChangedListener);
  }

  /**
   * This removes a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void removeListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.removeListener(notifyChangedListener);
  }

  /**
   * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void fireNotifyChanged(Notification notification)
  {
    changeNotifier.fireNotifyChanged(notification);

    if (parentAdapterFactory != null)
    {
      parentAdapterFactory.fireNotifyChanged(notification);
    }
  }

  /**
   * This disposes all of the item providers created by this factory. 
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void dispose()
  {
    if (ontologyViewpointItemProvider != null) ontologyViewpointItemProvider.dispose();
    if (organizationOntologyItemProvider != null) organizationOntologyItemProvider.dispose();
    if (owlOntologyItemProvider != null) owlOntologyItemProvider.dispose();
    if (semanticWebOrganizationItemProvider != null) semanticWebOrganizationItemProvider.dispose();
    if (roleOntologyItemProvider != null) roleOntologyItemProvider.dispose();
    if (serviceOntologyItemProvider != null) serviceOntologyItemProvider.dispose();
    if (swsItemProvider != null) swsItemProvider.dispose();
    if (roleItemProvider != null) roleItemProvider.dispose();
    if (ontologyMediatorRoleItemProvider != null) ontologyMediatorRoleItemProvider.dispose();
    if (beliefItemProvider != null) beliefItemProvider.dispose();
    if (factItemProvider != null) factItemProvider.dispose();
    if (odmowlStatementItemProvider != null) odmowlStatementItemProvider.dispose();
  }

}
