/**
 */
package Ontology;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Viewpoint</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link Ontology.OntologyViewpoint#getContainsSemanticWebOrganization <em>Contains Semantic Web Organization</em>}</li>
 *   <li>{@link Ontology.OntologyViewpoint#getContainsRoleOntology <em>Contains Role Ontology</em>}</li>
 *   <li>{@link Ontology.OntologyViewpoint#getContainsRole <em>Contains Role</em>}</li>
 *   <li>{@link Ontology.OntologyViewpoint#getContainsOrganizationOntology <em>Contains Organization Ontology</em>}</li>
 *   <li>{@link Ontology.OntologyViewpoint#getContainsServiceOntology <em>Contains Service Ontology</em>}</li>
 *   <li>{@link Ontology.OntologyViewpoint#getContainsSWS <em>Contains SWS</em>}</li>
 *   <li>{@link Ontology.OntologyViewpoint#getContainsOntologyMediatorRole <em>Contains Ontology Mediator Role</em>}</li>
 *   <li>{@link Ontology.OntologyViewpoint#getContainsBelief <em>Contains Belief</em>}</li>
 *   <li>{@link Ontology.OntologyViewpoint#getContainsFact <em>Contains Fact</em>}</li>
 * </ul>
 * </p>
 *
 * @see Ontology.OntologyPackage#getOntologyViewpoint()
 * @model annotation="gmf.diagram foo='bar'"
 * @generated
 */
public interface OntologyViewpoint extends EObject
{
  /**
   * Returns the value of the '<em><b>Contains Semantic Web Organization</b></em>' containment reference list.
   * The list contents are of type {@link Ontology.SemanticWebOrganization}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contains Semantic Web Organization</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contains Semantic Web Organization</em>' containment reference list.
   * @see Ontology.OntologyPackage#getOntologyViewpoint_ContainsSemanticWebOrganization()
   * @model containment="true"
   * @generated
   */
  EList<SemanticWebOrganization> getContainsSemanticWebOrganization();

  /**
   * Returns the value of the '<em><b>Contains Role Ontology</b></em>' containment reference list.
   * The list contents are of type {@link Ontology.RoleOntology}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contains Role Ontology</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contains Role Ontology</em>' containment reference list.
   * @see Ontology.OntologyPackage#getOntologyViewpoint_ContainsRoleOntology()
   * @model containment="true"
   * @generated
   */
  EList<RoleOntology> getContainsRoleOntology();

  /**
   * Returns the value of the '<em><b>Contains Role</b></em>' containment reference list.
   * The list contents are of type {@link Ontology.Role}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contains Role</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contains Role</em>' containment reference list.
   * @see Ontology.OntologyPackage#getOntologyViewpoint_ContainsRole()
   * @model containment="true"
   * @generated
   */
  EList<Role> getContainsRole();

  /**
   * Returns the value of the '<em><b>Contains Organization Ontology</b></em>' containment reference list.
   * The list contents are of type {@link Ontology.OrganizationOntology}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contains Organization Ontology</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contains Organization Ontology</em>' containment reference list.
   * @see Ontology.OntologyPackage#getOntologyViewpoint_ContainsOrganizationOntology()
   * @model containment="true"
   * @generated
   */
  EList<OrganizationOntology> getContainsOrganizationOntology();

  /**
   * Returns the value of the '<em><b>Contains Service Ontology</b></em>' containment reference list.
   * The list contents are of type {@link Ontology.ServiceOntology}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contains Service Ontology</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contains Service Ontology</em>' containment reference list.
   * @see Ontology.OntologyPackage#getOntologyViewpoint_ContainsServiceOntology()
   * @model containment="true"
   * @generated
   */
  EList<ServiceOntology> getContainsServiceOntology();

  /**
   * Returns the value of the '<em><b>Contains SWS</b></em>' containment reference list.
   * The list contents are of type {@link Ontology.SWS}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contains SWS</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contains SWS</em>' containment reference list.
   * @see Ontology.OntologyPackage#getOntologyViewpoint_ContainsSWS()
   * @model containment="true"
   * @generated
   */
  EList<SWS> getContainsSWS();

  /**
   * Returns the value of the '<em><b>Contains Ontology Mediator Role</b></em>' containment reference list.
   * The list contents are of type {@link Ontology.OntologyMediatorRole}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contains Ontology Mediator Role</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contains Ontology Mediator Role</em>' containment reference list.
   * @see Ontology.OntologyPackage#getOntologyViewpoint_ContainsOntologyMediatorRole()
   * @model containment="true"
   * @generated
   */
  EList<OntologyMediatorRole> getContainsOntologyMediatorRole();

  /**
   * Returns the value of the '<em><b>Contains Belief</b></em>' containment reference list.
   * The list contents are of type {@link Ontology.Belief}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contains Belief</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contains Belief</em>' containment reference list.
   * @see Ontology.OntologyPackage#getOntologyViewpoint_ContainsBelief()
   * @model containment="true"
   * @generated
   */
  EList<Belief> getContainsBelief();

  /**
   * Returns the value of the '<em><b>Contains Fact</b></em>' containment reference list.
   * The list contents are of type {@link Ontology.Fact}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Contains Fact</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Contains Fact</em>' containment reference list.
   * @see Ontology.OntologyPackage#getOntologyViewpoint_ContainsFact()
   * @model containment="true"
   * @generated
   */
  EList<Fact> getContainsFact();

} // OntologyViewpoint
