/**
 */
package Ontology.util;

import Ontology.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see Ontology.OntologyPackage
 * @generated
 */
public class OntologyAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static OntologyPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OntologyAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = OntologyPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OntologySwitch<Adapter> modelSwitch =
    new OntologySwitch<Adapter>()
    {
      @Override
      public Adapter caseOntologyViewpoint(OntologyViewpoint object)
      {
        return createOntologyViewpointAdapter();
      }
      @Override
      public Adapter caseOrganizationOntology(OrganizationOntology object)
      {
        return createOrganizationOntologyAdapter();
      }
      @Override
      public Adapter caseOWLOntology(OWLOntology object)
      {
        return createOWLOntologyAdapter();
      }
      @Override
      public Adapter caseSemanticWebOrganization(SemanticWebOrganization object)
      {
        return createSemanticWebOrganizationAdapter();
      }
      @Override
      public Adapter caseRoleOntology(RoleOntology object)
      {
        return createRoleOntologyAdapter();
      }
      @Override
      public Adapter caseServiceOntology(ServiceOntology object)
      {
        return createServiceOntologyAdapter();
      }
      @Override
      public Adapter caseSWS(SWS object)
      {
        return createSWSAdapter();
      }
      @Override
      public Adapter caseRole(Role object)
      {
        return createRoleAdapter();
      }
      @Override
      public Adapter caseOntologyMediatorRole(OntologyMediatorRole object)
      {
        return createOntologyMediatorRoleAdapter();
      }
      @Override
      public Adapter caseBelief(Belief object)
      {
        return createBeliefAdapter();
      }
      @Override
      public Adapter caseFact(Fact object)
      {
        return createFactAdapter();
      }
      @Override
      public Adapter caseODMOWLStatement(ODMOWLStatement object)
      {
        return createODMOWLStatementAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link Ontology.OntologyViewpoint <em>Viewpoint</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.OntologyViewpoint
   * @generated
   */
  public Adapter createOntologyViewpointAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Ontology.OrganizationOntology <em>Organization Ontology</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.OrganizationOntology
   * @generated
   */
  public Adapter createOrganizationOntologyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Ontology.OWLOntology <em>OWL Ontology</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.OWLOntology
   * @generated
   */
  public Adapter createOWLOntologyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Ontology.SemanticWebOrganization <em>Semantic Web Organization</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.SemanticWebOrganization
   * @generated
   */
  public Adapter createSemanticWebOrganizationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Ontology.RoleOntology <em>Role Ontology</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.RoleOntology
   * @generated
   */
  public Adapter createRoleOntologyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Ontology.ServiceOntology <em>Service Ontology</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.ServiceOntology
   * @generated
   */
  public Adapter createServiceOntologyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Ontology.SWS <em>SWS</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.SWS
   * @generated
   */
  public Adapter createSWSAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Ontology.Role <em>Role</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.Role
   * @generated
   */
  public Adapter createRoleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Ontology.OntologyMediatorRole <em>Mediator Role</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.OntologyMediatorRole
   * @generated
   */
  public Adapter createOntologyMediatorRoleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Ontology.Belief <em>Belief</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.Belief
   * @generated
   */
  public Adapter createBeliefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Ontology.Fact <em>Fact</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.Fact
   * @generated
   */
  public Adapter createFactAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Ontology.ODMOWLStatement <em>ODMOWL Statement</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Ontology.ODMOWLStatement
   * @generated
   */
  public Adapter createODMOWLStatementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //OntologyAdapterFactory
