/*
 * 
 */
package plan.diagram.navigator;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.common.ui.services.parser.CommonParserHint;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import plan.diagram.edit.parts.ActionEditPart;
import plan.diagram.edit.parts.ActionName1EditPart;
import plan.diagram.edit.parts.MessageEditPart;
import plan.diagram.edit.parts.MessageName2EditPart;
import plan.diagram.edit.parts.PlanEditPart;
import plan.diagram.edit.parts.PlanNameEditPart;
import plan.diagram.edit.parts.PlanPalleteEditPart;
import plan.diagram.edit.parts.ReceiveEditPart;
import plan.diagram.edit.parts.ReceiveName1EditPart;
import plan.diagram.edit.parts.ReceiveReceiveEditPart;
import plan.diagram.edit.parts.SendEditPart;
import plan.diagram.edit.parts.SendName1EditPart;
import plan.diagram.edit.parts.SendSendEditPart;
import plan.diagram.edit.parts.TaskEditPart;
import plan.diagram.edit.parts.TaskName0EditPart;
import plan.diagram.part.PlanDiagramEditorPlugin;
import plan.diagram.part.PlanVisualIDRegistry;
import plan.diagram.providers.PlanElementTypes;
import plan.diagram.providers.PlanParserProvider;

/**
 * @generated
 */
public class PlanNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		PlanDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		PlanDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof PlanNavigatorItem
				&& !isOwnView(((PlanNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof PlanNavigatorGroup) {
			PlanNavigatorGroup group = (PlanNavigatorGroup) element;
			return PlanDiagramEditorPlugin.getInstance().getBundledImage(
					group.getIcon());
		}

		if (element instanceof PlanNavigatorItem) {
			PlanNavigatorItem navigatorItem = (PlanNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getImage(view);
			}
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (PlanVisualIDRegistry.getVisualID(view)) {
		case ReceiveEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?plan?Receive", PlanElementTypes.Receive_3003); //$NON-NLS-1$
		case ReceiveReceiveEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?plan?Receive?receive", PlanElementTypes.ReceiveReceive_4002); //$NON-NLS-1$
		case SendSendEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?plan?Send?send", PlanElementTypes.SendSend_4001); //$NON-NLS-1$
		case ActionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?plan?Action", PlanElementTypes.Action_3004); //$NON-NLS-1$
		case PlanEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?plan?Plan", PlanElementTypes.Plan_2001); //$NON-NLS-1$
		case TaskEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?plan?Task", PlanElementTypes.Task_3001); //$NON-NLS-1$
		case SendEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?plan?Send", PlanElementTypes.Send_3002); //$NON-NLS-1$
		case PlanPalleteEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?plan?PlanPallete", PlanElementTypes.PlanPallete_1000); //$NON-NLS-1$
		case MessageEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?plan?Message", PlanElementTypes.Message_2002); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = PlanDiagramEditorPlugin.getInstance()
				.getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& PlanElementTypes.isKnownElementType(elementType)) {
			image = PlanElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof PlanNavigatorGroup) {
			PlanNavigatorGroup group = (PlanNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof PlanNavigatorItem) {
			PlanNavigatorItem navigatorItem = (PlanNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getText(view);
			}
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (PlanVisualIDRegistry.getVisualID(view)) {
		case ReceiveEditPart.VISUAL_ID:
			return getReceive_3003Text(view);
		case ReceiveReceiveEditPart.VISUAL_ID:
			return getReceiveReceive_4002Text(view);
		case SendSendEditPart.VISUAL_ID:
			return getSendSend_4001Text(view);
		case ActionEditPart.VISUAL_ID:
			return getAction_3004Text(view);
		case PlanEditPart.VISUAL_ID:
			return getPlan_2001Text(view);
		case TaskEditPart.VISUAL_ID:
			return getTask_3001Text(view);
		case SendEditPart.VISUAL_ID:
			return getSend_3002Text(view);
		case PlanPalleteEditPart.VISUAL_ID:
			return getPlanPallete_1000Text(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_2002Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getReceive_3003Text(View view) {
		IParser parser = PlanParserProvider.getParser(
				PlanElementTypes.Receive_3003,
				view.getElement() != null ? view.getElement() : view,
				PlanVisualIDRegistry.getType(ReceiveName1EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			PlanDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getReceiveReceive_4002Text(View view) {
		IParser parser = PlanParserProvider.getParser(
				PlanElementTypes.ReceiveReceive_4002,
				view.getElement() != null ? view.getElement() : view,
				CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			PlanDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSendSend_4001Text(View view) {
		IParser parser = PlanParserProvider.getParser(
				PlanElementTypes.SendSend_4001,
				view.getElement() != null ? view.getElement() : view,
				CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			PlanDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getAction_3004Text(View view) {
		IParser parser = PlanParserProvider.getParser(
				PlanElementTypes.Action_3004,
				view.getElement() != null ? view.getElement() : view,
				PlanVisualIDRegistry.getType(ActionName1EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			PlanDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getPlan_2001Text(View view) {
		IParser parser = PlanParserProvider.getParser(
				PlanElementTypes.Plan_2001,
				view.getElement() != null ? view.getElement() : view,
				PlanVisualIDRegistry.getType(PlanNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			PlanDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getTask_3001Text(View view) {
		IParser parser = PlanParserProvider.getParser(
				PlanElementTypes.Task_3001,
				view.getElement() != null ? view.getElement() : view,
				PlanVisualIDRegistry.getType(TaskName0EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			PlanDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSend_3002Text(View view) {
		IParser parser = PlanParserProvider.getParser(
				PlanElementTypes.Send_3002,
				view.getElement() != null ? view.getElement() : view,
				PlanVisualIDRegistry.getType(SendName1EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			PlanDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getPlanPallete_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getMessage_2002Text(View view) {
		IParser parser = PlanParserProvider.getParser(
				PlanElementTypes.Message_2002,
				view.getElement() != null ? view.getElement() : view,
				PlanVisualIDRegistry.getType(MessageName2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			PlanDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return PlanPalleteEditPart.MODEL_ID.equals(PlanVisualIDRegistry
				.getModelID(view));
	}

}
