/*
 * 
 */
package plan.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.update.DiagramUpdater;

import plan.Action;
import plan.Message;
import plan.Plan;
import plan.PlanPackage;
import plan.PlanPallete;
import plan.Receive;
import plan.Send;
import plan.Task;
import plan.diagram.edit.parts.ActionEditPart;
import plan.diagram.edit.parts.MessageEditPart;
import plan.diagram.edit.parts.PlanEditPart;
import plan.diagram.edit.parts.PlanPalleteEditPart;
import plan.diagram.edit.parts.PlanPlanComposed_ofCompartmentEditPart;
import plan.diagram.edit.parts.ReceiveEditPart;
import plan.diagram.edit.parts.ReceiveReceiveEditPart;
import plan.diagram.edit.parts.SendEditPart;
import plan.diagram.edit.parts.SendSendEditPart;
import plan.diagram.edit.parts.TaskEditPart;
import plan.diagram.edit.parts.TaskTaskComposed_ofCompartmentEditPart;
import plan.diagram.providers.PlanElementTypes;

/**
 * @generated
 */
public class PlanDiagramUpdater {

	/**
	 * @generated
	 */
	public static boolean isShortcutOrphaned(View view) {
		return !view.isSetElement() || view.getElement() == null
				|| view.getElement().eIsProxy();
	}

	/**
	 * @generated
	 */
	public static List<PlanNodeDescriptor> getSemanticChildren(View view) {
		switch (PlanVisualIDRegistry.getVisualID(view)) {
		case PlanPalleteEditPart.VISUAL_ID:
			return getPlanPallete_1000SemanticChildren(view);
		case PlanPlanComposed_ofCompartmentEditPart.VISUAL_ID:
			return getPlanPlanComposed_ofCompartment_7001SemanticChildren(view);
		case TaskTaskComposed_ofCompartmentEditPart.VISUAL_ID:
			return getTaskTaskComposed_ofCompartment_7002SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanNodeDescriptor> getPlanPallete_1000SemanticChildren(
			View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		PlanPallete modelElement = (PlanPallete) view.getElement();
		LinkedList<PlanNodeDescriptor> result = new LinkedList<PlanNodeDescriptor>();
		for (Iterator<?> it = modelElement.getPlans().iterator(); it.hasNext();) {
			Plan childElement = (Plan) it.next();
			int visualID = PlanVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == PlanEditPart.VISUAL_ID) {
				result.add(new PlanNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getMsgs().iterator(); it.hasNext();) {
			Message childElement = (Message) it.next();
			int visualID = PlanVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == MessageEditPart.VISUAL_ID) {
				result.add(new PlanNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<PlanNodeDescriptor> getPlanPlanComposed_ofCompartment_7001SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		Plan modelElement = (Plan) containerView.getElement();
		LinkedList<PlanNodeDescriptor> result = new LinkedList<PlanNodeDescriptor>();
		for (Iterator<?> it = modelElement.getComposed_of().iterator(); it
				.hasNext();) {
			Task childElement = (Task) it.next();
			int visualID = PlanVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == TaskEditPart.VISUAL_ID) {
				result.add(new PlanNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<PlanNodeDescriptor> getTaskTaskComposed_ofCompartment_7002SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		Task modelElement = (Task) containerView.getElement();
		LinkedList<PlanNodeDescriptor> result = new LinkedList<PlanNodeDescriptor>();
		for (Iterator<?> it = modelElement.getComposed_of().iterator(); it
				.hasNext();) {
			Action childElement = (Action) it.next();
			int visualID = PlanVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == SendEditPart.VISUAL_ID) {
				result.add(new PlanNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ReceiveEditPart.VISUAL_ID) {
				result.add(new PlanNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ActionEditPart.VISUAL_ID) {
				result.add(new PlanNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getContainedLinks(View view) {
		switch (PlanVisualIDRegistry.getVisualID(view)) {
		case PlanPalleteEditPart.VISUAL_ID:
			return getPlanPallete_1000ContainedLinks(view);
		case PlanEditPart.VISUAL_ID:
			return getPlan_2001ContainedLinks(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_2002ContainedLinks(view);
		case TaskEditPart.VISUAL_ID:
			return getTask_3001ContainedLinks(view);
		case SendEditPart.VISUAL_ID:
			return getSend_3002ContainedLinks(view);
		case ReceiveEditPart.VISUAL_ID:
			return getReceive_3003ContainedLinks(view);
		case ActionEditPart.VISUAL_ID:
			return getAction_3004ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getIncomingLinks(View view) {
		switch (PlanVisualIDRegistry.getVisualID(view)) {
		case PlanEditPart.VISUAL_ID:
			return getPlan_2001IncomingLinks(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_2002IncomingLinks(view);
		case TaskEditPart.VISUAL_ID:
			return getTask_3001IncomingLinks(view);
		case SendEditPart.VISUAL_ID:
			return getSend_3002IncomingLinks(view);
		case ReceiveEditPart.VISUAL_ID:
			return getReceive_3003IncomingLinks(view);
		case ActionEditPart.VISUAL_ID:
			return getAction_3004IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getOutgoingLinks(View view) {
		switch (PlanVisualIDRegistry.getVisualID(view)) {
		case PlanEditPart.VISUAL_ID:
			return getPlan_2001OutgoingLinks(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_2002OutgoingLinks(view);
		case TaskEditPart.VISUAL_ID:
			return getTask_3001OutgoingLinks(view);
		case SendEditPart.VISUAL_ID:
			return getSend_3002OutgoingLinks(view);
		case ReceiveEditPart.VISUAL_ID:
			return getReceive_3003OutgoingLinks(view);
		case ActionEditPart.VISUAL_ID:
			return getAction_3004OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getPlanPallete_1000ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getPlan_2001ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getMessage_2002ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getTask_3001ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getSend_3002ContainedLinks(View view) {
		Send modelElement = (Send) view.getElement();
		LinkedList<PlanLinkDescriptor> result = new LinkedList<PlanLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Send_Send_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getReceive_3003ContainedLinks(
			View view) {
		Receive modelElement = (Receive) view.getElement();
		LinkedList<PlanLinkDescriptor> result = new LinkedList<PlanLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Receive_Receive_4002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getAction_3004ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getPlan_2001IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getMessage_2002IncomingLinks(
			View view) {
		Message modelElement = (Message) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<PlanLinkDescriptor> result = new LinkedList<PlanLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_Send_Send_4001(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Receive_Receive_4002(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getTask_3001IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getSend_3002IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getReceive_3003IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getAction_3004IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getPlan_2001OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getMessage_2002OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getTask_3001OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getSend_3002OutgoingLinks(View view) {
		Send modelElement = (Send) view.getElement();
		LinkedList<PlanLinkDescriptor> result = new LinkedList<PlanLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Send_Send_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getReceive_3003OutgoingLinks(
			View view) {
		Receive modelElement = (Receive) view.getElement();
		LinkedList<PlanLinkDescriptor> result = new LinkedList<PlanLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Receive_Receive_4002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<PlanLinkDescriptor> getAction_3004OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	private static Collection<PlanLinkDescriptor> getIncomingFeatureModelFacetLinks_Send_Send_4001(
			Message target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<PlanLinkDescriptor> result = new LinkedList<PlanLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == PlanPackage.eINSTANCE
					.getSend_Send()) {
				result.add(new PlanLinkDescriptor(setting.getEObject(), target,
						PlanElementTypes.SendSend_4001,
						SendSendEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<PlanLinkDescriptor> getIncomingFeatureModelFacetLinks_Receive_Receive_4002(
			Message target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<PlanLinkDescriptor> result = new LinkedList<PlanLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == PlanPackage.eINSTANCE
					.getReceive_Receive()) {
				result.add(new PlanLinkDescriptor(setting.getEObject(), target,
						PlanElementTypes.ReceiveReceive_4002,
						ReceiveReceiveEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<PlanLinkDescriptor> getOutgoingFeatureModelFacetLinks_Send_Send_4001(
			Send source) {
		LinkedList<PlanLinkDescriptor> result = new LinkedList<PlanLinkDescriptor>();
		Message destination = source.getSend();
		if (destination == null) {
			return result;
		}
		result.add(new PlanLinkDescriptor(source, destination,
				PlanElementTypes.SendSend_4001, SendSendEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<PlanLinkDescriptor> getOutgoingFeatureModelFacetLinks_Receive_Receive_4002(
			Receive source) {
		LinkedList<PlanLinkDescriptor> result = new LinkedList<PlanLinkDescriptor>();
		Message destination = source.getReceive();
		if (destination == null) {
			return result;
		}
		result.add(new PlanLinkDescriptor(source, destination,
				PlanElementTypes.ReceiveReceive_4002,
				ReceiveReceiveEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	public static final DiagramUpdater TYPED_INSTANCE = new DiagramUpdater() {
		/**
		 * @generated
		 */
		@Override
		public List<PlanNodeDescriptor> getSemanticChildren(View view) {
			return PlanDiagramUpdater.getSemanticChildren(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<PlanLinkDescriptor> getContainedLinks(View view) {
			return PlanDiagramUpdater.getContainedLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<PlanLinkDescriptor> getIncomingLinks(View view) {
			return PlanDiagramUpdater.getIncomingLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<PlanLinkDescriptor> getOutgoingLinks(View view) {
			return PlanDiagramUpdater.getOutgoingLinks(view);
		}
	};

}
