/*
 * 
 */
package plan.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;

import plan.PlanPackage;
import plan.PlanPallete;
import plan.diagram.edit.parts.ActionEditPart;
import plan.diagram.edit.parts.ActionName1EditPart;
import plan.diagram.edit.parts.MessageEditPart;
import plan.diagram.edit.parts.MessageName2EditPart;
import plan.diagram.edit.parts.PlanEditPart;
import plan.diagram.edit.parts.PlanNameEditPart;
import plan.diagram.edit.parts.PlanPalleteEditPart;
import plan.diagram.edit.parts.PlanPlanComposed_ofCompartmentEditPart;
import plan.diagram.edit.parts.ReceiveEditPart;
import plan.diagram.edit.parts.ReceiveName1EditPart;
import plan.diagram.edit.parts.ReceiveReceiveEditPart;
import plan.diagram.edit.parts.SendEditPart;
import plan.diagram.edit.parts.SendName1EditPart;
import plan.diagram.edit.parts.SendSendEditPart;
import plan.diagram.edit.parts.TaskEditPart;
import plan.diagram.edit.parts.TaskName0EditPart;
import plan.diagram.edit.parts.TaskTaskComposed_ofCompartmentEditPart;
import plan.diagram.edit.parts.WrappingLabel2EditPart;
import plan.diagram.edit.parts.WrappingLabelEditPart;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class PlanVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "Plan.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (PlanPalleteEditPart.MODEL_ID.equals(view.getType())) {
				return PlanPalleteEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return plan.diagram.part.PlanVisualIDRegistry.getVisualID(view
				.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				PlanDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (PlanPackage.eINSTANCE.getPlanPallete().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((PlanPallete) domainElement)) {
			return PlanPalleteEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = plan.diagram.part.PlanVisualIDRegistry
				.getModelID(containerView);
		if (!PlanPalleteEditPart.MODEL_ID.equals(containerModelID)
				&& !"plan".equals(containerModelID)) { //$NON-NLS-1$
			return -1;
		}
		int containerVisualID;
		if (PlanPalleteEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = plan.diagram.part.PlanVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = PlanPalleteEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case PlanPalleteEditPart.VISUAL_ID:
			if (PlanPackage.eINSTANCE.getPlan().isSuperTypeOf(
					domainElement.eClass())) {
				return PlanEditPart.VISUAL_ID;
			}
			if (PlanPackage.eINSTANCE.getMessage().isSuperTypeOf(
					domainElement.eClass())) {
				return MessageEditPart.VISUAL_ID;
			}
			break;
		case PlanPlanComposed_ofCompartmentEditPart.VISUAL_ID:
			if (PlanPackage.eINSTANCE.getTask().isSuperTypeOf(
					domainElement.eClass())) {
				return TaskEditPart.VISUAL_ID;
			}
			break;
		case TaskTaskComposed_ofCompartmentEditPart.VISUAL_ID:
			if (PlanPackage.eINSTANCE.getSend().isSuperTypeOf(
					domainElement.eClass())) {
				return SendEditPart.VISUAL_ID;
			}
			if (PlanPackage.eINSTANCE.getReceive().isSuperTypeOf(
					domainElement.eClass())) {
				return ReceiveEditPart.VISUAL_ID;
			}
			if (PlanPackage.eINSTANCE.getAction().isSuperTypeOf(
					domainElement.eClass())) {
				return ActionEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = plan.diagram.part.PlanVisualIDRegistry
				.getModelID(containerView);
		if (!PlanPalleteEditPart.MODEL_ID.equals(containerModelID)
				&& !"plan".equals(containerModelID)) { //$NON-NLS-1$
			return false;
		}
		int containerVisualID;
		if (PlanPalleteEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = plan.diagram.part.PlanVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = PlanPalleteEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case PlanPalleteEditPart.VISUAL_ID:
			if (PlanEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MessageEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case PlanEditPart.VISUAL_ID:
			if (PlanNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (PlanPlanComposed_ofCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MessageEditPart.VISUAL_ID:
			if (MessageName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case TaskEditPart.VISUAL_ID:
			if (TaskName0EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (TaskTaskComposed_ofCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SendEditPart.VISUAL_ID:
			if (SendName1EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ReceiveEditPart.VISUAL_ID:
			if (ReceiveName1EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ActionEditPart.VISUAL_ID:
			if (ActionName1EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case PlanPlanComposed_ofCompartmentEditPart.VISUAL_ID:
			if (TaskEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case TaskTaskComposed_ofCompartmentEditPart.VISUAL_ID:
			if (SendEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ReceiveEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ActionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SendSendEditPart.VISUAL_ID:
			if (WrappingLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ReceiveReceiveEditPart.VISUAL_ID:
			if (WrappingLabel2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(PlanPallete element) {
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView,
			EObject domainElement, int candidate) {
		if (candidate == -1) {
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID) {
		switch (visualID) {
		case PlanPlanComposed_ofCompartmentEditPart.VISUAL_ID:
		case TaskTaskComposed_ofCompartmentEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID) {
		switch (visualID) {
		case PlanPalleteEditPart.VISUAL_ID:
			return false;
		case MessageEditPart.VISUAL_ID:
		case SendEditPart.VISUAL_ID:
		case ReceiveEditPart.VISUAL_ID:
		case ActionEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure TYPED_INSTANCE = new DiagramStructure() {
		/**
		 * @generated
		 */
		@Override
		public int getVisualID(View view) {
			return plan.diagram.part.PlanVisualIDRegistry.getVisualID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public String getModelID(View view) {
			return plan.diagram.part.PlanVisualIDRegistry.getModelID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public int getNodeVisualID(View containerView, EObject domainElement) {
			return plan.diagram.part.PlanVisualIDRegistry.getNodeVisualID(
					containerView, domainElement);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean checkNodeVisualID(View containerView,
				EObject domainElement, int candidate) {
			return plan.diagram.part.PlanVisualIDRegistry.checkNodeVisualID(
					containerView, domainElement, candidate);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isCompartmentVisualID(int visualID) {
			return plan.diagram.part.PlanVisualIDRegistry
					.isCompartmentVisualID(visualID);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isSemanticLeafVisualID(int visualID) {
			return plan.diagram.part.PlanVisualIDRegistry
					.isSemanticLeafVisualID(visualID);
		}
	};

}
