/*
 * 
 */
package plan.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

import plan.PlanPackage;
import plan.diagram.edit.parts.ActionEditPart;
import plan.diagram.edit.parts.MessageEditPart;
import plan.diagram.edit.parts.PlanEditPart;
import plan.diagram.edit.parts.PlanPalleteEditPart;
import plan.diagram.edit.parts.ReceiveEditPart;
import plan.diagram.edit.parts.ReceiveReceiveEditPart;
import plan.diagram.edit.parts.SendEditPart;
import plan.diagram.edit.parts.SendSendEditPart;
import plan.diagram.edit.parts.TaskEditPart;
import plan.diagram.part.PlanDiagramEditorPlugin;

/**
 * @generated
 */
public class PlanElementTypes {

	/**
	 * @generated
	 */
	private PlanElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType PlanPallete_1000 = getElementType("Plan.diagram.PlanPallete_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Plan_2001 = getElementType("Plan.diagram.Plan_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Message_2002 = getElementType("Plan.diagram.Message_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Task_3001 = getElementType("Plan.diagram.Task_3001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Send_3002 = getElementType("Plan.diagram.Send_3002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Receive_3003 = getElementType("Plan.diagram.Receive_3003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Action_3004 = getElementType("Plan.diagram.Action_3004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SendSend_4001 = getElementType("Plan.diagram.SendSend_4001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType ReceiveReceive_4002 = getElementType("Plan.diagram.ReceiveReceive_4002"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return PlanDiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(PlanPallete_1000,
					PlanPackage.eINSTANCE.getPlanPallete());

			elements.put(Plan_2001, PlanPackage.eINSTANCE.getPlan());

			elements.put(Message_2002, PlanPackage.eINSTANCE.getMessage());

			elements.put(Task_3001, PlanPackage.eINSTANCE.getTask());

			elements.put(Send_3002, PlanPackage.eINSTANCE.getSend());

			elements.put(Receive_3003, PlanPackage.eINSTANCE.getReceive());

			elements.put(Action_3004, PlanPackage.eINSTANCE.getAction());

			elements.put(SendSend_4001, PlanPackage.eINSTANCE.getSend_Send());

			elements.put(ReceiveReceive_4002,
					PlanPackage.eINSTANCE.getReceive_Receive());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(PlanPallete_1000);
			KNOWN_ELEMENT_TYPES.add(Plan_2001);
			KNOWN_ELEMENT_TYPES.add(Message_2002);
			KNOWN_ELEMENT_TYPES.add(Task_3001);
			KNOWN_ELEMENT_TYPES.add(Send_3002);
			KNOWN_ELEMENT_TYPES.add(Receive_3003);
			KNOWN_ELEMENT_TYPES.add(Action_3004);
			KNOWN_ELEMENT_TYPES.add(SendSend_4001);
			KNOWN_ELEMENT_TYPES.add(ReceiveReceive_4002);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case PlanPalleteEditPart.VISUAL_ID:
			return PlanPallete_1000;
		case PlanEditPart.VISUAL_ID:
			return Plan_2001;
		case MessageEditPart.VISUAL_ID:
			return Message_2002;
		case TaskEditPart.VISUAL_ID:
			return Task_3001;
		case SendEditPart.VISUAL_ID:
			return Send_3002;
		case ReceiveEditPart.VISUAL_ID:
			return Receive_3003;
		case ActionEditPart.VISUAL_ID:
			return Action_3004;
		case SendSendEditPart.VISUAL_ID:
			return SendSend_4001;
		case ReceiveReceiveEditPart.VISUAL_ID:
			return ReceiveReceive_4002;
		}
		return null;
	}

}
