/*
 * 
 */
package plan.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

import plan.PlanPackage;
import plan.diagram.edit.parts.ActionName1EditPart;
import plan.diagram.edit.parts.MessageName2EditPart;
import plan.diagram.edit.parts.PlanNameEditPart;
import plan.diagram.edit.parts.ReceiveName1EditPart;
import plan.diagram.edit.parts.SendName1EditPart;
import plan.diagram.edit.parts.TaskName0EditPart;
import plan.diagram.parsers.MessageFormatParser;
import plan.diagram.part.PlanVisualIDRegistry;

/**
 * @generated
 */
public class PlanParserProvider extends AbstractProvider implements
		IParserProvider {

	/**
	 * @generated
	 */
	private IParser planName_5005Parser;

	/**
	 * @generated
	 */
	private IParser getPlanName_5005Parser() {
		if (planName_5005Parser == null) {
			EAttribute[] features = new EAttribute[] { PlanPackage.eINSTANCE
					.getPlan_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			planName_5005Parser = parser;
		}
		return planName_5005Parser;
	}

	/**
	 * @generated
	 */
	private IParser messageName2_5006Parser;

	/**
	 * @generated
	 */
	private IParser getMessageName2_5006Parser() {
		if (messageName2_5006Parser == null) {
			EAttribute[] features = new EAttribute[] { PlanPackage.eINSTANCE
					.getMessage_Name2() };
			MessageFormatParser parser = new MessageFormatParser(features);
			messageName2_5006Parser = parser;
		}
		return messageName2_5006Parser;
	}

	/**
	 * @generated
	 */
	private IParser taskName0_5004Parser;

	/**
	 * @generated
	 */
	private IParser getTaskName0_5004Parser() {
		if (taskName0_5004Parser == null) {
			EAttribute[] features = new EAttribute[] { PlanPackage.eINSTANCE
					.getTask_Name0() };
			MessageFormatParser parser = new MessageFormatParser(features);
			taskName0_5004Parser = parser;
		}
		return taskName0_5004Parser;
	}

	/**
	 * @generated
	 */
	private IParser sendName1_5001Parser;

	/**
	 * @generated
	 */
	private IParser getSendName1_5001Parser() {
		if (sendName1_5001Parser == null) {
			EAttribute[] features = new EAttribute[] { PlanPackage.eINSTANCE
					.getAction_Name1() };
			MessageFormatParser parser = new MessageFormatParser(features);
			sendName1_5001Parser = parser;
		}
		return sendName1_5001Parser;
	}

	/**
	 * @generated
	 */
	private IParser receiveName1_5002Parser;

	/**
	 * @generated
	 */
	private IParser getReceiveName1_5002Parser() {
		if (receiveName1_5002Parser == null) {
			EAttribute[] features = new EAttribute[] { PlanPackage.eINSTANCE
					.getAction_Name1() };
			MessageFormatParser parser = new MessageFormatParser(features);
			receiveName1_5002Parser = parser;
		}
		return receiveName1_5002Parser;
	}

	/**
	 * @generated
	 */
	private IParser actionName1_5003Parser;

	/**
	 * @generated
	 */
	private IParser getActionName1_5003Parser() {
		if (actionName1_5003Parser == null) {
			EAttribute[] features = new EAttribute[] { PlanPackage.eINSTANCE
					.getAction_Name1() };
			MessageFormatParser parser = new MessageFormatParser(features);
			actionName1_5003Parser = parser;
		}
		return actionName1_5003Parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case PlanNameEditPart.VISUAL_ID:
			return getPlanName_5005Parser();
		case MessageName2EditPart.VISUAL_ID:
			return getMessageName2_5006Parser();
		case TaskName0EditPart.VISUAL_ID:
			return getTaskName0_5004Parser();
		case SendName1EditPart.VISUAL_ID:
			return getSendName1_5001Parser();
		case ReceiveName1EditPart.VISUAL_ID:
			return getReceiveName1_5002Parser();
		case ActionName1EditPart.VISUAL_ID:
			return getActionName1_5003Parser();
		}
		return null;
	}

	/**
	 * Utility method that consults ParserService
	 * @generated
	 */
	public static IParser getParser(IElementType type, EObject object,
			String parserHint) {
		return ParserService.getInstance().getParser(
				new HintAdapter(type, object, parserHint));
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(PlanVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(PlanVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (PlanElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	private static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
