/*
 * 
 */
package role.diagram.edit.parts;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.directedit.locator.CellEditorLocatorAccess;

import role.diagram.part.RoleVisualIDRegistry;

/**
 * @generated
 */
public class RoleEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (RoleVisualIDRegistry.getVisualID(view)) {

			case RoleViewpointEditPart.VISUAL_ID:
				return new RoleViewpointEditPart(view);

			case RegistrationRoleEditPart.VISUAL_ID:
				return new RegistrationRoleEditPart(view);

			case RegistrationRoleNameEditPart.VISUAL_ID:
				return new RegistrationRoleNameEditPart(view);

			case OntologyMediatorRoleEditPart.VISUAL_ID:
				return new OntologyMediatorRoleEditPart(view);

			case OntologyMediatorRoleNameEditPart.VISUAL_ID:
				return new OntologyMediatorRoleNameEditPart(view);

			case DomainRoleEditPart.VISUAL_ID:
				return new DomainRoleEditPart(view);

			case DomainRoleNameEditPart.VISUAL_ID:
				return new DomainRoleNameEditPart(view);

			case SemanticWebServiceEditPart.VISUAL_ID:
				return new SemanticWebServiceEditPart(view);

			case SemanticWebServiceNameEditPart.VISUAL_ID:
				return new SemanticWebServiceNameEditPart(view);

			case InteractionEditPart.VISUAL_ID:
				return new InteractionEditPart(view);

			case InteractionNameEditPart.VISUAL_ID:
				return new InteractionNameEditPart(view);

			case RoleRealizesEditPart.VISUAL_ID:
				return new RoleRealizesEditPart(view);

			case RoleRealizesExternalLabelEditPart.VISUAL_ID:
				return new RoleRealizesExternalLabelEditPart(view);

			case RegistrationRoleAdvertisesEditPart.VISUAL_ID:
				return new RegistrationRoleAdvertisesEditPart(view);

			case RegistrationRoleAdvertisesExternalLabelEditPart.VISUAL_ID:
				return new RegistrationRoleAdvertisesExternalLabelEditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		return CellEditorLocatorAccess.INSTANCE
				.getTextCellEditorLocator(source);
	}

}
