/*
 * 
 */
package role.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

import role.diagram.edit.commands.DomainRoleCreateCommand;
import role.diagram.edit.commands.InteractionCreateCommand;
import role.diagram.edit.commands.OntologyMediatorRoleCreateCommand;
import role.diagram.edit.commands.RegistrationRoleCreateCommand;
import role.diagram.edit.commands.SemanticWebServiceCreateCommand;
import role.diagram.providers.RoleElementTypes;

/**
 * @generated
 */
public class RoleViewpointItemSemanticEditPolicy extends
		RoleBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public RoleViewpointItemSemanticEditPolicy() {
		super(RoleElementTypes.RoleViewpoint_1000);
	}

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (RoleElementTypes.RegistrationRole_2001 == req.getElementType()) {
			return getGEFWrapper(new RegistrationRoleCreateCommand(req));
		}
		if (RoleElementTypes.OntologyMediatorRole_2002 == req.getElementType()) {
			return getGEFWrapper(new OntologyMediatorRoleCreateCommand(req));
		}
		if (RoleElementTypes.DomainRole_2003 == req.getElementType()) {
			return getGEFWrapper(new DomainRoleCreateCommand(req));
		}
		if (RoleElementTypes.SemanticWebService_2004 == req.getElementType()) {
			return getGEFWrapper(new SemanticWebServiceCreateCommand(req));
		}
		if (RoleElementTypes.Interaction_2005 == req.getElementType()) {
			return getGEFWrapper(new InteractionCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
