/*
 * 
 */
package role.diagram.navigator;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.common.ui.services.parser.CommonParserHint;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import role.diagram.edit.parts.DomainRoleEditPart;
import role.diagram.edit.parts.DomainRoleNameEditPart;
import role.diagram.edit.parts.InteractionEditPart;
import role.diagram.edit.parts.InteractionNameEditPart;
import role.diagram.edit.parts.OntologyMediatorRoleEditPart;
import role.diagram.edit.parts.OntologyMediatorRoleNameEditPart;
import role.diagram.edit.parts.RegistrationRoleAdvertisesEditPart;
import role.diagram.edit.parts.RegistrationRoleEditPart;
import role.diagram.edit.parts.RegistrationRoleNameEditPart;
import role.diagram.edit.parts.RoleRealizesEditPart;
import role.diagram.edit.parts.RoleViewpointEditPart;
import role.diagram.edit.parts.SemanticWebServiceEditPart;
import role.diagram.edit.parts.SemanticWebServiceNameEditPart;
import role.diagram.part.RoleDiagramEditorPlugin;
import role.diagram.part.RoleVisualIDRegistry;
import role.diagram.providers.RoleElementTypes;
import role.diagram.providers.RoleParserProvider;

/**
 * @generated
 */
public class RoleNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		RoleDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		RoleDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof RoleNavigatorItem
				&& !isOwnView(((RoleNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof RoleNavigatorGroup) {
			RoleNavigatorGroup group = (RoleNavigatorGroup) element;
			return RoleDiagramEditorPlugin.getInstance().getBundledImage(
					group.getIcon());
		}

		if (element instanceof RoleNavigatorItem) {
			RoleNavigatorItem navigatorItem = (RoleNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getImage(view);
			}
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case OntologyMediatorRoleEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?role?OntologyMediatorRole", RoleElementTypes.OntologyMediatorRole_2002); //$NON-NLS-1$
		case InteractionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?role?Interaction", RoleElementTypes.Interaction_2005); //$NON-NLS-1$
		case DomainRoleEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?role?DomainRole", RoleElementTypes.DomainRole_2003); //$NON-NLS-1$
		case RoleViewpointEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?role?RoleViewpoint", RoleElementTypes.RoleViewpoint_1000); //$NON-NLS-1$
		case RoleRealizesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?role?Role?realizes", RoleElementTypes.RoleRealizes_4001); //$NON-NLS-1$
		case RegistrationRoleEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?role?RegistrationRole", RoleElementTypes.RegistrationRole_2001); //$NON-NLS-1$
		case SemanticWebServiceEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?role?SemanticWebService", RoleElementTypes.SemanticWebService_2004); //$NON-NLS-1$
		case RegistrationRoleAdvertisesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?role?RegistrationRole?advertises", RoleElementTypes.RegistrationRoleAdvertises_4002); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = RoleDiagramEditorPlugin.getInstance()
				.getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& RoleElementTypes.isKnownElementType(elementType)) {
			image = RoleElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof RoleNavigatorGroup) {
			RoleNavigatorGroup group = (RoleNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof RoleNavigatorItem) {
			RoleNavigatorItem navigatorItem = (RoleNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getText(view);
			}
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case OntologyMediatorRoleEditPart.VISUAL_ID:
			return getOntologyMediatorRole_2002Text(view);
		case InteractionEditPart.VISUAL_ID:
			return getInteraction_2005Text(view);
		case DomainRoleEditPart.VISUAL_ID:
			return getDomainRole_2003Text(view);
		case RoleViewpointEditPart.VISUAL_ID:
			return getRoleViewpoint_1000Text(view);
		case RoleRealizesEditPart.VISUAL_ID:
			return getRoleRealizes_4001Text(view);
		case RegistrationRoleEditPart.VISUAL_ID:
			return getRegistrationRole_2001Text(view);
		case SemanticWebServiceEditPart.VISUAL_ID:
			return getSemanticWebService_2004Text(view);
		case RegistrationRoleAdvertisesEditPart.VISUAL_ID:
			return getRegistrationRoleAdvertises_4002Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getOntologyMediatorRole_2002Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.OntologyMediatorRole_2002,
				view.getElement() != null ? view.getElement() : view,
				RoleVisualIDRegistry
						.getType(OntologyMediatorRoleNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getInteraction_2005Text(View view) {
		IParser parser = RoleParserProvider
				.getParser(RoleElementTypes.Interaction_2005,
						view.getElement() != null ? view.getElement() : view,
						RoleVisualIDRegistry
								.getType(InteractionNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getDomainRole_2003Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.DomainRole_2003,
				view.getElement() != null ? view.getElement() : view,
				RoleVisualIDRegistry.getType(DomainRoleNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRoleViewpoint_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getRoleRealizes_4001Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.RoleRealizes_4001,
				view.getElement() != null ? view.getElement() : view,
				CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRegistrationRole_2001Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.RegistrationRole_2001,
				view.getElement() != null ? view.getElement() : view,
				RoleVisualIDRegistry
						.getType(RegistrationRoleNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSemanticWebService_2004Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.SemanticWebService_2004,
				view.getElement() != null ? view.getElement() : view,
				RoleVisualIDRegistry
						.getType(SemanticWebServiceNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRegistrationRoleAdvertises_4002Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.RegistrationRoleAdvertises_4002,
				view.getElement() != null ? view.getElement() : view,
				CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return RoleViewpointEditPart.MODEL_ID.equals(RoleVisualIDRegistry
				.getModelID(view));
	}

}
