/*
 * 
 */
package role.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;

import role.RolePackage;
import role.RoleViewpoint;
import role.diagram.edit.parts.DomainRoleEditPart;
import role.diagram.edit.parts.DomainRoleNameEditPart;
import role.diagram.edit.parts.InteractionEditPart;
import role.diagram.edit.parts.InteractionNameEditPart;
import role.diagram.edit.parts.OntologyMediatorRoleEditPart;
import role.diagram.edit.parts.OntologyMediatorRoleNameEditPart;
import role.diagram.edit.parts.RegistrationRoleAdvertisesEditPart;
import role.diagram.edit.parts.RegistrationRoleAdvertisesExternalLabelEditPart;
import role.diagram.edit.parts.RegistrationRoleEditPart;
import role.diagram.edit.parts.RegistrationRoleNameEditPart;
import role.diagram.edit.parts.RoleRealizesEditPart;
import role.diagram.edit.parts.RoleRealizesExternalLabelEditPart;
import role.diagram.edit.parts.RoleViewpointEditPart;
import role.diagram.edit.parts.SemanticWebServiceEditPart;
import role.diagram.edit.parts.SemanticWebServiceNameEditPart;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class RoleVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "Role.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (RoleViewpointEditPart.MODEL_ID.equals(view.getType())) {
				return RoleViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return role.diagram.part.RoleVisualIDRegistry.getVisualID(view
				.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				RoleDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (RolePackage.eINSTANCE.getRoleViewpoint().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((RoleViewpoint) domainElement)) {
			return RoleViewpointEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = role.diagram.part.RoleVisualIDRegistry
				.getModelID(containerView);
		if (!RoleViewpointEditPart.MODEL_ID.equals(containerModelID)
				&& !"role".equals(containerModelID)) { //$NON-NLS-1$
			return -1;
		}
		int containerVisualID;
		if (RoleViewpointEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = role.diagram.part.RoleVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = RoleViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case RoleViewpointEditPart.VISUAL_ID:
			if (RolePackage.eINSTANCE.getRegistrationRole().isSuperTypeOf(
					domainElement.eClass())) {
				return RegistrationRoleEditPart.VISUAL_ID;
			}
			if (RolePackage.eINSTANCE.getOntologyMediatorRole().isSuperTypeOf(
					domainElement.eClass())) {
				return OntologyMediatorRoleEditPart.VISUAL_ID;
			}
			if (RolePackage.eINSTANCE.getDomainRole().isSuperTypeOf(
					domainElement.eClass())) {
				return DomainRoleEditPart.VISUAL_ID;
			}
			if (RolePackage.eINSTANCE.getSemanticWebService().isSuperTypeOf(
					domainElement.eClass())) {
				return SemanticWebServiceEditPart.VISUAL_ID;
			}
			if (RolePackage.eINSTANCE.getInteraction().isSuperTypeOf(
					domainElement.eClass())) {
				return InteractionEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = role.diagram.part.RoleVisualIDRegistry
				.getModelID(containerView);
		if (!RoleViewpointEditPart.MODEL_ID.equals(containerModelID)
				&& !"role".equals(containerModelID)) { //$NON-NLS-1$
			return false;
		}
		int containerVisualID;
		if (RoleViewpointEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = role.diagram.part.RoleVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = RoleViewpointEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case RoleViewpointEditPart.VISUAL_ID:
			if (RegistrationRoleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (OntologyMediatorRoleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (DomainRoleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SemanticWebServiceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (InteractionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case RegistrationRoleEditPart.VISUAL_ID:
			if (RegistrationRoleNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case OntologyMediatorRoleEditPart.VISUAL_ID:
			if (OntologyMediatorRoleNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case DomainRoleEditPart.VISUAL_ID:
			if (DomainRoleNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SemanticWebServiceEditPart.VISUAL_ID:
			if (SemanticWebServiceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InteractionEditPart.VISUAL_ID:
			if (InteractionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case RoleRealizesEditPart.VISUAL_ID:
			if (RoleRealizesExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case RegistrationRoleAdvertisesEditPart.VISUAL_ID:
			if (RegistrationRoleAdvertisesExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(RoleViewpoint element) {
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView,
			EObject domainElement, int candidate) {
		if (candidate == -1) {
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID) {
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID) {
		switch (visualID) {
		case RoleViewpointEditPart.VISUAL_ID:
			return false;
		case RegistrationRoleEditPart.VISUAL_ID:
		case OntologyMediatorRoleEditPart.VISUAL_ID:
		case DomainRoleEditPart.VISUAL_ID:
		case SemanticWebServiceEditPart.VISUAL_ID:
		case InteractionEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure TYPED_INSTANCE = new DiagramStructure() {
		/**
		 * @generated
		 */
		@Override
		public int getVisualID(View view) {
			return role.diagram.part.RoleVisualIDRegistry.getVisualID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public String getModelID(View view) {
			return role.diagram.part.RoleVisualIDRegistry.getModelID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public int getNodeVisualID(View containerView, EObject domainElement) {
			return role.diagram.part.RoleVisualIDRegistry.getNodeVisualID(
					containerView, domainElement);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean checkNodeVisualID(View containerView,
				EObject domainElement, int candidate) {
			return role.diagram.part.RoleVisualIDRegistry.checkNodeVisualID(
					containerView, domainElement, candidate);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isCompartmentVisualID(int visualID) {
			return role.diagram.part.RoleVisualIDRegistry
					.isCompartmentVisualID(visualID);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isSemanticLeafVisualID(int visualID) {
			return role.diagram.part.RoleVisualIDRegistry
					.isSemanticLeafVisualID(visualID);
		}
	};

}
