/*
 * 
 */
package role.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

import role.RolePackage;
import role.diagram.edit.parts.DomainRoleNameEditPart;
import role.diagram.edit.parts.InteractionNameEditPart;
import role.diagram.edit.parts.OntologyMediatorRoleNameEditPart;
import role.diagram.edit.parts.RegistrationRoleNameEditPart;
import role.diagram.edit.parts.SemanticWebServiceNameEditPart;
import role.diagram.parsers.MessageFormatParser;
import role.diagram.part.RoleVisualIDRegistry;

/**
 * @generated
 */
public class RoleParserProvider extends AbstractProvider implements
		IParserProvider {

	/**
	 * @generated
	 */
	private IParser registrationRoleName_5001Parser;

	/**
	 * @generated
	 */
	private IParser getRegistrationRoleName_5001Parser() {
		if (registrationRoleName_5001Parser == null) {
			EAttribute[] features = new EAttribute[] { RolePackage.eINSTANCE
					.getRole_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			registrationRoleName_5001Parser = parser;
		}
		return registrationRoleName_5001Parser;
	}

	/**
	 * @generated
	 */
	private IParser ontologyMediatorRoleName_5002Parser;

	/**
	 * @generated
	 */
	private IParser getOntologyMediatorRoleName_5002Parser() {
		if (ontologyMediatorRoleName_5002Parser == null) {
			EAttribute[] features = new EAttribute[] { RolePackage.eINSTANCE
					.getRole_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			ontologyMediatorRoleName_5002Parser = parser;
		}
		return ontologyMediatorRoleName_5002Parser;
	}

	/**
	 * @generated
	 */
	private IParser domainRoleName_5003Parser;

	/**
	 * @generated
	 */
	private IParser getDomainRoleName_5003Parser() {
		if (domainRoleName_5003Parser == null) {
			EAttribute[] features = new EAttribute[] { RolePackage.eINSTANCE
					.getRole_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			domainRoleName_5003Parser = parser;
		}
		return domainRoleName_5003Parser;
	}

	/**
	 * @generated
	 */
	private IParser semanticWebServiceName_5004Parser;

	/**
	 * @generated
	 */
	private IParser getSemanticWebServiceName_5004Parser() {
		if (semanticWebServiceName_5004Parser == null) {
			EAttribute[] features = new EAttribute[] { RolePackage.eINSTANCE
					.getSemanticWebService_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			semanticWebServiceName_5004Parser = parser;
		}
		return semanticWebServiceName_5004Parser;
	}

	/**
	 * @generated
	 */
	private IParser interactionName_5005Parser;

	/**
	 * @generated
	 */
	private IParser getInteractionName_5005Parser() {
		if (interactionName_5005Parser == null) {
			EAttribute[] features = new EAttribute[] { RolePackage.eINSTANCE
					.getInteraction_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			interactionName_5005Parser = parser;
		}
		return interactionName_5005Parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case RegistrationRoleNameEditPart.VISUAL_ID:
			return getRegistrationRoleName_5001Parser();
		case OntologyMediatorRoleNameEditPart.VISUAL_ID:
			return getOntologyMediatorRoleName_5002Parser();
		case DomainRoleNameEditPart.VISUAL_ID:
			return getDomainRoleName_5003Parser();
		case SemanticWebServiceNameEditPart.VISUAL_ID:
			return getSemanticWebServiceName_5004Parser();
		case InteractionNameEditPart.VISUAL_ID:
			return getInteractionName_5005Parser();
		}
		return null;
	}

	/**
	 * Utility method that consults ParserService
	 * @generated
	 */
	public static IParser getParser(IElementType type, EObject object,
			String parserHint) {
		return ParserService.getInstance().getParser(
				new HintAdapter(type, object, parserHint));
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(RoleVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(RoleVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (RoleElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	private static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
