/**
 */
package role;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see role.RoleFactory
 * @model kind="package"
 * @generated
 */
public interface RolePackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "role";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "role";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "role";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  RolePackage eINSTANCE = role.impl.RolePackageImpl.init();

  /**
   * The meta object id for the '{@link role.impl.RoleViewpointImpl <em>Viewpoint</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see role.impl.RoleViewpointImpl
   * @see role.impl.RolePackageImpl#getRoleViewpoint()
   * @generated
   */
  int ROLE_VIEWPOINT = 0;

  /**
   * The feature id for the '<em><b>Has Domain Role</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_VIEWPOINT__HAS_DOMAIN_ROLE = 0;

  /**
   * The feature id for the '<em><b>Has Registration Role</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_VIEWPOINT__HAS_REGISTRATION_ROLE = 1;

  /**
   * The feature id for the '<em><b>Has Ontology Mediator Role</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_VIEWPOINT__HAS_ONTOLOGY_MEDIATOR_ROLE = 2;

  /**
   * The feature id for the '<em><b>Has Semantic Web Service</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_VIEWPOINT__HAS_SEMANTIC_WEB_SERVICE = 3;

  /**
   * The feature id for the '<em><b>Has Interaction</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_VIEWPOINT__HAS_INTERACTION = 4;

  /**
   * The number of structural features of the '<em>Viewpoint</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_VIEWPOINT_FEATURE_COUNT = 5;

  /**
   * The meta object id for the '{@link role.impl.RoleImpl <em>Role</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see role.impl.RoleImpl
   * @see role.impl.RolePackageImpl#getRole()
   * @generated
   */
  int ROLE = 1;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__NAME = 0;

  /**
   * The feature id for the '<em><b>Realizes</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__REALIZES = 1;

  /**
   * The number of structural features of the '<em>Role</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link role.impl.DomainRoleImpl <em>Domain Role</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see role.impl.DomainRoleImpl
   * @see role.impl.RolePackageImpl#getDomainRole()
   * @generated
   */
  int DOMAIN_ROLE = 2;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DOMAIN_ROLE__NAME = ROLE__NAME;

  /**
   * The feature id for the '<em><b>Realizes</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DOMAIN_ROLE__REALIZES = ROLE__REALIZES;

  /**
   * The number of structural features of the '<em>Domain Role</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DOMAIN_ROLE_FEATURE_COUNT = ROLE_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link role.impl.ArchitectureRoleImpl <em>Architecture Role</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see role.impl.ArchitectureRoleImpl
   * @see role.impl.RolePackageImpl#getArchitectureRole()
   * @generated
   */
  int ARCHITECTURE_ROLE = 3;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARCHITECTURE_ROLE__NAME = ROLE__NAME;

  /**
   * The feature id for the '<em><b>Realizes</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARCHITECTURE_ROLE__REALIZES = ROLE__REALIZES;

  /**
   * The feature id for the '<em><b>Scope</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARCHITECTURE_ROLE__SCOPE = ROLE_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Architecture Role</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARCHITECTURE_ROLE_FEATURE_COUNT = ROLE_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link role.impl.RegistrationRoleImpl <em>Registration Role</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see role.impl.RegistrationRoleImpl
   * @see role.impl.RolePackageImpl#getRegistrationRole()
   * @generated
   */
  int REGISTRATION_ROLE = 4;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_ROLE__NAME = ARCHITECTURE_ROLE__NAME;

  /**
   * The feature id for the '<em><b>Realizes</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_ROLE__REALIZES = ARCHITECTURE_ROLE__REALIZES;

  /**
   * The feature id for the '<em><b>Scope</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_ROLE__SCOPE = ARCHITECTURE_ROLE__SCOPE;

  /**
   * The feature id for the '<em><b>Advertises</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_ROLE__ADVERTISES = ARCHITECTURE_ROLE_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Registration Role</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_ROLE_FEATURE_COUNT = ARCHITECTURE_ROLE_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link role.impl.OntologyMediatorRoleImpl <em>Ontology Mediator Role</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see role.impl.OntologyMediatorRoleImpl
   * @see role.impl.RolePackageImpl#getOntologyMediatorRole()
   * @generated
   */
  int ONTOLOGY_MEDIATOR_ROLE = 5;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_MEDIATOR_ROLE__NAME = ARCHITECTURE_ROLE__NAME;

  /**
   * The feature id for the '<em><b>Realizes</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_MEDIATOR_ROLE__REALIZES = ARCHITECTURE_ROLE__REALIZES;

  /**
   * The feature id for the '<em><b>Scope</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_MEDIATOR_ROLE__SCOPE = ARCHITECTURE_ROLE__SCOPE;

  /**
   * The number of structural features of the '<em>Ontology Mediator Role</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_MEDIATOR_ROLE_FEATURE_COUNT = ARCHITECTURE_ROLE_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link role.impl.SemanticWebServiceImpl <em>Semantic Web Service</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see role.impl.SemanticWebServiceImpl
   * @see role.impl.RolePackageImpl#getSemanticWebService()
   * @generated
   */
  int SEMANTIC_WEB_SERVICE = 6;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEMANTIC_WEB_SERVICE__NAME = 0;

  /**
   * The number of structural features of the '<em>Semantic Web Service</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEMANTIC_WEB_SERVICE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link role.impl.InteractionImpl <em>Interaction</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see role.impl.InteractionImpl
   * @see role.impl.RolePackageImpl#getInteraction()
   * @generated
   */
  int INTERACTION = 7;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERACTION__NAME = 0;

  /**
   * The number of structural features of the '<em>Interaction</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERACTION_FEATURE_COUNT = 1;


  /**
   * Returns the meta object for class '{@link role.RoleViewpoint <em>Viewpoint</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Viewpoint</em>'.
   * @see role.RoleViewpoint
   * @generated
   */
  EClass getRoleViewpoint();

  /**
   * Returns the meta object for the containment reference list '{@link role.RoleViewpoint#getHasDomainRole <em>Has Domain Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Domain Role</em>'.
   * @see role.RoleViewpoint#getHasDomainRole()
   * @see #getRoleViewpoint()
   * @generated
   */
  EReference getRoleViewpoint_HasDomainRole();

  /**
   * Returns the meta object for the containment reference list '{@link role.RoleViewpoint#getHasRegistrationRole <em>Has Registration Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Registration Role</em>'.
   * @see role.RoleViewpoint#getHasRegistrationRole()
   * @see #getRoleViewpoint()
   * @generated
   */
  EReference getRoleViewpoint_HasRegistrationRole();

  /**
   * Returns the meta object for the containment reference list '{@link role.RoleViewpoint#getHasOntologyMediatorRole <em>Has Ontology Mediator Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Ontology Mediator Role</em>'.
   * @see role.RoleViewpoint#getHasOntologyMediatorRole()
   * @see #getRoleViewpoint()
   * @generated
   */
  EReference getRoleViewpoint_HasOntologyMediatorRole();

  /**
   * Returns the meta object for the containment reference list '{@link role.RoleViewpoint#getHasSemanticWebService <em>Has Semantic Web Service</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Semantic Web Service</em>'.
   * @see role.RoleViewpoint#getHasSemanticWebService()
   * @see #getRoleViewpoint()
   * @generated
   */
  EReference getRoleViewpoint_HasSemanticWebService();

  /**
   * Returns the meta object for the containment reference list '{@link role.RoleViewpoint#getHasInteraction <em>Has Interaction</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Has Interaction</em>'.
   * @see role.RoleViewpoint#getHasInteraction()
   * @see #getRoleViewpoint()
   * @generated
   */
  EReference getRoleViewpoint_HasInteraction();

  /**
   * Returns the meta object for class '{@link role.Role <em>Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Role</em>'.
   * @see role.Role
   * @generated
   */
  EClass getRole();

  /**
   * Returns the meta object for the attribute '{@link role.Role#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see role.Role#getName()
   * @see #getRole()
   * @generated
   */
  EAttribute getRole_Name();

  /**
   * Returns the meta object for the reference list '{@link role.Role#getRealizes <em>Realizes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Realizes</em>'.
   * @see role.Role#getRealizes()
   * @see #getRole()
   * @generated
   */
  EReference getRole_Realizes();

  /**
   * Returns the meta object for class '{@link role.DomainRole <em>Domain Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Domain Role</em>'.
   * @see role.DomainRole
   * @generated
   */
  EClass getDomainRole();

  /**
   * Returns the meta object for class '{@link role.ArchitectureRole <em>Architecture Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Architecture Role</em>'.
   * @see role.ArchitectureRole
   * @generated
   */
  EClass getArchitectureRole();

  /**
   * Returns the meta object for the attribute '{@link role.ArchitectureRole#getScope <em>Scope</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Scope</em>'.
   * @see role.ArchitectureRole#getScope()
   * @see #getArchitectureRole()
   * @generated
   */
  EAttribute getArchitectureRole_Scope();

  /**
   * Returns the meta object for class '{@link role.RegistrationRole <em>Registration Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Registration Role</em>'.
   * @see role.RegistrationRole
   * @generated
   */
  EClass getRegistrationRole();

  /**
   * Returns the meta object for the reference list '{@link role.RegistrationRole#getAdvertises <em>Advertises</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Advertises</em>'.
   * @see role.RegistrationRole#getAdvertises()
   * @see #getRegistrationRole()
   * @generated
   */
  EReference getRegistrationRole_Advertises();

  /**
   * Returns the meta object for class '{@link role.OntologyMediatorRole <em>Ontology Mediator Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Ontology Mediator Role</em>'.
   * @see role.OntologyMediatorRole
   * @generated
   */
  EClass getOntologyMediatorRole();

  /**
   * Returns the meta object for class '{@link role.SemanticWebService <em>Semantic Web Service</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Semantic Web Service</em>'.
   * @see role.SemanticWebService
   * @generated
   */
  EClass getSemanticWebService();

  /**
   * Returns the meta object for the attribute '{@link role.SemanticWebService#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see role.SemanticWebService#getName()
   * @see #getSemanticWebService()
   * @generated
   */
  EAttribute getSemanticWebService_Name();

  /**
   * Returns the meta object for class '{@link role.Interaction <em>Interaction</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Interaction</em>'.
   * @see role.Interaction
   * @generated
   */
  EClass getInteraction();

  /**
   * Returns the meta object for the attribute '{@link role.Interaction#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see role.Interaction#getName()
   * @see #getInteraction()
   * @generated
   */
  EAttribute getInteraction_Name();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  RoleFactory getRoleFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link role.impl.RoleViewpointImpl <em>Viewpoint</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see role.impl.RoleViewpointImpl
     * @see role.impl.RolePackageImpl#getRoleViewpoint()
     * @generated
     */
    EClass ROLE_VIEWPOINT = eINSTANCE.getRoleViewpoint();

    /**
     * The meta object literal for the '<em><b>Has Domain Role</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE_VIEWPOINT__HAS_DOMAIN_ROLE = eINSTANCE.getRoleViewpoint_HasDomainRole();

    /**
     * The meta object literal for the '<em><b>Has Registration Role</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE_VIEWPOINT__HAS_REGISTRATION_ROLE = eINSTANCE.getRoleViewpoint_HasRegistrationRole();

    /**
     * The meta object literal for the '<em><b>Has Ontology Mediator Role</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE_VIEWPOINT__HAS_ONTOLOGY_MEDIATOR_ROLE = eINSTANCE.getRoleViewpoint_HasOntologyMediatorRole();

    /**
     * The meta object literal for the '<em><b>Has Semantic Web Service</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE_VIEWPOINT__HAS_SEMANTIC_WEB_SERVICE = eINSTANCE.getRoleViewpoint_HasSemanticWebService();

    /**
     * The meta object literal for the '<em><b>Has Interaction</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE_VIEWPOINT__HAS_INTERACTION = eINSTANCE.getRoleViewpoint_HasInteraction();

    /**
     * The meta object literal for the '{@link role.impl.RoleImpl <em>Role</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see role.impl.RoleImpl
     * @see role.impl.RolePackageImpl#getRole()
     * @generated
     */
    EClass ROLE = eINSTANCE.getRole();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ROLE__NAME = eINSTANCE.getRole_Name();

    /**
     * The meta object literal for the '<em><b>Realizes</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE__REALIZES = eINSTANCE.getRole_Realizes();

    /**
     * The meta object literal for the '{@link role.impl.DomainRoleImpl <em>Domain Role</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see role.impl.DomainRoleImpl
     * @see role.impl.RolePackageImpl#getDomainRole()
     * @generated
     */
    EClass DOMAIN_ROLE = eINSTANCE.getDomainRole();

    /**
     * The meta object literal for the '{@link role.impl.ArchitectureRoleImpl <em>Architecture Role</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see role.impl.ArchitectureRoleImpl
     * @see role.impl.RolePackageImpl#getArchitectureRole()
     * @generated
     */
    EClass ARCHITECTURE_ROLE = eINSTANCE.getArchitectureRole();

    /**
     * The meta object literal for the '<em><b>Scope</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARCHITECTURE_ROLE__SCOPE = eINSTANCE.getArchitectureRole_Scope();

    /**
     * The meta object literal for the '{@link role.impl.RegistrationRoleImpl <em>Registration Role</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see role.impl.RegistrationRoleImpl
     * @see role.impl.RolePackageImpl#getRegistrationRole()
     * @generated
     */
    EClass REGISTRATION_ROLE = eINSTANCE.getRegistrationRole();

    /**
     * The meta object literal for the '<em><b>Advertises</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference REGISTRATION_ROLE__ADVERTISES = eINSTANCE.getRegistrationRole_Advertises();

    /**
     * The meta object literal for the '{@link role.impl.OntologyMediatorRoleImpl <em>Ontology Mediator Role</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see role.impl.OntologyMediatorRoleImpl
     * @see role.impl.RolePackageImpl#getOntologyMediatorRole()
     * @generated
     */
    EClass ONTOLOGY_MEDIATOR_ROLE = eINSTANCE.getOntologyMediatorRole();

    /**
     * The meta object literal for the '{@link role.impl.SemanticWebServiceImpl <em>Semantic Web Service</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see role.impl.SemanticWebServiceImpl
     * @see role.impl.RolePackageImpl#getSemanticWebService()
     * @generated
     */
    EClass SEMANTIC_WEB_SERVICE = eINSTANCE.getSemanticWebService();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SEMANTIC_WEB_SERVICE__NAME = eINSTANCE.getSemanticWebService_Name();

    /**
     * The meta object literal for the '{@link role.impl.InteractionImpl <em>Interaction</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see role.impl.InteractionImpl
     * @see role.impl.RolePackageImpl#getInteraction()
     * @generated
     */
    EClass INTERACTION = eINSTANCE.getInteraction();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INTERACTION__NAME = eINSTANCE.getInteraction_Name();

  }

} //RolePackage
