/**
 */
package role.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import role.DomainRole;
import role.Interaction;
import role.OntologyMediatorRole;
import role.RegistrationRole;
import role.RolePackage;
import role.RoleViewpoint;
import role.SemanticWebService;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Viewpoint</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link role.impl.RoleViewpointImpl#getHasDomainRole <em>Has Domain Role</em>}</li>
 *   <li>{@link role.impl.RoleViewpointImpl#getHasRegistrationRole <em>Has Registration Role</em>}</li>
 *   <li>{@link role.impl.RoleViewpointImpl#getHasOntologyMediatorRole <em>Has Ontology Mediator Role</em>}</li>
 *   <li>{@link role.impl.RoleViewpointImpl#getHasSemanticWebService <em>Has Semantic Web Service</em>}</li>
 *   <li>{@link role.impl.RoleViewpointImpl#getHasInteraction <em>Has Interaction</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RoleViewpointImpl extends EObjectImpl implements RoleViewpoint
{
  /**
   * The cached value of the '{@link #getHasDomainRole() <em>Has Domain Role</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHasDomainRole()
   * @generated
   * @ordered
   */
  protected EList<DomainRole> hasDomainRole;

  /**
   * The cached value of the '{@link #getHasRegistrationRole() <em>Has Registration Role</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHasRegistrationRole()
   * @generated
   * @ordered
   */
  protected EList<RegistrationRole> hasRegistrationRole;

  /**
   * The cached value of the '{@link #getHasOntologyMediatorRole() <em>Has Ontology Mediator Role</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHasOntologyMediatorRole()
   * @generated
   * @ordered
   */
  protected EList<OntologyMediatorRole> hasOntologyMediatorRole;

  /**
   * The cached value of the '{@link #getHasSemanticWebService() <em>Has Semantic Web Service</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHasSemanticWebService()
   * @generated
   * @ordered
   */
  protected EList<SemanticWebService> hasSemanticWebService;

  /**
   * The cached value of the '{@link #getHasInteraction() <em>Has Interaction</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHasInteraction()
   * @generated
   * @ordered
   */
  protected EList<Interaction> hasInteraction;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RoleViewpointImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return RolePackage.Literals.ROLE_VIEWPOINT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<DomainRole> getHasDomainRole()
  {
    if (hasDomainRole == null)
    {
      hasDomainRole = new EObjectContainmentEList<DomainRole>(DomainRole.class, this, RolePackage.ROLE_VIEWPOINT__HAS_DOMAIN_ROLE);
    }
    return hasDomainRole;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<RegistrationRole> getHasRegistrationRole()
  {
    if (hasRegistrationRole == null)
    {
      hasRegistrationRole = new EObjectContainmentEList<RegistrationRole>(RegistrationRole.class, this, RolePackage.ROLE_VIEWPOINT__HAS_REGISTRATION_ROLE);
    }
    return hasRegistrationRole;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<OntologyMediatorRole> getHasOntologyMediatorRole()
  {
    if (hasOntologyMediatorRole == null)
    {
      hasOntologyMediatorRole = new EObjectContainmentEList<OntologyMediatorRole>(OntologyMediatorRole.class, this, RolePackage.ROLE_VIEWPOINT__HAS_ONTOLOGY_MEDIATOR_ROLE);
    }
    return hasOntologyMediatorRole;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SemanticWebService> getHasSemanticWebService()
  {
    if (hasSemanticWebService == null)
    {
      hasSemanticWebService = new EObjectContainmentEList<SemanticWebService>(SemanticWebService.class, this, RolePackage.ROLE_VIEWPOINT__HAS_SEMANTIC_WEB_SERVICE);
    }
    return hasSemanticWebService;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Interaction> getHasInteraction()
  {
    if (hasInteraction == null)
    {
      hasInteraction = new EObjectContainmentEList<Interaction>(Interaction.class, this, RolePackage.ROLE_VIEWPOINT__HAS_INTERACTION);
    }
    return hasInteraction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case RolePackage.ROLE_VIEWPOINT__HAS_DOMAIN_ROLE:
        return ((InternalEList<?>)getHasDomainRole()).basicRemove(otherEnd, msgs);
      case RolePackage.ROLE_VIEWPOINT__HAS_REGISTRATION_ROLE:
        return ((InternalEList<?>)getHasRegistrationRole()).basicRemove(otherEnd, msgs);
      case RolePackage.ROLE_VIEWPOINT__HAS_ONTOLOGY_MEDIATOR_ROLE:
        return ((InternalEList<?>)getHasOntologyMediatorRole()).basicRemove(otherEnd, msgs);
      case RolePackage.ROLE_VIEWPOINT__HAS_SEMANTIC_WEB_SERVICE:
        return ((InternalEList<?>)getHasSemanticWebService()).basicRemove(otherEnd, msgs);
      case RolePackage.ROLE_VIEWPOINT__HAS_INTERACTION:
        return ((InternalEList<?>)getHasInteraction()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case RolePackage.ROLE_VIEWPOINT__HAS_DOMAIN_ROLE:
        return getHasDomainRole();
      case RolePackage.ROLE_VIEWPOINT__HAS_REGISTRATION_ROLE:
        return getHasRegistrationRole();
      case RolePackage.ROLE_VIEWPOINT__HAS_ONTOLOGY_MEDIATOR_ROLE:
        return getHasOntologyMediatorRole();
      case RolePackage.ROLE_VIEWPOINT__HAS_SEMANTIC_WEB_SERVICE:
        return getHasSemanticWebService();
      case RolePackage.ROLE_VIEWPOINT__HAS_INTERACTION:
        return getHasInteraction();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case RolePackage.ROLE_VIEWPOINT__HAS_DOMAIN_ROLE:
        getHasDomainRole().clear();
        getHasDomainRole().addAll((Collection<? extends DomainRole>)newValue);
        return;
      case RolePackage.ROLE_VIEWPOINT__HAS_REGISTRATION_ROLE:
        getHasRegistrationRole().clear();
        getHasRegistrationRole().addAll((Collection<? extends RegistrationRole>)newValue);
        return;
      case RolePackage.ROLE_VIEWPOINT__HAS_ONTOLOGY_MEDIATOR_ROLE:
        getHasOntologyMediatorRole().clear();
        getHasOntologyMediatorRole().addAll((Collection<? extends OntologyMediatorRole>)newValue);
        return;
      case RolePackage.ROLE_VIEWPOINT__HAS_SEMANTIC_WEB_SERVICE:
        getHasSemanticWebService().clear();
        getHasSemanticWebService().addAll((Collection<? extends SemanticWebService>)newValue);
        return;
      case RolePackage.ROLE_VIEWPOINT__HAS_INTERACTION:
        getHasInteraction().clear();
        getHasInteraction().addAll((Collection<? extends Interaction>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case RolePackage.ROLE_VIEWPOINT__HAS_DOMAIN_ROLE:
        getHasDomainRole().clear();
        return;
      case RolePackage.ROLE_VIEWPOINT__HAS_REGISTRATION_ROLE:
        getHasRegistrationRole().clear();
        return;
      case RolePackage.ROLE_VIEWPOINT__HAS_ONTOLOGY_MEDIATOR_ROLE:
        getHasOntologyMediatorRole().clear();
        return;
      case RolePackage.ROLE_VIEWPOINT__HAS_SEMANTIC_WEB_SERVICE:
        getHasSemanticWebService().clear();
        return;
      case RolePackage.ROLE_VIEWPOINT__HAS_INTERACTION:
        getHasInteraction().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case RolePackage.ROLE_VIEWPOINT__HAS_DOMAIN_ROLE:
        return hasDomainRole != null && !hasDomainRole.isEmpty();
      case RolePackage.ROLE_VIEWPOINT__HAS_REGISTRATION_ROLE:
        return hasRegistrationRole != null && !hasRegistrationRole.isEmpty();
      case RolePackage.ROLE_VIEWPOINT__HAS_ONTOLOGY_MEDIATOR_ROLE:
        return hasOntologyMediatorRole != null && !hasOntologyMediatorRole.isEmpty();
      case RolePackage.ROLE_VIEWPOINT__HAS_SEMANTIC_WEB_SERVICE:
        return hasSemanticWebService != null && !hasSemanticWebService.isEmpty();
      case RolePackage.ROLE_VIEWPOINT__HAS_INTERACTION:
        return hasInteraction != null && !hasInteraction.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //RoleViewpointImpl
