package SWSInteraction.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LabeledContainer;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.core.edithelpers.CreateElementRequestAdapter;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CreationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.FlowLayoutEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewAndElementRequest;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class InterfaceEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2005;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public InterfaceEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		installEditPolicy(EditPolicyRoles.CREATION_ROLE,
				new CreationEditPolicy());
		super.createDefaultEditPolicies();
		installEditPolicy(
				EditPolicyRoles.SEMANTIC_ROLE,
				new SWSInteraction.diagram.edit.policies.InterfaceItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {

		FlowLayoutEditPolicy lep = new FlowLayoutEditPolicy() {

			protected Command createAddCommand(EditPart child, EditPart after) {
				return null;
			}

			protected Command createMoveChildCommand(EditPart child,
					EditPart after) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new InterfaceFigure();
	}

	/**
	 * @generated
	 */
	public InterfaceFigure getPrimaryShape() {
		return (InterfaceFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.InterfaceNameEditPart) {
			((SWSInteraction.diagram.edit.parts.InterfaceNameEditPart) childEditPart)
					.setLabel(getPrimaryShape().getFigureInterfaceNameFigure());
			return true;
		}
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfaceInputCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureInterfaceInputCompartmentNameFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((SWSInteraction.diagram.edit.parts.InterfaceInterfaceInputCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfaceOutputCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureInterfaceOutputCompartmentNameFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((SWSInteraction.diagram.edit.parts.InterfaceInterfaceOutputCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfacePreconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureInterfacePreconditionCompartmentNameFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((SWSInteraction.diagram.edit.parts.InterfaceInterfacePreconditionCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfaceEffectCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureInterfaceEffectCompartmentNameFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((SWSInteraction.diagram.edit.parts.InterfaceInterfaceEffectCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.InterfaceNameEditPart) {
			return true;
		}
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfaceInputCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureInterfaceInputCompartmentNameFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.remove(((SWSInteraction.diagram.edit.parts.InterfaceInterfaceInputCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfaceOutputCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureInterfaceOutputCompartmentNameFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.remove(((SWSInteraction.diagram.edit.parts.InterfaceInterfaceOutputCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfacePreconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureInterfacePreconditionCompartmentNameFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.remove(((SWSInteraction.diagram.edit.parts.InterfaceInterfacePreconditionCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfaceEffectCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureInterfaceEffectCompartmentNameFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.remove(((SWSInteraction.diagram.edit.parts.InterfaceInterfaceEffectCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		if (editPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfaceInputCompartmentEditPart) {
			return getPrimaryShape()
					.getFigureInterfaceInputCompartmentNameFigure();
		}
		if (editPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfaceOutputCompartmentEditPart) {
			return getPrimaryShape()
					.getFigureInterfaceOutputCompartmentNameFigure();
		}
		if (editPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfacePreconditionCompartmentEditPart) {
			return getPrimaryShape()
					.getFigureInterfacePreconditionCompartmentNameFigure();
		}
		if (editPart instanceof SWSInteraction.diagram.edit.parts.InterfaceInterfaceEffectCompartmentEditPart) {
			return getPrimaryShape()
					.getFigureInterfaceEffectCompartmentNameFigure();
		}
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(4, 5);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
				.getType(SWSInteraction.diagram.edit.parts.InterfaceNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.InterfacePresents_4027);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(
			IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof SWSInteraction.diagram.edit.parts.SWSEditPart) {
			types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.InterfacePresents_4027);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == SWSInteraction.diagram.providers.SWSInteractionElementTypes.InterfacePresents_4027) {
			types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.SWS_2004);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(3);
		types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_RegisterPlanAdvertises_4009);
		types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_FinderPlanDiscovers_4013);
		types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_AgreementPlanNegotiates_4014);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_RegisterPlanAdvertises_4009) {
			types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_RegisterPlan_2016);
		} else if (relationshipType == SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_FinderPlanDiscovers_4013) {
			types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_FinderPlan_2014);
		} else if (relationshipType == SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_AgreementPlanNegotiates_4014) {
			types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_AgreementPlan_2015);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public EditPart getTargetEditPart(Request request) {
		if (request instanceof CreateViewAndElementRequest) {
			CreateElementRequestAdapter adapter = ((CreateViewAndElementRequest) request)
					.getViewAndElementDescriptor()
					.getCreateElementRequestAdapter();
			IElementType type = (IElementType) adapter
					.getAdapter(IElementType.class);
			if (type == SWSInteraction.diagram.providers.SWSInteractionElementTypes.Input_3001) {
				return getChildBySemanticHint(SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
						.getType(SWSInteraction.diagram.edit.parts.InterfaceInterfaceInputCompartmentEditPart.VISUAL_ID));
			}
			if (type == SWSInteraction.diagram.providers.SWSInteractionElementTypes.Output_3002) {
				return getChildBySemanticHint(SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
						.getType(SWSInteraction.diagram.edit.parts.InterfaceInterfaceOutputCompartmentEditPart.VISUAL_ID));
			}
			if (type == SWSInteraction.diagram.providers.SWSInteractionElementTypes.Precondition_3003) {
				return getChildBySemanticHint(SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
						.getType(SWSInteraction.diagram.edit.parts.InterfaceInterfacePreconditionCompartmentEditPart.VISUAL_ID));
			}
			if (type == SWSInteraction.diagram.providers.SWSInteractionElementTypes.Effect_3004) {
				return getChildBySemanticHint(SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
						.getType(SWSInteraction.diagram.edit.parts.InterfaceInterfaceEffectCompartmentEditPart.VISUAL_ID));
			}
		}
		return super.getTargetEditPart(request);
	}

	/**
	 * @generated
	 */
	public class InterfaceFigure extends RectangleFigure {

		/**
		 * @generated
		 */
		private LabeledContainer fFigureInterfaceEffectCompartmentNameFigure;
		/**
		 * @generated
		 */
		private LabeledContainer fFigureInterfacePreconditionCompartmentNameFigure;
		/**
		 * @generated
		 */
		private LabeledContainer fFigureInterfaceOutputCompartmentNameFigure;
		/**
		 * @generated
		 */
		private LabeledContainer fFigureInterfaceInputCompartmentNameFigure;
		/**
		 * @generated
		 */
		private WrappingLabel fFigureInterfaceNameFigure;

		/**
		 * @generated
		 */
		public InterfaceFigure() {

			FlowLayout layoutThis = new FlowLayout();
			layoutThis.setStretchMinorAxis(false);
			layoutThis.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutThis.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutThis.setMajorSpacing(5);
			layoutThis.setMinorSpacing(5);
			layoutThis.setHorizontal(true);

			this.setLayoutManager(layoutThis);

			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			fFigureInterfaceNameFigure = new WrappingLabel();
			fFigureInterfaceNameFigure.setText("<...>");
			fFigureInterfaceNameFigure
					.setForegroundColor(FFIGUREINTERFACENAMEFIGURE_FORE);

			this.add(fFigureInterfaceNameFigure);

			fFigureInterfaceInputCompartmentNameFigure = new LabeledContainer();

			fFigureInterfaceInputCompartmentNameFigure
					.setBackgroundColor(FFIGUREINTERFACEINPUTCOMPARTMENTNAMEFIGURE_BACK);
			fFigureInterfaceInputCompartmentNameFigure
					.setBorder(new MarginBorder(getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4), getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4)));

			this.add(fFigureInterfaceInputCompartmentNameFigure);

			FlowLayout layoutFFigureInterfaceInputCompartmentNameFigure = new FlowLayout();
			layoutFFigureInterfaceInputCompartmentNameFigure
					.setStretchMinorAxis(false);
			layoutFFigureInterfaceInputCompartmentNameFigure
					.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutFFigureInterfaceInputCompartmentNameFigure
					.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutFFigureInterfaceInputCompartmentNameFigure.setMajorSpacing(5);
			layoutFFigureInterfaceInputCompartmentNameFigure.setMinorSpacing(5);
			layoutFFigureInterfaceInputCompartmentNameFigure
					.setHorizontal(true);

			fFigureInterfaceInputCompartmentNameFigure
					.setLayoutManager(layoutFFigureInterfaceInputCompartmentNameFigure);

			WrappingLabel interfaceInputCompartmentName1 = new WrappingLabel();
			interfaceInputCompartmentName1.setText("<Inputs>");
			interfaceInputCompartmentName1
					.setForegroundColor(INTERFACEINPUTCOMPARTMENTNAME1_FORE);

			fFigureInterfaceInputCompartmentNameFigure
					.add(interfaceInputCompartmentName1);

			fFigureInterfaceOutputCompartmentNameFigure = new LabeledContainer();

			fFigureInterfaceOutputCompartmentNameFigure
					.setBackgroundColor(FFIGUREINTERFACEOUTPUTCOMPARTMENTNAMEFIGURE_BACK);
			fFigureInterfaceOutputCompartmentNameFigure
					.setBorder(new MarginBorder(getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4), getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4)));

			this.add(fFigureInterfaceOutputCompartmentNameFigure);

			FlowLayout layoutFFigureInterfaceOutputCompartmentNameFigure = new FlowLayout();
			layoutFFigureInterfaceOutputCompartmentNameFigure
					.setStretchMinorAxis(false);
			layoutFFigureInterfaceOutputCompartmentNameFigure
					.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutFFigureInterfaceOutputCompartmentNameFigure
					.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutFFigureInterfaceOutputCompartmentNameFigure
					.setMajorSpacing(5);
			layoutFFigureInterfaceOutputCompartmentNameFigure
					.setMinorSpacing(5);
			layoutFFigureInterfaceOutputCompartmentNameFigure
					.setHorizontal(true);

			fFigureInterfaceOutputCompartmentNameFigure
					.setLayoutManager(layoutFFigureInterfaceOutputCompartmentNameFigure);

			WrappingLabel interfaceOutputCompartmentName1 = new WrappingLabel();
			interfaceOutputCompartmentName1.setText("<Outputs>");
			interfaceOutputCompartmentName1
					.setForegroundColor(INTERFACEOUTPUTCOMPARTMENTNAME1_FORE);

			fFigureInterfaceOutputCompartmentNameFigure
					.add(interfaceOutputCompartmentName1);

			fFigureInterfacePreconditionCompartmentNameFigure = new LabeledContainer();

			fFigureInterfacePreconditionCompartmentNameFigure
					.setBackgroundColor(FFIGUREINTERFACEPRECONDITIONCOMPARTMENTNAMEFIGURE_BACK);
			fFigureInterfacePreconditionCompartmentNameFigure
					.setBorder(new MarginBorder(getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4), getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4)));

			this.add(fFigureInterfacePreconditionCompartmentNameFigure);

			FlowLayout layoutFFigureInterfacePreconditionCompartmentNameFigure = new FlowLayout();
			layoutFFigureInterfacePreconditionCompartmentNameFigure
					.setStretchMinorAxis(false);
			layoutFFigureInterfacePreconditionCompartmentNameFigure
					.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutFFigureInterfacePreconditionCompartmentNameFigure
					.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutFFigureInterfacePreconditionCompartmentNameFigure
					.setMajorSpacing(5);
			layoutFFigureInterfacePreconditionCompartmentNameFigure
					.setMinorSpacing(5);
			layoutFFigureInterfacePreconditionCompartmentNameFigure
					.setHorizontal(true);

			fFigureInterfacePreconditionCompartmentNameFigure
					.setLayoutManager(layoutFFigureInterfacePreconditionCompartmentNameFigure);

			WrappingLabel interfacePreconditionCompartmentName1 = new WrappingLabel();
			interfacePreconditionCompartmentName1.setText("<Preconditions>");
			interfacePreconditionCompartmentName1
					.setForegroundColor(INTERFACEPRECONDITIONCOMPARTMENTNAME1_FORE);

			fFigureInterfacePreconditionCompartmentNameFigure
					.add(interfacePreconditionCompartmentName1);

			fFigureInterfaceEffectCompartmentNameFigure = new LabeledContainer();

			fFigureInterfaceEffectCompartmentNameFigure
					.setBackgroundColor(FFIGUREINTERFACEEFFECTCOMPARTMENTNAMEFIGURE_BACK);
			fFigureInterfaceEffectCompartmentNameFigure
					.setBorder(new MarginBorder(getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4), getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4)));

			this.add(fFigureInterfaceEffectCompartmentNameFigure);

			FlowLayout layoutFFigureInterfaceEffectCompartmentNameFigure = new FlowLayout();
			layoutFFigureInterfaceEffectCompartmentNameFigure
					.setStretchMinorAxis(false);
			layoutFFigureInterfaceEffectCompartmentNameFigure
					.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutFFigureInterfaceEffectCompartmentNameFigure
					.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutFFigureInterfaceEffectCompartmentNameFigure
					.setMajorSpacing(5);
			layoutFFigureInterfaceEffectCompartmentNameFigure
					.setMinorSpacing(5);
			layoutFFigureInterfaceEffectCompartmentNameFigure
					.setHorizontal(true);

			fFigureInterfaceEffectCompartmentNameFigure
					.setLayoutManager(layoutFFigureInterfaceEffectCompartmentNameFigure);

			WrappingLabel interfaceEffectCompartmentName1 = new WrappingLabel();
			interfaceEffectCompartmentName1.setText("<Effects>");
			interfaceEffectCompartmentName1
					.setForegroundColor(INTERFACEEFFECTCOMPARTMENTNAME1_FORE);

			fFigureInterfaceEffectCompartmentNameFigure
					.add(interfaceEffectCompartmentName1);

		}

		/**
		 * @generated
		 */
		public LabeledContainer getFigureInterfaceEffectCompartmentNameFigure() {
			return fFigureInterfaceEffectCompartmentNameFigure;
		}

		/**
		 * @generated
		 */
		public LabeledContainer getFigureInterfacePreconditionCompartmentNameFigure() {
			return fFigureInterfacePreconditionCompartmentNameFigure;
		}

		/**
		 * @generated
		 */
		public LabeledContainer getFigureInterfaceOutputCompartmentNameFigure() {
			return fFigureInterfaceOutputCompartmentNameFigure;
		}

		/**
		 * @generated
		 */
		public LabeledContainer getFigureInterfaceInputCompartmentNameFigure() {
			return fFigureInterfaceInputCompartmentNameFigure;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureInterfaceNameFigure() {
			return fFigureInterfaceNameFigure;
		}

	}

	/**
	 * @generated
	 */
	static final Color FFIGUREINTERFACENAMEFIGURE_FORE = new Color(null, 0, 0,
			0);

	/**
	 * @generated
	 */
	static final Color FFIGUREINTERFACEINPUTCOMPARTMENTNAMEFIGURE_BACK = new Color(
			null, 180, 180, 180);

	/**
	 * @generated
	 */
	static final Color INTERFACEINPUTCOMPARTMENTNAME1_FORE = new Color(null, 0,
			0, 0);

	/**
	 * @generated
	 */
	static final Color FFIGUREINTERFACEOUTPUTCOMPARTMENTNAMEFIGURE_BACK = new Color(
			null, 180, 180, 180);

	/**
	 * @generated
	 */
	static final Color INTERFACEOUTPUTCOMPARTMENTNAME1_FORE = new Color(null,
			0, 0, 0);

	/**
	 * @generated
	 */
	static final Color FFIGUREINTERFACEPRECONDITIONCOMPARTMENTNAMEFIGURE_BACK = new Color(
			null, 180, 180, 180);

	/**
	 * @generated
	 */
	static final Color INTERFACEPRECONDITIONCOMPARTMENTNAME1_FORE = new Color(
			null, 0, 0, 0);

	/**
	 * @generated
	 */
	static final Color FFIGUREINTERFACEEFFECTCOMPARTMENTNAMEFIGURE_BACK = new Color(
			null, 180, 180, 180);

	/**
	 * @generated
	 */
	static final Color INTERFACEEFFECTCOMPARTMENTNAME1_FORE = new Color(null,
			0, 0, 0);

}
