package SWSInteraction.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.UnexecutableCommand;
import org.eclipse.gef.requests.ReconnectRequest;
import org.eclipse.gmf.runtime.common.core.command.ICommand;
import org.eclipse.gmf.runtime.common.core.command.ICompositeCommand;
import org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand;
import org.eclipse.gmf.runtime.diagram.ui.commands.CommandProxy;
import org.eclipse.gmf.runtime.diagram.ui.commands.ICommandProxy;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.SemanticEditPolicy;
import org.eclipse.gmf.runtime.emf.commands.core.command.CompositeTransactionalCommand;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.type.core.requests.ConfigureRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyReferenceRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.GetEditContextRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.IEditCommandRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.MoveRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.SetRequest;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class SWSInteractionBaseItemSemanticEditPolicy extends
		SemanticEditPolicy {

	/**
	 * Extended request data key to hold editpart visual id.
	 * @generated
	 */
	public static final String VISUAL_ID_KEY = "visual_id"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	private final IElementType myElementType;

	/**
	 * @generated
	 */
	protected SWSInteractionBaseItemSemanticEditPolicy(IElementType elementType) {
		myElementType = elementType;
	}

	/**
	 * Extended request data key to hold editpart visual id.
	 * Add visual id of edited editpart to extended data of the request
	 * so command switch can decide what kind of diagram element is being edited.
	 * It is done in those cases when it's not possible to deduce diagram
	 * element kind from domain element.
	 * 
	 * @generated
	 */
	public Command getCommand(Request request) {
		if (request instanceof ReconnectRequest) {
			Object view = ((ReconnectRequest) request).getConnectionEditPart()
					.getModel();
			if (view instanceof View) {
				Integer id = new Integer(
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getVisualID((View) view));
				request.getExtendedData().put(VISUAL_ID_KEY, id);
			}
		}
		return super.getCommand(request);
	}

	/**
	 * Returns visual id from request parameters.
	 * @generated
	 */
	protected int getVisualID(IEditCommandRequest request) {
		Object id = request.getParameter(VISUAL_ID_KEY);
		return id instanceof Integer ? ((Integer) id).intValue() : -1;
	}

	/**
	 * @generated
	 */
	protected Command getSemanticCommand(IEditCommandRequest request) {
		IEditCommandRequest completedRequest = completeRequest(request);
		Command semanticCommand = getSemanticCommandSwitch(completedRequest);
		semanticCommand = getEditHelperCommand(completedRequest,
				semanticCommand);
		if (completedRequest instanceof DestroyRequest) {
			DestroyRequest destroyRequest = (DestroyRequest) completedRequest;
			return shouldProceed(destroyRequest) ? addDeleteViewCommand(
					semanticCommand, destroyRequest) : null;
		}
		return semanticCommand;
	}

	/**
	 * @generated
	 */
	protected Command addDeleteViewCommand(Command mainCommand,
			DestroyRequest completedRequest) {
		Command deleteViewCommand = getGEFWrapper(new DeleteCommand(
				getEditingDomain(), (View) getHost().getModel()));
		return mainCommand == null ? deleteViewCommand : mainCommand
				.chain(deleteViewCommand);
	}

	/**
	 * @generated
	 */
	private Command getEditHelperCommand(IEditCommandRequest request,
			Command editPolicyCommand) {
		if (editPolicyCommand != null) {
			ICommand command = editPolicyCommand instanceof ICommandProxy ? ((ICommandProxy) editPolicyCommand)
					.getICommand() : new CommandProxy(editPolicyCommand);
			request.setParameter(
					SWSInteraction.diagram.edit.helpers.SWSInteractionBaseEditHelper.EDIT_POLICY_COMMAND,
					command);
		}
		IElementType requestContextElementType = getContextElementType(request);
		request.setParameter(
				SWSInteraction.diagram.edit.helpers.SWSInteractionBaseEditHelper.CONTEXT_ELEMENT_TYPE,
				requestContextElementType);
		ICommand command = requestContextElementType.getEditCommand(request);
		request.setParameter(
				SWSInteraction.diagram.edit.helpers.SWSInteractionBaseEditHelper.EDIT_POLICY_COMMAND,
				null);
		request.setParameter(
				SWSInteraction.diagram.edit.helpers.SWSInteractionBaseEditHelper.CONTEXT_ELEMENT_TYPE,
				null);
		if (command != null) {
			if (!(command instanceof CompositeTransactionalCommand)) {
				command = new CompositeTransactionalCommand(getEditingDomain(),
						command.getLabel()).compose(command);
			}
			return new ICommandProxy(command);
		}
		return editPolicyCommand;
	}

	/**
	 * @generated
	 */
	private IElementType getContextElementType(IEditCommandRequest request) {
		IElementType requestContextElementType = SWSInteraction.diagram.providers.SWSInteractionElementTypes
				.getElementType(getVisualID(request));
		return requestContextElementType != null ? requestContextElementType
				: myElementType;
	}

	/**
	 * @generated
	 */
	protected Command getSemanticCommandSwitch(IEditCommandRequest req) {
		if (req instanceof CreateRelationshipRequest) {
			return getCreateRelationshipCommand((CreateRelationshipRequest) req);
		} else if (req instanceof CreateElementRequest) {
			return getCreateCommand((CreateElementRequest) req);
		} else if (req instanceof ConfigureRequest) {
			return getConfigureCommand((ConfigureRequest) req);
		} else if (req instanceof DestroyElementRequest) {
			return getDestroyElementCommand((DestroyElementRequest) req);
		} else if (req instanceof DestroyReferenceRequest) {
			return getDestroyReferenceCommand((DestroyReferenceRequest) req);
		} else if (req instanceof DuplicateElementsRequest) {
			return getDuplicateCommand((DuplicateElementsRequest) req);
		} else if (req instanceof GetEditContextRequest) {
			return getEditContextCommand((GetEditContextRequest) req);
		} else if (req instanceof MoveRequest) {
			return getMoveCommand((MoveRequest) req);
		} else if (req instanceof ReorientReferenceRelationshipRequest) {
			return getReorientReferenceRelationshipCommand((ReorientReferenceRelationshipRequest) req);
		} else if (req instanceof ReorientRelationshipRequest) {
			return getReorientRelationshipCommand((ReorientRelationshipRequest) req);
		} else if (req instanceof SetRequest) {
			return getSetCommand((SetRequest) req);
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getConfigureCommand(ConfigureRequest req) {
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getSetCommand(SetRequest req) {
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getEditContextCommand(GetEditContextRequest req) {
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getDestroyReferenceCommand(DestroyReferenceRequest req) {
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getMoveCommand(MoveRequest req) {
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(
			ReorientReferenceRelationshipRequest req) {
		return UnexecutableCommand.INSTANCE;
	}

	/**
	 * @generated
	 */
	protected Command getReorientRelationshipCommand(
			ReorientRelationshipRequest req) {
		return UnexecutableCommand.INSTANCE;
	}

	/**
	 * @generated
	 */
	protected final Command getGEFWrapper(ICommand cmd) {
		return new ICommandProxy(cmd);
	}

	/**
	 * Returns editing domain from the host edit part.
	 * @generated
	 */
	protected TransactionalEditingDomain getEditingDomain() {
		return ((IGraphicalEditPart) getHost()).getEditingDomain();
	}

	/**
	 * Clean all shortcuts to the host element from the same diagram
	 * @generated
	 */
	protected void addDestroyShortcutsCommand(ICompositeCommand cmd, View view) {
		assert view.getEAnnotation("Shortcut") == null; //$NON-NLS-1$
		for (Iterator it = view.getDiagram().getChildren().iterator(); it
				.hasNext();) {
			View nextView = (View) it.next();
			if (nextView.getEAnnotation("Shortcut") == null || !nextView.isSetElement() || nextView.getElement() != view.getElement()) { //$NON-NLS-1$
				continue;
			}
			cmd.add(new DeleteCommand(getEditingDomain(), nextView));
		}
	}

	/**
	 * @generated
	 */
	public static LinkConstraints getLinkConstraints() {
		LinkConstraints cached = SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
				.getInstance().getLinkConstraints();
		if (cached == null) {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().setLinkConstraints(
							cached = new LinkConstraints());
		}
		return cached;
	}

	/**
	 * @generated
	 */
	public static class LinkConstraints {

		/**
		 * @generated
		 */
		LinkConstraints() {
			// use static method #getLinkConstraints() to access instance
		}

		/**
		 * @generated
		 */
		public boolean canCreateSS_RegisterPlanAdvertises_4009(
				SWSInteraction.SS_RegisterPlan source,
				SWSInteraction.Interface target) {
			if (source != null) {
				if (source.getAdvertises().contains(target)) {
					return false;
				}
			}

			return canExistSS_RegisterPlanAdvertises_4009(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateSemanticWebAgentApplies_4008(
				SWSInteraction.SemanticWebAgent source,
				SWSInteraction.Plan target) {
			if (source != null) {
				if (source.getApplies().contains(target)) {
					return false;
				}
			}

			return canExistSemanticWebAgentApplies_4008(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateSemanticWebAgentPlays_4010(
				SWSInteraction.SemanticWebAgent source,
				SWSInteraction.Role target) {
			if (source != null) {
				if (source.getPlays().contains(target)) {
					return false;
				}
			}

			return canExistSemanticWebAgentPlays_4010(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateSS_FinderPlanInteracts_with_4012(
				SWSInteraction.SS_FinderPlan source,
				SWSInteraction.SSMatchmakerAgent target) {
			if (source != null) {
				if (source.getInteracts_with() != null) {
					return false;
				}
			}

			return canExistSS_FinderPlanInteracts_with_4012(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateSS_FinderPlanDiscovers_4013(
				SWSInteraction.SS_FinderPlan source,
				SWSInteraction.Interface target) {
			if (source != null) {
				if (source.getDiscovers().contains(target)) {
					return false;
				}
			}

			return canExistSS_FinderPlanDiscovers_4013(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateSS_AgreementPlanNegotiates_4014(
				SWSInteraction.SS_AgreementPlan source,
				SWSInteraction.Interface target) {
			if (source != null) {
				if (source.getNegotiates().contains(target)) {
					return false;
				}
			}

			return canExistSS_AgreementPlanNegotiates_4014(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateSS_ExecutorPlanExecutes_4026(
				SWSInteraction.SS_ExecutorPlan source,
				SWSInteraction.Process target) {
			if (source != null) {
				if (source.getExecutes() != null) {
					return false;
				}
			}

			return canExistSS_ExecutorPlanExecutes_4026(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateSS_ExecutorPlanUses_4016(
				SWSInteraction.SS_ExecutorPlan source,
				SWSInteraction.Grounding target) {
			if (source != null) {
				if (source.getUses() != null) {
					return false;
				}
			}

			return canExistSS_ExecutorPlanUses_4016(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateInterfacePresents_4027(
				SWSInteraction.Interface source, SWSInteraction.SWS target) {
			if (source != null) {
				if (source.getPresents() != null) {
					return false;
				}
			}

			return canExistInterfacePresents_4027(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateProcessDescribed_by_4028(
				SWSInteraction.Process source, SWSInteraction.SWS target) {
			if (source != null) {
				if (source.getDescribed_by() != null) {
					return false;
				}
			}

			return canExistProcessDescribed_by_4028(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateGroundingCalls_4019(
				SWSInteraction.Grounding source,
				SWSInteraction.WebService target) {
			if (source != null) {
				if (source.getCalls() != null) {
					return false;
				}
			}

			return canExistGroundingCalls_4019(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateGroundingSupports_4030(
				SWSInteraction.Grounding source, SWSInteraction.SWS target) {
			if (source != null) {
				if (source.getSupports() != null) {
					return false;
				}
			}

			return canExistGroundingSupports_4030(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateSSMatchmakerAgentAppliesSS_RegPlan_4031(
				SWSInteraction.SSMatchmakerAgent source,
				SWSInteraction.SS_RegisterPlan target) {
			if (source != null) {
				if (source.getAppliesSS_RegPlan().contains(target)) {
					return false;
				}
			}

			return canExistSSMatchmakerAgentAppliesSS_RegPlan_4031(source,
					target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateSSMatchmakerAgentPlaysRegRole_4032(
				SWSInteraction.SSMatchmakerAgent source,
				SWSInteraction.Role target) {
			if (source != null) {
				if (source.getPlaysRegRole() != null) {
					return false;
				}
			}

			return canExistSSMatchmakerAgentPlaysRegRole_4032(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canCreateRoleInteracts_with_4033(
				SWSInteraction.Role source, SWSInteraction.SWS target) {
			if (source != null) {
				if (source.getInteracts_with() != null) {
					return false;
				}
			}

			return canExistRoleInteracts_with_4033(source, target);
		}

		/**
		 * @generated
		 */
		public boolean canExistSS_RegisterPlanAdvertises_4009(
				SWSInteraction.SS_RegisterPlan source,
				SWSInteraction.Interface target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistSemanticWebAgentApplies_4008(
				SWSInteraction.SemanticWebAgent source,
				SWSInteraction.Plan target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistSemanticWebAgentPlays_4010(
				SWSInteraction.SemanticWebAgent source,
				SWSInteraction.Role target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistSS_FinderPlanInteracts_with_4012(
				SWSInteraction.SS_FinderPlan source,
				SWSInteraction.SSMatchmakerAgent target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistSS_FinderPlanDiscovers_4013(
				SWSInteraction.SS_FinderPlan source,
				SWSInteraction.Interface target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistSS_AgreementPlanNegotiates_4014(
				SWSInteraction.SS_AgreementPlan source,
				SWSInteraction.Interface target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistSS_ExecutorPlanExecutes_4026(
				SWSInteraction.SS_ExecutorPlan source,
				SWSInteraction.Process target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistSS_ExecutorPlanUses_4016(
				SWSInteraction.SS_ExecutorPlan source,
				SWSInteraction.Grounding target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistInterfacePresents_4027(
				SWSInteraction.Interface source, SWSInteraction.SWS target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistProcessDescribed_by_4028(
				SWSInteraction.Process source, SWSInteraction.SWS target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistGroundingCalls_4019(
				SWSInteraction.Grounding source,
				SWSInteraction.WebService target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistGroundingSupports_4030(
				SWSInteraction.Grounding source, SWSInteraction.SWS target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistSSMatchmakerAgentAppliesSS_RegPlan_4031(
				SWSInteraction.SSMatchmakerAgent source,
				SWSInteraction.SS_RegisterPlan target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistSSMatchmakerAgentPlaysRegRole_4032(
				SWSInteraction.SSMatchmakerAgent source,
				SWSInteraction.Role target) {
			return true;
		}

		/**
		 * @generated
		 */
		public boolean canExistRoleInteracts_with_4033(
				SWSInteraction.Role source, SWSInteraction.SWS target) {
			return true;
		}
	}

}
