package SWSInteraction.diagram.navigator;

import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

/**
 * @generated
 */
public class SWSInteractionNavigatorLabelProvider extends LabelProvider
		implements ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem
				&& !isOwnView(((SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem) element)
						.getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup) {
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup group = (SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup) element;
			return SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().getBundledImage(group.getIcon());
		}

		if (element instanceof SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem) {
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem navigatorItem = (SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
				.getVisualID(view)) {
		case SWSInteraction.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/viewPointsFull/model/SWSInteraction.ecore?SemanticWebAgent", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SemanticWebAgent_2021); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SS_RegisterPlanAdvertisesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?SS_RegisterPlan?advertises", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_RegisterPlanAdvertises_4009); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SWSEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/viewPointsFull/model/SWSInteraction.ecore?SWS", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SWS_2004); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.ProcessEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/viewPointsFull/model/SWSInteraction.ecore?Process", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Process_2010); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.OutputEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/viewPointsFull/model/SWSInteraction.ecore?Output", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Output_3002); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SS_AgreementPlanNegotiatesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?SS_AgreementPlan?negotiates", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_AgreementPlanNegotiates_4014); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SSMatchmakerAgentEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/viewPointsFull/model/SWSInteraction.ecore?SSMatchmakerAgent", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SSMatchmakerAgent_2018); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.EffectEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/viewPointsFull/model/SWSInteraction.ecore?Effect", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Effect_3004); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/viewPointsFull/model/SWSInteraction.ecore?Role", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Role_2001); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.GroundingSupportsEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?Grounding?supports", SWSInteraction.diagram.providers.SWSInteractionElementTypes.GroundingSupports_4030); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.RoleInteracts_withEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?Role?interacts_with", SWSInteraction.diagram.providers.SWSInteractionElementTypes.RoleInteracts_with_4033); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SS_AgreementPlanEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/viewPointsFull/model/SWSInteraction.ecore?SS_AgreementPlan", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_AgreementPlan_2015); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?SemanticWebAgent?plays", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SemanticWebAgentPlays_4010); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.Effect2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/viewPointsFull/model/SWSInteraction.ecore?Effect", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Effect_3008); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.Input2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/viewPointsFull/model/SWSInteraction.ecore?Input", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Input_3005); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.GroundingEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/viewPointsFull/model/SWSInteraction.ecore?Grounding", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Grounding_2008); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SS_RegisterPlanEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/viewPointsFull/model/SWSInteraction.ecore?SS_RegisterPlan", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_RegisterPlan_2016); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanExecutesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?SS_ExecutorPlan?executes", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_ExecutorPlanExecutes_4026); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SSMatchmakerAgentAppliesSS_RegPlanEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?SSMatchmakerAgent?appliesSS_RegPlan", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SSMatchmakerAgentAppliesSS_RegPlan_4031); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SS_FinderPlanInteracts_withEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?SS_FinderPlan?interacts_with", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_FinderPlanInteracts_with_4012); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SS_FinderPlanEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/viewPointsFull/model/SWSInteraction.ecore?SS_FinderPlan", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_FinderPlan_2014); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/viewPointsFull/model/SWSInteraction.ecore?SS_ExecutorPlan", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_ExecutorPlan_2017); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanUsesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?SS_ExecutorPlan?uses", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_ExecutorPlanUses_4016); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SemanticWebAgentAppliesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?SemanticWebAgent?applies", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SemanticWebAgentApplies_4008); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.PreconditionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/viewPointsFull/model/SWSInteraction.ecore?Precondition", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Precondition_3003); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SS_FinderPlanDiscoversEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?SS_FinderPlan?discovers", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_FinderPlanDiscovers_4013); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?/viewPointsFull/model/SWSInteraction.ecore?SWSInteractionViewpoint", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SWSInteractionViewpoint_1000); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.InputEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/viewPointsFull/model/SWSInteraction.ecore?Input", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Input_3001); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.WebServiceEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/viewPointsFull/model/SWSInteraction.ecore?WebService", SWSInteraction.diagram.providers.SWSInteractionElementTypes.WebService_3011); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.SSMatchmakerAgentPlaysRegRoleEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?SSMatchmakerAgent?playsRegRole", SWSInteraction.diagram.providers.SWSInteractionElementTypes.SSMatchmakerAgentPlaysRegRole_4032); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.InterfacePresentsEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?Interface?presents", SWSInteraction.diagram.providers.SWSInteractionElementTypes.InterfacePresents_4027); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.Precondition2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/viewPointsFull/model/SWSInteraction.ecore?Precondition", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Precondition_3007); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.Output2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?/viewPointsFull/model/SWSInteraction.ecore?Output", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Output_3006); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.GroundingCallsEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?Grounding?calls", SWSInteraction.diagram.providers.SWSInteractionElementTypes.GroundingCalls_4019); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.ProcessDescribed_byEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?/viewPointsFull/model/SWSInteraction.ecore?Process?described_by", SWSInteraction.diagram.providers.SWSInteractionElementTypes.ProcessDescribed_by_4028); //$NON-NLS-1$
		case SWSInteraction.diagram.edit.parts.InterfaceEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?/viewPointsFull/model/SWSInteraction.ecore?Interface", SWSInteraction.diagram.providers.SWSInteractionElementTypes.Interface_2005); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null
				&& elementType != null
				&& SWSInteraction.diagram.providers.SWSInteractionElementTypes
						.isKnownElementType(elementType)) {
			image = SWSInteraction.diagram.providers.SWSInteractionElementTypes
					.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup) {
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup group = (SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem) {
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem navigatorItem = (SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
				.getVisualID(view)) {
		case SWSInteraction.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID:
			return getSemanticWebAgent_2021Text(view);
		case SWSInteraction.diagram.edit.parts.SS_RegisterPlanAdvertisesEditPart.VISUAL_ID:
			return getSS_RegisterPlanAdvertises_4009Text(view);
		case SWSInteraction.diagram.edit.parts.SWSEditPart.VISUAL_ID:
			return getSWS_2004Text(view);
		case SWSInteraction.diagram.edit.parts.ProcessEditPart.VISUAL_ID:
			return getProcess_2010Text(view);
		case SWSInteraction.diagram.edit.parts.OutputEditPart.VISUAL_ID:
			return getOutput_3002Text(view);
		case SWSInteraction.diagram.edit.parts.SS_AgreementPlanNegotiatesEditPart.VISUAL_ID:
			return getSS_AgreementPlanNegotiates_4014Text(view);
		case SWSInteraction.diagram.edit.parts.SSMatchmakerAgentEditPart.VISUAL_ID:
			return getSSMatchmakerAgent_2018Text(view);
		case SWSInteraction.diagram.edit.parts.EffectEditPart.VISUAL_ID:
			return getEffect_3004Text(view);
		case SWSInteraction.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			return getRole_2001Text(view);
		case SWSInteraction.diagram.edit.parts.GroundingSupportsEditPart.VISUAL_ID:
			return getGroundingSupports_4030Text(view);
		case SWSInteraction.diagram.edit.parts.RoleInteracts_withEditPart.VISUAL_ID:
			return getRoleInteracts_with_4033Text(view);
		case SWSInteraction.diagram.edit.parts.SS_AgreementPlanEditPart.VISUAL_ID:
			return getSS_AgreementPlan_2015Text(view);
		case SWSInteraction.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID:
			return getSemanticWebAgentPlays_4010Text(view);
		case SWSInteraction.diagram.edit.parts.Effect2EditPart.VISUAL_ID:
			return getEffect_3008Text(view);
		case SWSInteraction.diagram.edit.parts.Input2EditPart.VISUAL_ID:
			return getInput_3005Text(view);
		case SWSInteraction.diagram.edit.parts.GroundingEditPart.VISUAL_ID:
			return getGrounding_2008Text(view);
		case SWSInteraction.diagram.edit.parts.SS_RegisterPlanEditPart.VISUAL_ID:
			return getSS_RegisterPlan_2016Text(view);
		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanExecutesEditPart.VISUAL_ID:
			return getSS_ExecutorPlanExecutes_4026Text(view);
		case SWSInteraction.diagram.edit.parts.SSMatchmakerAgentAppliesSS_RegPlanEditPart.VISUAL_ID:
			return getSSMatchmakerAgentAppliesSS_RegPlan_4031Text(view);
		case SWSInteraction.diagram.edit.parts.SS_FinderPlanInteracts_withEditPart.VISUAL_ID:
			return getSS_FinderPlanInteracts_with_4012Text(view);
		case SWSInteraction.diagram.edit.parts.SS_FinderPlanEditPart.VISUAL_ID:
			return getSS_FinderPlan_2014Text(view);
		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanEditPart.VISUAL_ID:
			return getSS_ExecutorPlan_2017Text(view);
		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanUsesEditPart.VISUAL_ID:
			return getSS_ExecutorPlanUses_4016Text(view);
		case SWSInteraction.diagram.edit.parts.SemanticWebAgentAppliesEditPart.VISUAL_ID:
			return getSemanticWebAgentApplies_4008Text(view);
		case SWSInteraction.diagram.edit.parts.PreconditionEditPart.VISUAL_ID:
			return getPrecondition_3003Text(view);
		case SWSInteraction.diagram.edit.parts.SS_FinderPlanDiscoversEditPart.VISUAL_ID:
			return getSS_FinderPlanDiscovers_4013Text(view);
		case SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.VISUAL_ID:
			return getSWSInteractionViewpoint_1000Text(view);
		case SWSInteraction.diagram.edit.parts.InputEditPart.VISUAL_ID:
			return getInput_3001Text(view);
		case SWSInteraction.diagram.edit.parts.WebServiceEditPart.VISUAL_ID:
			return getWebService_3011Text(view);
		case SWSInteraction.diagram.edit.parts.SSMatchmakerAgentPlaysRegRoleEditPart.VISUAL_ID:
			return getSSMatchmakerAgentPlaysRegRole_4032Text(view);
		case SWSInteraction.diagram.edit.parts.InterfacePresentsEditPart.VISUAL_ID:
			return getInterfacePresents_4027Text(view);
		case SWSInteraction.diagram.edit.parts.Precondition2EditPart.VISUAL_ID:
			return getPrecondition_3007Text(view);
		case SWSInteraction.diagram.edit.parts.Output2EditPart.VISUAL_ID:
			return getOutput_3006Text(view);
		case SWSInteraction.diagram.edit.parts.GroundingCallsEditPart.VISUAL_ID:
			return getGroundingCalls_4019Text(view);
		case SWSInteraction.diagram.edit.parts.ProcessDescribed_byEditPart.VISUAL_ID:
			return getProcessDescribed_by_4028Text(view);
		case SWSInteraction.diagram.edit.parts.InterfaceEditPart.VISUAL_ID:
			return getInterface_2005Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getSemanticWebAgent_2021Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SemanticWebAgent_2021,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5031); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSS_RegisterPlanAdvertises_4009Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_RegisterPlanAdvertises_4009,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabelEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSWS_2004Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SWS_2004,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.SWSNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getProcess_2010Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Process_2010,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.ProcessNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5011); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getOutput_3002Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Output_3002,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.OutputNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5020); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSS_AgreementPlanNegotiates_4014Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_AgreementPlanNegotiates_4014,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel6EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6008); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSSMatchmakerAgent_2018Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SSMatchmakerAgent_2018,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.SSMatchmakerAgentNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5019); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getEffect_3004Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Effect_3004,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.EffectNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5026); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRole_2001Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Role_2001,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.RoleNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getGroundingSupports_4030Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getRoleInteracts_with_4033Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.RoleInteracts_with_4033,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel13EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6019); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSS_AgreementPlan_2015Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_AgreementPlan_2015,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.SS_AgreementPlanNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5016); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSemanticWebAgentPlays_4010Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SemanticWebAgentPlays_4010,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel3EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getEffect_3008Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Effect_3008,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.EffectName2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5027); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getInput_3005Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Input_3005,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.InputName2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5022); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getGrounding_2008Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Grounding_2008,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.GroundingNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5009); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSS_RegisterPlan_2016Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_RegisterPlan_2016,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.SS_RegisterPlanNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5017); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSS_ExecutorPlanExecutes_4026Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_ExecutorPlanExecutes_4026,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel7EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6015); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSSMatchmakerAgentAppliesSS_RegPlan_4031Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SSMatchmakerAgentAppliesSS_RegPlan_4031,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel12EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6018); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSS_FinderPlanInteracts_with_4012Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_FinderPlanInteracts_with_4012,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel4EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSS_FinderPlan_2014Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_FinderPlan_2014,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.SS_FinderPlanNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5015); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSS_ExecutorPlan_2017Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_ExecutorPlan_2017,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.SS_ExecutorPlanNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5018); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSS_ExecutorPlanUses_4016Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_ExecutorPlanUses_4016,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel8EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6010); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSemanticWebAgentApplies_4008Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SemanticWebAgentApplies_4008,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getPrecondition_3003Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Precondition_3003,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.PreconditionNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5021); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSS_FinderPlanDiscovers_4013Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_FinderPlanDiscovers_4013,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel5EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSWSInteractionViewpoint_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getInput_3001Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Input_3001,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.InputNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getWebService_3011Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.WebService_3011,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WebServiceNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5032); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSSMatchmakerAgentPlaysRegRole_4032Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getInterfacePresents_4027Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.InterfacePresents_4027,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel9EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6016); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getPrecondition_3007Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Precondition_3007,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.PreconditionName2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5024); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getOutput_3006Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Output_3006,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.OutputName2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5023); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getGroundingCalls_4019Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.GroundingCalls_4019,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel11EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6013); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getProcessDescribed_by_4028Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.ProcessDescribed_by_4028,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.WrappingLabel10EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 6017); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getInterface_2005Text(View view) {
		IParser parser = SWSInteraction.diagram.providers.SWSInteractionParserProvider
				.getParser(
						SWSInteraction.diagram.providers.SWSInteractionElementTypes.Interface_2005,
						view.getElement() != null ? view.getElement() : view,
						SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
								.getType(SWSInteraction.diagram.edit.parts.InterfaceNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
					.getInstance().logError(
							"Parser was not found for label " + 5006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.MODEL_ID
				.equals(SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
						.getModelID(view));
	}

}
