package SWSInteraction.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class SWSInteractionVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "SWSInteractionVP.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.MODEL_ID
					.equals(view.getType())) {
				return SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				SWSInteraction.diagram.part.SWSInteractionDiagramEditorPlugin
						.getInstance().logError(
								"Unable to parse view type as a visualID number: "
										+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (SWSInteraction.SWSInteractionPackage.eINSTANCE
				.getSWSInteractionViewpoint().isSuperTypeOf(
						domainElement.eClass())
				&& isDiagram((SWSInteraction.SWSInteractionViewpoint) domainElement)) {
			return SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
				.getModelID(containerView);
		if (!SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.VISUAL_ID:
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getRole()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.RoleEditPart.VISUAL_ID;
			}
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getSWS()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.SWSEditPart.VISUAL_ID;
			}
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getInterface()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.InterfaceEditPart.VISUAL_ID;
			}
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE
					.getSemanticWebAgent()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID;
			}
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getGrounding()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.GroundingEditPart.VISUAL_ID;
			}
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE
					.getSS_FinderPlan().isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.SS_FinderPlanEditPart.VISUAL_ID;
			}
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getProcess()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.ProcessEditPart.VISUAL_ID;
			}
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE
					.getSS_AgreementPlan()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.SS_AgreementPlanEditPart.VISUAL_ID;
			}
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE
					.getSS_RegisterPlan().isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.SS_RegisterPlanEditPart.VISUAL_ID;
			}
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE
					.getSS_ExecutorPlan().isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.SS_ExecutorPlanEditPart.VISUAL_ID;
			}
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE
					.getSSMatchmakerAgent().isSuperTypeOf(
							domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.SSMatchmakerAgentEditPart.VISUAL_ID;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SWSSWSWebServiceCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getWebService()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.WebServiceEditPart.VISUAL_ID;
			}
			break;
		case SWSInteraction.diagram.edit.parts.InterfaceInterfaceInputCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getInput()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.InputEditPart.VISUAL_ID;
			}
			break;
		case SWSInteraction.diagram.edit.parts.InterfaceInterfaceOutputCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getOutput()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.OutputEditPart.VISUAL_ID;
			}
			break;
		case SWSInteraction.diagram.edit.parts.InterfaceInterfacePreconditionCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE
					.getPrecondition().isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.PreconditionEditPart.VISUAL_ID;
			}
			break;
		case SWSInteraction.diagram.edit.parts.InterfaceInterfaceEffectCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getEffect()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.EffectEditPart.VISUAL_ID;
			}
			break;
		case SWSInteraction.diagram.edit.parts.ProcessProcessInputCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getInput()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.Input2EditPart.VISUAL_ID;
			}
			break;
		case SWSInteraction.diagram.edit.parts.ProcessProcessOutputCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getOutput()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.Output2EditPart.VISUAL_ID;
			}
			break;
		case SWSInteraction.diagram.edit.parts.ProcessProcessPreconditionCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE
					.getPrecondition().isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.Precondition2EditPart.VISUAL_ID;
			}
			break;
		case SWSInteraction.diagram.edit.parts.ProcessProcessEffectCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.SWSInteractionPackage.eINSTANCE.getEffect()
					.isSuperTypeOf(domainElement.eClass())) {
				return SWSInteraction.diagram.edit.parts.Effect2EditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
				.getModelID(containerView);
		if (!SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.RoleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.SWSEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.InterfaceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.GroundingEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.SS_FinderPlanEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.ProcessEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.SS_AgreementPlanEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.SS_RegisterPlanEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.SS_ExecutorPlanEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.SSMatchmakerAgentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.RoleNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SWSEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.SWSNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.SWSSWSWebServiceCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.InterfaceEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.InterfaceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.InterfaceInterfaceInputCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.InterfaceInterfaceOutputCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.InterfaceInterfacePreconditionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.InterfaceInterfaceEffectCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.SemanticWebAgentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.GroundingEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.GroundingNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SS_FinderPlanEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.SS_FinderPlanNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.ProcessEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.ProcessNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.ProcessProcessInputCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.ProcessProcessOutputCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.ProcessProcessPreconditionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SWSInteraction.diagram.edit.parts.ProcessProcessEffectCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SS_AgreementPlanEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.SS_AgreementPlanNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SS_RegisterPlanEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.SS_RegisterPlanNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.SS_ExecutorPlanNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SSMatchmakerAgentEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.SSMatchmakerAgentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.WebServiceEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WebServiceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.InputEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.InputNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.OutputEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.OutputNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.PreconditionEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.PreconditionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.EffectEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.EffectNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.Input2EditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.InputName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.Output2EditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.OutputName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.Precondition2EditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.PreconditionName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.Effect2EditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.EffectName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SWSSWSWebServiceCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WebServiceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.InterfaceInterfaceInputCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.InputEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.InterfaceInterfaceOutputCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.OutputEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.InterfaceInterfacePreconditionCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.PreconditionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.InterfaceInterfaceEffectCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.EffectEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.ProcessProcessInputCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.Input2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.ProcessProcessOutputCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.Output2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.ProcessProcessPreconditionCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.Precondition2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.ProcessProcessEffectCompartmentEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.Effect2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SS_RegisterPlanAdvertisesEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SemanticWebAgentAppliesEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SS_FinderPlanInteracts_withEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel4EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SS_FinderPlanDiscoversEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel5EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SS_AgreementPlanNegotiatesEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel6EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanExecutesEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel7EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanUsesEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel8EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.InterfacePresentsEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel9EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.ProcessDescribed_byEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel10EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.GroundingCallsEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel11EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.SSMatchmakerAgentAppliesSS_RegPlanEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel12EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SWSInteraction.diagram.edit.parts.RoleInteracts_withEditPart.VISUAL_ID:
			if (SWSInteraction.diagram.edit.parts.WrappingLabel13EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(
			SWSInteraction.SWSInteractionViewpoint element) {
		return true;
	}

}
