/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SWSInteraction.impl;

import SWSInteraction.Effect;
import SWSInteraction.Grounding;
import SWSInteraction.Input;
import SWSInteraction.Interface;
import SWSInteraction.ODM_OWLClass;
import SWSInteraction.Output;
import SWSInteraction.Plan;
import SWSInteraction.Precondition;
import SWSInteraction.RegistrationRole;
import SWSInteraction.Role;
import SWSInteraction.SSMatchmakerAgent;
import SWSInteraction.SS_AgreementPlan;
import SWSInteraction.SS_ExecutorPlan;
import SWSInteraction.SS_FinderPlan;
import SWSInteraction.SS_RegisterPlan;
import SWSInteraction.SWS;
import SWSInteraction.SWSInteractionFactory;
import SWSInteraction.SWSInteractionPackage;
import SWSInteraction.SWSInteractionViewpoint;
import SWSInteraction.SemanticWebAgent;
import SWSInteraction.Service;
import SWSInteraction.WebService;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SWSInteractionFactoryImpl extends EFactoryImpl implements SWSInteractionFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SWSInteractionFactory init() {
		try {
			SWSInteractionFactory theSWSInteractionFactory = (SWSInteractionFactory)EPackage.Registry.INSTANCE.getEFactory("/viewPointsFull/model/SWSInteraction.ecore"); 
			if (theSWSInteractionFactory != null) {
				return theSWSInteractionFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new SWSInteractionFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SWSInteractionFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case SWSInteractionPackage.PLAN: return createPlan();
			case SWSInteractionPackage.SEMANTIC_WEB_AGENT: return createSemanticWebAgent();
			case SWSInteractionPackage.ROLE: return createRole();
			case SWSInteractionPackage.SS_MATCHMAKER_AGENT: return createSSMatchmakerAgent();
			case SWSInteractionPackage.SS_REGISTER_PLAN: return createSS_RegisterPlan();
			case SWSInteractionPackage.SS_FINDER_PLAN: return createSS_FinderPlan();
			case SWSInteractionPackage.SS_AGREEMENT_PLAN: return createSS_AgreementPlan();
			case SWSInteractionPackage.SS_EXECUTOR_PLAN: return createSS_ExecutorPlan();
			case SWSInteractionPackage.SWS: return createSWS();
			case SWSInteractionPackage.INTERFACE: return createInterface();
			case SWSInteractionPackage.PROCESS: return createProcess();
			case SWSInteractionPackage.GROUNDING: return createGrounding();
			case SWSInteractionPackage.INPUT: return createInput();
			case SWSInteractionPackage.OUTPUT: return createOutput();
			case SWSInteractionPackage.PRECONDITION: return createPrecondition();
			case SWSInteractionPackage.EFFECT: return createEffect();
			case SWSInteractionPackage.WEB_SERVICE: return createWebService();
			case SWSInteractionPackage.SERVICE: return createService();
			case SWSInteractionPackage.ODM_OWL_CLASS: return createODM_OWLClass();
			case SWSInteractionPackage.REGISTRATION_ROLE: return createRegistrationRole();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT: return createSWSInteractionViewpoint();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Plan createPlan() {
		PlanImpl plan = new PlanImpl();
		return plan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SemanticWebAgent createSemanticWebAgent() {
		SemanticWebAgentImpl semanticWebAgent = new SemanticWebAgentImpl();
		return semanticWebAgent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Role createRole() {
		RoleImpl role = new RoleImpl();
		return role;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SSMatchmakerAgent createSSMatchmakerAgent() {
		SSMatchmakerAgentImpl ssMatchmakerAgent = new SSMatchmakerAgentImpl();
		return ssMatchmakerAgent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SS_RegisterPlan createSS_RegisterPlan() {
		SS_RegisterPlanImpl sS_RegisterPlan = new SS_RegisterPlanImpl();
		return sS_RegisterPlan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SS_FinderPlan createSS_FinderPlan() {
		SS_FinderPlanImpl sS_FinderPlan = new SS_FinderPlanImpl();
		return sS_FinderPlan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SS_AgreementPlan createSS_AgreementPlan() {
		SS_AgreementPlanImpl sS_AgreementPlan = new SS_AgreementPlanImpl();
		return sS_AgreementPlan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SS_ExecutorPlan createSS_ExecutorPlan() {
		SS_ExecutorPlanImpl sS_ExecutorPlan = new SS_ExecutorPlanImpl();
		return sS_ExecutorPlan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SWS createSWS() {
		SWSImpl sws = new SWSImpl();
		return sws;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Interface createInterface() {
		InterfaceImpl interface_ = new InterfaceImpl();
		return interface_;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SWSInteraction.Process createProcess() {
		ProcessImpl process = new ProcessImpl();
		return process;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Grounding createGrounding() {
		GroundingImpl grounding = new GroundingImpl();
		return grounding;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Input createInput() {
		InputImpl input = new InputImpl();
		return input;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Output createOutput() {
		OutputImpl output = new OutputImpl();
		return output;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Precondition createPrecondition() {
		PreconditionImpl precondition = new PreconditionImpl();
		return precondition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Effect createEffect() {
		EffectImpl effect = new EffectImpl();
		return effect;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WebService createWebService() {
		WebServiceImpl webService = new WebServiceImpl();
		return webService;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Service createService() {
		ServiceImpl service = new ServiceImpl();
		return service;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ODM_OWLClass createODM_OWLClass() {
		ODM_OWLClassImpl odM_OWLClass = new ODM_OWLClassImpl();
		return odM_OWLClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RegistrationRole createRegistrationRole() {
		RegistrationRoleImpl registrationRole = new RegistrationRoleImpl();
		return registrationRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SWSInteractionViewpoint createSWSInteractionViewpoint() {
		SWSInteractionViewpointImpl swsInteractionViewpoint = new SWSInteractionViewpointImpl();
		return swsInteractionViewpoint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SWSInteractionPackage getSWSInteractionPackage() {
		return (SWSInteractionPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static SWSInteractionPackage getPackage() {
		return SWSInteractionPackage.eINSTANCE;
	}

} //SWSInteractionFactoryImpl
