/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SWSInteraction.util;

import SWSInteraction.Effect;
import SWSInteraction.Grounding;
import SWSInteraction.Input;
import SWSInteraction.Interface;
import SWSInteraction.ODM_OWLClass;
import SWSInteraction.Output;
import SWSInteraction.Plan;
import SWSInteraction.Precondition;
import SWSInteraction.RegistrationRole;
import SWSInteraction.Role;
import SWSInteraction.SSMatchmakerAgent;
import SWSInteraction.SS_AgreementPlan;
import SWSInteraction.SS_ExecutorPlan;
import SWSInteraction.SS_FinderPlan;
import SWSInteraction.SS_RegisterPlan;
import SWSInteraction.SWS;
import SWSInteraction.SWSInteractionPackage;
import SWSInteraction.SWSInteractionViewpoint;
import SWSInteraction.SemanticWebAgent;
import SWSInteraction.Service;
import SWSInteraction.WebService;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see SWSInteraction.SWSInteractionPackage
 * @generated
 */
public class SWSInteractionAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static SWSInteractionPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SWSInteractionAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = SWSInteractionPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SWSInteractionSwitch<Adapter> modelSwitch =
		new SWSInteractionSwitch<Adapter>() {
			@Override
			public Adapter casePlan(Plan object) {
				return createPlanAdapter();
			}
			@Override
			public Adapter caseSemanticWebAgent(SemanticWebAgent object) {
				return createSemanticWebAgentAdapter();
			}
			@Override
			public Adapter caseRole(Role object) {
				return createRoleAdapter();
			}
			@Override
			public Adapter caseSSMatchmakerAgent(SSMatchmakerAgent object) {
				return createSSMatchmakerAgentAdapter();
			}
			@Override
			public Adapter caseSS_RegisterPlan(SS_RegisterPlan object) {
				return createSS_RegisterPlanAdapter();
			}
			@Override
			public Adapter caseSS_FinderPlan(SS_FinderPlan object) {
				return createSS_FinderPlanAdapter();
			}
			@Override
			public Adapter caseSS_AgreementPlan(SS_AgreementPlan object) {
				return createSS_AgreementPlanAdapter();
			}
			@Override
			public Adapter caseSS_ExecutorPlan(SS_ExecutorPlan object) {
				return createSS_ExecutorPlanAdapter();
			}
			@Override
			public Adapter caseSWS(SWS object) {
				return createSWSAdapter();
			}
			@Override
			public Adapter caseInterface(Interface object) {
				return createInterfaceAdapter();
			}
			@Override
			public Adapter caseProcess(SWSInteraction.Process object) {
				return createProcessAdapter();
			}
			@Override
			public Adapter caseGrounding(Grounding object) {
				return createGroundingAdapter();
			}
			@Override
			public Adapter caseInput(Input object) {
				return createInputAdapter();
			}
			@Override
			public Adapter caseOutput(Output object) {
				return createOutputAdapter();
			}
			@Override
			public Adapter casePrecondition(Precondition object) {
				return createPreconditionAdapter();
			}
			@Override
			public Adapter caseEffect(Effect object) {
				return createEffectAdapter();
			}
			@Override
			public Adapter caseWebService(WebService object) {
				return createWebServiceAdapter();
			}
			@Override
			public Adapter caseService(Service object) {
				return createServiceAdapter();
			}
			@Override
			public Adapter caseODM_OWLClass(ODM_OWLClass object) {
				return createODM_OWLClassAdapter();
			}
			@Override
			public Adapter caseRegistrationRole(RegistrationRole object) {
				return createRegistrationRoleAdapter();
			}
			@Override
			public Adapter caseSWSInteractionViewpoint(SWSInteractionViewpoint object) {
				return createSWSInteractionViewpointAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.Plan <em>Plan</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.Plan
	 * @generated
	 */
	public Adapter createPlanAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.SemanticWebAgent <em>Semantic Web Agent</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.SemanticWebAgent
	 * @generated
	 */
	public Adapter createSemanticWebAgentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.Role <em>Role</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.Role
	 * @generated
	 */
	public Adapter createRoleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.SSMatchmakerAgent <em>SS Matchmaker Agent</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.SSMatchmakerAgent
	 * @generated
	 */
	public Adapter createSSMatchmakerAgentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.SS_RegisterPlan <em>SS Register Plan</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.SS_RegisterPlan
	 * @generated
	 */
	public Adapter createSS_RegisterPlanAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.SS_FinderPlan <em>SS Finder Plan</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.SS_FinderPlan
	 * @generated
	 */
	public Adapter createSS_FinderPlanAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.SS_AgreementPlan <em>SS Agreement Plan</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.SS_AgreementPlan
	 * @generated
	 */
	public Adapter createSS_AgreementPlanAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.SS_ExecutorPlan <em>SS Executor Plan</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.SS_ExecutorPlan
	 * @generated
	 */
	public Adapter createSS_ExecutorPlanAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.SWS <em>SWS</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.SWS
	 * @generated
	 */
	public Adapter createSWSAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.Interface <em>Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.Interface
	 * @generated
	 */
	public Adapter createInterfaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.Process <em>Process</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.Process
	 * @generated
	 */
	public Adapter createProcessAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.Grounding <em>Grounding</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.Grounding
	 * @generated
	 */
	public Adapter createGroundingAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.Input <em>Input</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.Input
	 * @generated
	 */
	public Adapter createInputAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.Output <em>Output</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.Output
	 * @generated
	 */
	public Adapter createOutputAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.Precondition <em>Precondition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.Precondition
	 * @generated
	 */
	public Adapter createPreconditionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.Effect <em>Effect</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.Effect
	 * @generated
	 */
	public Adapter createEffectAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.WebService <em>Web Service</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.WebService
	 * @generated
	 */
	public Adapter createWebServiceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.Service <em>Service</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.Service
	 * @generated
	 */
	public Adapter createServiceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.ODM_OWLClass <em>ODM OWL Class</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.ODM_OWLClass
	 * @generated
	 */
	public Adapter createODM_OWLClassAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.RegistrationRole <em>Registration Role</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.RegistrationRole
	 * @generated
	 */
	public Adapter createRegistrationRoleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SWSInteraction.SWSInteractionViewpoint <em>Viewpoint</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SWSInteraction.SWSInteractionViewpoint
	 * @generated
	 */
	public Adapter createSWSInteractionViewpointAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //SWSInteractionAdapterFactory
